var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw new Error('Dynamic require of "' + x + '" is not supported');
});
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};

// src/parser/SchemaParser.ts
import changeCase2 from "change-case";

// src/types/core.ts
var FileType = /* @__PURE__ */ ((FileType2) => {
  FileType2["CSS"] = "css";
  FileType2["SCSS"] = "scss";
  FileType2["LESS"] = "less";
  FileType2["HTML"] = "html";
  FileType2["JS"] = "js";
  FileType2["MJS"] = "mjs";
  FileType2["JSX"] = "jsx";
  FileType2["TS"] = "ts";
  FileType2["MTS"] = "mts";
  FileType2["TSX"] = "tsx";
  FileType2["JSON"] = "json";
  FileType2["MD"] = "md";
  FileType2["VUE"] = "vue";
  return FileType2;
})(FileType || {});
var ChunkType = /* @__PURE__ */ ((ChunkType2) => {
  ChunkType2["AST"] = "ast";
  ChunkType2["STRING"] = "string";
  ChunkType2["JSON"] = "json";
  return ChunkType2;
})(ChunkType || {});
var PluginType = /* @__PURE__ */ ((PluginType2) => {
  PluginType2["COMPONENT"] = "component";
  PluginType2["UTILS"] = "utils";
  PluginType2["I18N"] = "i18n";
  return PluginType2;
})(PluginType || {});

// src/types/deps.ts
var InternalDependencyType = /* @__PURE__ */ ((InternalDependencyType2) => {
  InternalDependencyType2["PAGE"] = "pages";
  InternalDependencyType2["BLOCK"] = "components";
  InternalDependencyType2["COMPONENT"] = "components";
  InternalDependencyType2["UTILS"] = "utils";
  return InternalDependencyType2;
})(InternalDependencyType || {});
var DependencyType = /* @__PURE__ */ ((DependencyType2) => {
  DependencyType2["External"] = "External";
  DependencyType2["Internal"] = "Internal";
  return DependencyType2;
})(DependencyType || {});

// src/types/error.ts
var CodeGeneratorError = class extends Error {
  constructor(message, detail) {
    super(message);
    __publicField(this, "detail");
    this.name = this.constructor.name;
    this.detail = detail;
    Object.setPrototypeOf(this, new.target.prototype);
  }
};
var ComponentValidationError = class extends CodeGeneratorError {
};
var CompatibilityError = class extends CodeGeneratorError {
};
var PublisherError = class extends CodeGeneratorError {
};

// src/types/jsx.ts
var PIECE_TYPE = /* @__PURE__ */ ((PIECE_TYPE2) => {
  PIECE_TYPE2["BEFORE"] = "NodeCodePieceBefore";
  PIECE_TYPE2["TAG"] = "NodeCodePieceTag";
  PIECE_TYPE2["ATTR"] = "NodeCodePieceAttr";
  PIECE_TYPE2["CHILDREN"] = "NodeCodePieceChildren";
  PIECE_TYPE2["AFTER"] = "NodeCodePieceAfter";
  return PIECE_TYPE2;
})(PIECE_TYPE || {});

// src/const/index.ts
var const_exports = {};
__export(const_exports, {
  BUILTIN_SLOT_NAMES: () => BUILTIN_SLOT_NAMES,
  CLASS_DEFINE_CHUNK_NAME: () => CLASS_DEFINE_CHUNK_NAME,
  COMMON_CHUNK_NAME: () => COMMON_CHUNK_NAME,
  COMMON_SUB_MODULE_NAME: () => COMMON_SUB_MODULE_NAME,
  CONTAINER_TYPE: () => CONTAINER_TYPE,
  DEFAULT_LINK_AFTER: () => DEFAULT_LINK_AFTER,
  FILE_TYPE_FAMILY: () => FILE_TYPE_FAMILY,
  NATIVE_ELE_PKG: () => NATIVE_ELE_PKG,
  SUPPORT_SCHEMA_VERSION_LIST: () => SUPPORT_SCHEMA_VERSION_LIST,
  TEMPLATE_DEFINE_CHUNK_NAME: () => TEMPLATE_DEFINE_CHUNK_NAME,
  VUE_DEFAULT_LINK_AFTER: () => VUE_DEFAULT_LINK_AFTER,
  VUE_MODULE_NAME: () => VUE_MODULE_NAME,
  isBuiltinSlotName: () => isBuiltinSlotName
});

// src/const/file.ts
var FILE_TYPE_FAMILY = [["tsx" /* TSX */, "ts" /* TS */, "jsx" /* JSX */, "js" /* JS */]];

// src/const/generator.ts
var COMMON_CHUNK_NAME = {
  ExternalDepsImport: "CommonExternalDependencyImport",
  InternalDepsImport: "CommonInternalDependencyImport",
  ImportAliasDefine: "CommonImportAliasDefine",
  FileVarDefine: "CommonFileScopeVarDefine",
  FileUtilDefine: "CommonFileScopeMethodDefine",
  FileMainContent: "CommonFileMainContent",
  FileExport: "CommonFileExport",
  StyleDepsImport: "CommonStyleDepsImport",
  StyleCssContent: "CommonStyleCssContent",
  HtmlContent: "CommonHtmlContent",
  CustomContent: "CommonCustomContent"
};
var CLASS_DEFINE_CHUNK_NAME = {
  Start: "CommonClassDefineStart",
  ConstructorStart: "CommonClassDefineConstructorStart",
  ConstructorContent: "CommonClassDefineConstructorContent",
  ConstructorEnd: "CommonClassDefineConstructorEnd",
  StaticVar: "CommonClassDefineStaticVar",
  StaticMethod: "CommonClassDefineStaticMethod",
  InsVar: "CommonClassDefineInsVar",
  InsVarMethod: "CommonClassDefineInsVarMethod",
  InsMethod: "CommonClassDefineInsMethod",
  InsPrivateMethod: "CommonClassDefineInsPrivateMethod",
  End: "CommonClassDefineEnd"
};
var TEMPLATE_DEFINE_CHUNK_NAME = {
  TemplateStart: "CommonTemplateDefineStart",
  TemplateDom: "CommonTemplateDefineDom",
  TemplateEnd: "CommonTemplateDefineEnd",
  ScriptStart: "CommonScriptDefineStart",
  ExternalDepsImport: "CommonExternalDependencyImport",
  InternalDepsImport: "CommonInternalDependencyImport",
  ConstVar: "CommonScriptDefineConstVar",
  LetVar: "CommonScriptDefineLetVar",
  DataSourceMapStart: "CommonScriptDefineDataSourceMapStart",
  DataSourceMapContent: "CommonScriptDefineDataSourceMapContent",
  DataSourceMapEnd: "CommonScriptDefineDataSourceMapEnd",
  OnMountedStart: "CommonScriptDefineOnMountedStart",
  OnMountedContent: "CommonScriptDefineOnMountedContent",
  OnMountedEnd: "CommonScriptDefineOnMountedEnd",
  UnMountedStart: "CommonScriptDefineUnMountedStart",
  UnMountedContent: "CommonScriptDefineUnMountedContent",
  UnMountedEnd: "CommonScriptDefineUnMountedEnd",
  Method: "CommonScriptDefineMethod",
  ScriptEnd: "CommonScriptDefineEnd",
  CssStyleStart: "CommonCssStyleDefineStart",
  CssStyleImport: "CommonCssStyleDefineImport",
  CssStyleEnd: "CommonCssStyleDefineEnd"
};
var DEFAULT_LINK_AFTER = {
  [COMMON_CHUNK_NAME.ExternalDepsImport]: [],
  [COMMON_CHUNK_NAME.InternalDepsImport]: [COMMON_CHUNK_NAME.ExternalDepsImport],
  [COMMON_CHUNK_NAME.ImportAliasDefine]: [
    COMMON_CHUNK_NAME.ExternalDepsImport,
    COMMON_CHUNK_NAME.InternalDepsImport
  ],
  [COMMON_CHUNK_NAME.FileVarDefine]: [
    COMMON_CHUNK_NAME.ExternalDepsImport,
    COMMON_CHUNK_NAME.InternalDepsImport,
    COMMON_CHUNK_NAME.ImportAliasDefine
  ],
  [COMMON_CHUNK_NAME.FileUtilDefine]: [
    COMMON_CHUNK_NAME.ExternalDepsImport,
    COMMON_CHUNK_NAME.InternalDepsImport,
    COMMON_CHUNK_NAME.ImportAliasDefine,
    COMMON_CHUNK_NAME.FileVarDefine
  ],
  [CLASS_DEFINE_CHUNK_NAME.Start]: [
    COMMON_CHUNK_NAME.ExternalDepsImport,
    COMMON_CHUNK_NAME.InternalDepsImport,
    COMMON_CHUNK_NAME.ImportAliasDefine,
    COMMON_CHUNK_NAME.FileVarDefine,
    COMMON_CHUNK_NAME.FileUtilDefine
  ],
  [CLASS_DEFINE_CHUNK_NAME.ConstructorStart]: [
    CLASS_DEFINE_CHUNK_NAME.Start,
    CLASS_DEFINE_CHUNK_NAME.StaticVar,
    CLASS_DEFINE_CHUNK_NAME.StaticMethod,
    CLASS_DEFINE_CHUNK_NAME.InsVar,
    CLASS_DEFINE_CHUNK_NAME.InsVarMethod
  ],
  [CLASS_DEFINE_CHUNK_NAME.ConstructorContent]: [CLASS_DEFINE_CHUNK_NAME.ConstructorStart],
  [CLASS_DEFINE_CHUNK_NAME.ConstructorEnd]: [
    CLASS_DEFINE_CHUNK_NAME.ConstructorStart,
    CLASS_DEFINE_CHUNK_NAME.ConstructorContent
  ],
  [CLASS_DEFINE_CHUNK_NAME.StaticVar]: [CLASS_DEFINE_CHUNK_NAME.Start],
  [CLASS_DEFINE_CHUNK_NAME.StaticMethod]: [
    CLASS_DEFINE_CHUNK_NAME.Start,
    CLASS_DEFINE_CHUNK_NAME.StaticVar
  ],
  [CLASS_DEFINE_CHUNK_NAME.InsVar]: [
    CLASS_DEFINE_CHUNK_NAME.Start,
    CLASS_DEFINE_CHUNK_NAME.StaticVar,
    CLASS_DEFINE_CHUNK_NAME.StaticMethod
  ],
  [CLASS_DEFINE_CHUNK_NAME.InsVarMethod]: [
    CLASS_DEFINE_CHUNK_NAME.Start,
    CLASS_DEFINE_CHUNK_NAME.StaticVar,
    CLASS_DEFINE_CHUNK_NAME.StaticMethod,
    CLASS_DEFINE_CHUNK_NAME.InsVar
  ],
  [CLASS_DEFINE_CHUNK_NAME.InsMethod]: [
    CLASS_DEFINE_CHUNK_NAME.Start,
    CLASS_DEFINE_CHUNK_NAME.StaticVar,
    CLASS_DEFINE_CHUNK_NAME.StaticMethod,
    CLASS_DEFINE_CHUNK_NAME.InsVar,
    CLASS_DEFINE_CHUNK_NAME.InsVarMethod,
    CLASS_DEFINE_CHUNK_NAME.ConstructorEnd
  ],
  [CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod]: [
    CLASS_DEFINE_CHUNK_NAME.Start,
    CLASS_DEFINE_CHUNK_NAME.StaticVar,
    CLASS_DEFINE_CHUNK_NAME.StaticMethod,
    CLASS_DEFINE_CHUNK_NAME.InsVar,
    CLASS_DEFINE_CHUNK_NAME.InsVarMethod,
    CLASS_DEFINE_CHUNK_NAME.InsMethod,
    CLASS_DEFINE_CHUNK_NAME.ConstructorEnd
  ],
  [CLASS_DEFINE_CHUNK_NAME.End]: [
    CLASS_DEFINE_CHUNK_NAME.Start,
    CLASS_DEFINE_CHUNK_NAME.StaticVar,
    CLASS_DEFINE_CHUNK_NAME.StaticMethod,
    CLASS_DEFINE_CHUNK_NAME.InsVar,
    CLASS_DEFINE_CHUNK_NAME.InsVarMethod,
    CLASS_DEFINE_CHUNK_NAME.InsMethod,
    CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
    CLASS_DEFINE_CHUNK_NAME.ConstructorEnd
  ],
  [COMMON_CHUNK_NAME.FileMainContent]: [
    COMMON_CHUNK_NAME.ExternalDepsImport,
    COMMON_CHUNK_NAME.InternalDepsImport,
    COMMON_CHUNK_NAME.ImportAliasDefine,
    COMMON_CHUNK_NAME.FileVarDefine,
    COMMON_CHUNK_NAME.FileUtilDefine,
    CLASS_DEFINE_CHUNK_NAME.End
  ],
  [COMMON_CHUNK_NAME.FileExport]: [
    COMMON_CHUNK_NAME.ExternalDepsImport,
    COMMON_CHUNK_NAME.InternalDepsImport,
    COMMON_CHUNK_NAME.ImportAliasDefine,
    COMMON_CHUNK_NAME.FileVarDefine,
    COMMON_CHUNK_NAME.FileUtilDefine,
    CLASS_DEFINE_CHUNK_NAME.End,
    COMMON_CHUNK_NAME.FileMainContent
  ],
  [COMMON_CHUNK_NAME.StyleDepsImport]: [],
  [COMMON_CHUNK_NAME.StyleCssContent]: [COMMON_CHUNK_NAME.StyleDepsImport],
  [COMMON_CHUNK_NAME.HtmlContent]: []
};
var VUE_DEFAULT_LINK_AFTER = {
  [TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart]: [],
  [TEMPLATE_DEFINE_CHUNK_NAME.TemplateDom]: [TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart],
  [TEMPLATE_DEFINE_CHUNK_NAME.TemplateEnd]: [
    TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart,
    TEMPLATE_DEFINE_CHUNK_NAME.TemplateDom
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart]: [
    TEMPLATE_DEFINE_CHUNK_NAME.TemplateEnd
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport]: [
    TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport]: [
    TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart,
    TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.ConstVar]: [
    TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.LetVar]: [TEMPLATE_DEFINE_CHUNK_NAME.ConstVar],
  [TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapStart]: [
    TEMPLATE_DEFINE_CHUNK_NAME.LetVar
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapContent]: [TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapStart],
  [TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapEnd]: [
    TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapStart,
    TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapContent
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.OnMountedStart]: [
    TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapEnd
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent]: [TEMPLATE_DEFINE_CHUNK_NAME.OnMountedStart],
  [TEMPLATE_DEFINE_CHUNK_NAME.OnMountedEnd]: [
    TEMPLATE_DEFINE_CHUNK_NAME.OnMountedStart,
    TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.UnMountedStart]: [
    TEMPLATE_DEFINE_CHUNK_NAME.OnMountedEnd
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.UnMountedContent]: [
    TEMPLATE_DEFINE_CHUNK_NAME.UnMountedStart
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.UnMountedEnd]: [
    TEMPLATE_DEFINE_CHUNK_NAME.UnMountedStart,
    TEMPLATE_DEFINE_CHUNK_NAME.UnMountedContent
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.Method]: [
    TEMPLATE_DEFINE_CHUNK_NAME.UnMountedEnd
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd]: [
    TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart,
    TEMPLATE_DEFINE_CHUNK_NAME.UnMountedEnd,
    TEMPLATE_DEFINE_CHUNK_NAME.Method
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.CssStyleStart]: [
    TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.CssStyleImport]: [
    TEMPLATE_DEFINE_CHUNK_NAME.CssStyleStart
  ],
  [TEMPLATE_DEFINE_CHUNK_NAME.CssStyleEnd]: [TEMPLATE_DEFINE_CHUNK_NAME.CssStyleStart, TEMPLATE_DEFINE_CHUNK_NAME.CssStyleImport]
};
var COMMON_SUB_MODULE_NAME = "index";
var VUE_MODULE_NAME = "@dckj-npm/lowcode-vue-materials";

// src/const/index.ts
var NATIVE_ELE_PKG = "native";
var CONTAINER_TYPE = {
  COMPONENT: "Component",
  BLOCK: "Block",
  PAGE: "Page"
};
var SUPPORT_SCHEMA_VERSION_LIST = ["0.0.1", "1.0.0"];
var BUILTIN_SLOT_NAMES = [
  "pages",
  "components",
  "router",
  "entry",
  "appConfig",
  "buildConfig",
  "constants",
  "utils",
  "i18n",
  "globalStyle",
  "htmlEntry",
  "packageJSON",
  "demo",
  "form",
  "hooks"
];
var isBuiltinSlotName = function(name) {
  return BUILTIN_SLOT_NAMES.includes(name);
};

// src/utils/errors.ts
function getErrorMessage(error) {
  if (!error) {
    return null;
  }
  if (error instanceof Error) {
    return error.message;
  }
  if (typeof error === "string") {
    return error;
  }
  if (typeof error === "object" && error !== null) {
    return getErrorMessage(error.message) || getErrorMessage(error.errorMessage) || getErrorMessage(error.detail);
  }
  return null;
}

// src/utils/schema.ts
var schema_exports = {};
__export(schema_exports, {
  ContainerType: () => ContainerType,
  handleSubNodes: () => handleSubNodes,
  isContainerSchema: () => isContainerSchema,
  isNpmInfo: () => isNpmInfo,
  isValidContainerType: () => isValidContainerType
});
import * as _ from "lodash";
import {
  isJSExpression,
  isJSSlot,
  isDOMText,
  isNodeSchema,
  isJSFunction
} from "@alilc/lowcode-types";

// src/utils/common.ts
var common_exports = {};
__export(common_exports, {
  camel2dash: () => camel2dash,
  camelize: () => camelize,
  generateID: () => generateID,
  getStaticExprValue: () => getStaticExprValue,
  isExternalDependency: () => isExternalDependency,
  isInternalDependency: () => isInternalDependency,
  isJSExpressionFn: () => isJSExpressionFn,
  uniqueArray: () => uniqueArray,
  upperCaseFirst: () => upperCaseFirst
});
import changeCase from "change-case";
import short from "short-uuid";
function camel2dash(input) {
  return changeCase.paramCase(input);
}
function camelize(str) {
  return changeCase.camelCase(str);
}
function generateID() {
  return short.generate();
}
function upperCaseFirst(inputValue) {
  return changeCase.upperCaseFirst(inputValue);
}
function uniqueArray(arr, by) {
  const map = {};
  arr.forEach((item) => {
    map[by(item)] = item;
  });
  const uniqueKeys = Array.from(new Set(Object.keys(map)));
  const uniqueItems = uniqueKeys.map((key) => map[key]);
  return uniqueItems;
}
function getStaticExprValue(expr) {
  return Function(`"use strict";return (${expr})`)();
}
function isJSExpressionFn(data) {
  return (data == null ? void 0 : data.type) === "JSExpression" && (data == null ? void 0 : data.extType) === "function";
}
function isInternalDependency(dependency) {
  return dependency.dependencyType === "Internal" /* Internal */;
}
function isExternalDependency(dependency) {
  return dependency.dependencyType === "External" /* External */;
}

// src/utils/schema.ts
function isContainerSchema(x) {
  return typeof x === "object" && x && typeof x.componentName === "string" && typeof x.fileName === "string";
}
function isNpmInfo(x) {
  return typeof x === "object" && x && typeof x.package === "string";
}
var noop = () => void 0;
var handleChildrenDefaultOptions = {
  rerun: false
};
var DEFAULT_MAX_DEPTH = 1e5;
function handleSubNodes(children, handlers, options) {
  var _a;
  const opt = {
    ...handleChildrenDefaultOptions,
    ...options || {}
  };
  const maxDepth = (_a = opt.maxDepth) != null ? _a : DEFAULT_MAX_DEPTH;
  if (maxDepth <= 0) {
    throw new Error("handleSubNodes maxDepth reached");
  }
  if (Array.isArray(children)) {
    const list = children;
    return list.map((child) => handleSubNodes(child, handlers, { ...opt, maxDepth: maxDepth - 1 })).reduce((p, c) => p.concat(c), []);
  }
  let result;
  const childrenRes = [];
  if (children === null || children === void 0) {
    return [];
  } else if (isDOMText(children)) {
    const handler = handlers.string || noop;
    result = handler(children);
  } else if (isJSExpression(children)) {
    const handler = handlers.expression || noop;
    result = handler(children);
  } else if (isJSSlot(children)) {
    return handleSubNodes(children.value, handlers, { ...opt, maxDepth: maxDepth - 1 });
  } else if (isNodeSchema(children)) {
    const handler = handlers.node || noop;
    const child = children;
    result = handler(child);
    if (child.children) {
      const childRes = handleSubNodes(child.children, handlers, opt);
      childrenRes.push(...childRes);
    }
    if (child.props) {
      if (Array.isArray(child.props)) {
        child.props.forEach(({ value }) => {
          const childRes = handleCompositeValueInProps(value);
          childrenRes.push(...childRes);
        });
      } else {
        Object.values(child.props).forEach((value) => {
          const childRes = handleCompositeValueInProps(value);
          childrenRes.push(...childRes);
        });
      }
    }
  } else {
    throw new CodeGeneratorError("handleSubNodes got invalid NodeData", children);
  }
  if (result !== void 0) {
    childrenRes.unshift(result);
  }
  return childrenRes;
  function handleCompositeValueInProps(value) {
    if (isJSSlot(value)) {
      return handleSubNodes(value.value, handlers, { ...opt, maxDepth: maxDepth - 1 });
    }
    if (Array.isArray(value)) {
      return _.flatMap(value, (v) => handleCompositeValueInProps(v));
    }
    if (!isJSExpression(value) && !isJSExpressionFn(value) && !isJSFunction(value) && typeof value === "object" && value !== null) {
      return _.flatMap(Object.values(value), (v) => handleCompositeValueInProps(v));
    }
    return [];
  }
}
function isValidContainerType(schema) {
  return [
    "Page",
    "Component",
    "Block"
  ].includes(schema.componentName);
}
var ContainerType = /* @__PURE__ */ ((ContainerType2) => {
  ContainerType2["Page"] = "Page";
  ContainerType2["Component"] = "Component";
  ContainerType2["Block"] = "Block";
  return ContainerType2;
})(ContainerType || {});

// src/analyzer/componentAnalyzer.ts
var componentAnalyzer = (container) => {
  let hasRefAttr = false;
  const nodeValidator = (n) => {
    if (n.props) {
      const props = n.props;
      if (props.ref) {
        hasRefAttr = true;
      }
    }
  };
  nodeValidator(container);
  if (!hasRefAttr && container.children) {
    handleSubNodes(
      container.children,
      {
        node: nodeValidator
      },
      {
        rerun: true
      }
    );
  }
  return {
    isUsingRef: hasRefAttr
  };
};

// src/utils/validate.ts
var validate_exports = {};
__export(validate_exports, {
  ensureValidClassName: () => ensureValidClassName,
  isValidComponentName: () => isValidComponentName,
  isValidIdentifier: () => isValidIdentifier,
  isValidVueDirective: () => isValidVueDirective
});
var isValidIdentifier = (name) => {
  return /^[_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF]*$/.test(name);
};
var isValidComponentName = (name) => {
  return /^[_$a-zA-Z\xA0-\uFFFF][_$a-zA-Z0-9\xA0-\uFFFF.]*$/.test(name);
};
var ensureValidClassName = (name) => {
  if (!isValidIdentifier(name)) {
    return `$${name.replace(/[^_$a-zA-Z0-9]/g, "")}`;
  }
  return name;
};
var isValidVueDirective = (name) => {
  const directives = ["v-model", "v-html", "v-for", "v-if", "v-else", "v-if-else", "v-show"];
  return directives.includes(name);
};

// src/parser/SchemaParser.ts
var defaultContainer = {
  containerType: "Component",
  componentName: "Component",
  moduleName: "Index",
  fileName: "Index",
  css: "",
  props: {}
};
function getRootComponentName(typeName, maps) {
  if (maps[typeName]) {
    const rec = maps[typeName];
    if (rec.destructuring) {
      return rec.componentName || typeName;
    }
    const peerName = Object.keys(maps).find((depName) => {
      const depInfo = maps[depName];
      return depName !== typeName && !depInfo.destructuring && depInfo.package === rec.package && depInfo.version === rec.version && depInfo.main === rec.main && depInfo.exportName === rec.exportName && depInfo.subName === rec.subName;
    });
    return peerName || typeName;
  }
  return typeName;
}
function processChildren(schema) {
  if (schema.props) {
    if (Array.isArray(schema.props)) {
    } else {
      const nodeProps = schema.props;
      if (nodeProps.children) {
        if (!schema.children) {
          schema.children = nodeProps.children;
        } else {
          let _children = [];
          if (Array.isArray(schema.children)) {
            _children = _children.concat(schema.children);
          } else {
            _children.push(schema.children);
          }
          if (Array.isArray(nodeProps.children)) {
            _children = _children.concat(nodeProps.children);
          } else {
            _children.push(nodeProps.children);
          }
          schema.children = _children;
        }
        delete nodeProps.children;
      }
    }
  }
}
function getInternalDep(internalDeps, depName) {
  const dep = internalDeps[depName];
  return dep && dep.type !== "pages" /* PAGE */ ? dep : null;
}
var SchemaParser = class {
  validate(schema) {
    if (SUPPORT_SCHEMA_VERSION_LIST.indexOf(schema.version) < 0) {
      throw new CompatibilityError(`Not support schema with version [${schema.version}]`);
    }
    return true;
  }
  parse(schemaSrc) {
    const compDeps = {};
    const internalDeps = {};
    let utilsDeps = [];
    const schema = this.decodeSchema(schemaSrc);
    schema.componentsMap.forEach((info) => {
      var _a, _b;
      if (info.componentName) {
        compDeps[info.componentName] = {
          ...info,
          dependencyType: "External" /* External */,
          componentName: info.componentName,
          exportName: (_a = info.exportName) != null ? _a : info.componentName,
          version: info.version || "*",
          destructuring: (_b = info.destructuring) != null ? _b : false
        };
      }
    });
    let containers;
    if (schema.componentsTree.length > 0) {
      const firstRoot = schema.componentsTree[0];
      if (!firstRoot.fileName && !isValidContainerType(firstRoot)) {
        const container = {
          ...firstRoot,
          ...defaultContainer,
          props: firstRoot.props || defaultContainer.props,
          css: firstRoot.css || defaultContainer.css,
          moduleName: firstRoot.moduleName || defaultContainer.moduleName,
          children: schema.componentsTree
        };
        containers = [container];
      } else {
        containers = schema.componentsTree.map((n) => {
          const subRoot = n;
          const container = {
            ...subRoot,
            componentName: getRootComponentName(subRoot.componentName, compDeps),
            containerType: subRoot.componentName,
            moduleName: ensureValidClassName(
              subRoot.componentName === "Component" /* Component */ ? subRoot.fileName : changeCase2.pascalCase(subRoot.fileName)
            )
          };
          return container;
        });
      }
    } else {
      throw new CodeGeneratorError("Can't find anything to generate.");
    }
    containers = containers.map((con) => ({
      ...con,
      analyzeResult: componentAnalyzer(con)
    }));
    containers.forEach((container) => {
      let type;
      switch (container.containerType) {
        case "Page":
          type = "pages" /* PAGE */;
          break;
        case "Block":
          type = "components" /* BLOCK */;
          break;
        default:
          type = "components" /* COMPONENT */;
          break;
      }
      const dep = {
        type,
        moduleName: container.moduleName,
        destructuring: false,
        exportName: container.moduleName,
        dependencyType: "Internal" /* Internal */
      };
      internalDeps[dep.moduleName] = dep;
    });
    const containersDeps = [].concat(...containers.map((c) => c.deps || []));
    containers.forEach((container) => {
      if (container.children) {
        handleSubNodes(
          container.children,
          {
            node: (i) => processChildren(i)
          },
          {
            rerun: true
          }
        );
      }
    });
    containers.forEach((container) => {
      const depNames = this.getComponentNames(container);
      container.deps = uniqueArray(depNames, (i) => i).map((depName) => getInternalDep(internalDeps, depName) || compDeps[depName]).filter(Boolean);
    });
    const routes = schemaSrc.routes ? schemaSrc.routes : containers.filter((container) => container.containerType === "Page").map((page) => {
      const { meta } = page;
      if (meta) {
        return {
          path: meta.router || `/${page.fileName}`,
          fileName: page.fileName,
          componentName: page.moduleName,
          isFormRouter: page.state["pageType"] == "form"
        };
      }
      return {
        path: `/${page.fileName}`,
        fileName: page.fileName,
        componentName: page.moduleName,
        isFormRouter: page.state["pageType"] == "form"
      };
    });
    const routerDeps = routes.map((r) => internalDeps[r.componentName] || compDeps[r.componentName]).filter((dep) => !!dep);
    let utils;
    if (schema.utils) {
      utils = schema.utils;
      utilsDeps = schema.utils.filter(
        (u) => u.type !== "function"
      ).map(
        (u) => {
          var _a, _b;
          return {
            ...u.content,
            componentName: u.name,
            version: u.content.version || "*",
            destructuring: (_a = u.content.destructuring) != null ? _a : false,
            exportName: (_b = u.content.exportName) != null ? _b : u.name
          };
        }
      );
    } else {
      utils = [];
    }
    let npms = [];
    containers.forEach((con) => {
      const p = (con.deps || []).map((dep) => {
        return dep.dependencyType === "External" /* External */ ? dep : null;
      }).filter((dep) => dep !== null);
      const npmInfos = p.filter(Boolean).map((i) => ({
        package: i.package,
        version: i.version
      }));
      npms.push(...npmInfos);
    });
    npms.push(
      ...utilsDeps.map((utilsDep) => ({
        package: utilsDep.package,
        version: utilsDep.version
      }))
    );
    npms = uniqueArray(npms, (i) => i.package).filter(Boolean);
    return {
      containers,
      globalUtils: {
        utils,
        deps: utilsDeps
      },
      globalI18n: schema.i18n,
      globalRouter: {
        routes,
        deps: routerDeps
      },
      project: {
        css: schema.css,
        constants: schema.constants,
        config: schema.config || {},
        meta: schema.meta || {},
        i18n: schema.i18n,
        containersDeps,
        utilsDeps,
        packages: npms || [],
        dataSourcesTypes: this.collectDataSourcesTypes(schema),
        projectRemark: this.getProjectRemark(containers)
      }
    };
  }
  getProjectRemark(containers) {
    return {
      isSingleComponent: containers.length === 1 && containers[0].containerType === "Component"
    };
  }
  getComponentNames(children) {
    return handleSubNodes(
      children,
      {
        node: (i) => i.componentName
      },
      {
        rerun: true
      }
    );
  }
  decodeSchema(schemaSrc) {
    let schema;
    if (typeof schemaSrc === "string") {
      try {
        schema = JSON.parse(schemaSrc);
      } catch (error) {
        throw new CodeGeneratorError(
          `Parse schema failed: ${getErrorMessage(error) || "unknown reason"}`
        );
      }
    } else {
      schema = schemaSrc;
    }
    return schema;
  }
  collectDataSourcesTypes(schema) {
    var _a, _b;
    const dataSourcesTypes = /* @__PURE__ */ new Set();
    const defaultDataSourceType = "fetch";
    (_b = (_a = schema.dataSource) == null ? void 0 : _a.list) == null ? void 0 : _b.forEach((ds) => {
      dataSourcesTypes.add(ds.type || defaultDataSourceType);
    });
    schema.componentsTree.forEach((rootNode) => {
      var _a2, _b2;
      (_b2 = (_a2 = rootNode.dataSource) == null ? void 0 : _a2.list) == null ? void 0 : _b2.forEach((ds) => {
        dataSourcesTypes.add(ds.type || defaultDataSourceType);
      });
    });
    return Array.from(dataSourcesTypes.values());
  }
};
function handleRouter(originalSchema, resourceList) {
  if (!resourceList || resourceList.length == 0) {
    return "";
  }
  return resourceList.map((item) => {
    const schema = originalSchema.find((s) => s.componentsTree[0].fileName === item.slug);
    if (!schema)
      return "";
    const page = schema == null ? void 0 : schema.componentsTree[0];
    return {
      path: `/${page == null ? void 0 : page.fileName}`,
      fileName: page == null ? void 0 : page.fileName,
      componentName: (page == null ? void 0 : page.moduleName) || capitalizeFirstLetter(page == null ? void 0 : page.fileName),
      isFormRouter: (page == null ? void 0 : page.state["pageType"]) == "form",
      firstPage: item.firstPage,
      title: item.title
    };
  }).filter((item) => item);
}
function capitalizeFirstLetter(str) {
  if (!str)
    return "";
  return str.split("-").map(
    (word) => word.charAt(0).toUpperCase() + word.slice(1)
  ).join("");
}

// src/utils/resultHelper.ts
var resultHelper_exports = {};
__export(resultHelper_exports, {
  addDirectory: () => addDirectory,
  addFile: () => addFile,
  createResultDir: () => createResultDir,
  createResultFile: () => createResultFile,
  findDir: () => findDir,
  findFile: () => findFile,
  flattenResult: () => flattenResult,
  getFileNameWithExt: () => getFileNameWithExt,
  globDirs: () => globDirs,
  globFiles: () => globFiles,
  removeDirsFromResult: () => removeDirsFromResult,
  removeFilesFromResult: () => removeFilesFromResult,
  scanDirs: () => scanDirs,
  scanFiles: () => scanFiles
});
import nm from "nanomatch";
function createResultFile(name, ext = "jsx", content = "") {
  return {
    name,
    ext,
    content
  };
}
function createResultDir(name) {
  return {
    name,
    dirs: [],
    files: []
  };
}
function addDirectory(target, dir) {
  if (target.dirs.findIndex((d) => d.name === dir.name) < 0) {
    target.dirs.push(dir);
  } else {
    throw new CodeGeneratorError(
      `Adding same directory to one directory: ${dir.name} -> ${target.name}`
    );
  }
}
function addFile(target, file2) {
  if (target.files.findIndex((f) => f.name === file2.name && f.ext === file2.ext) < 0) {
    target.files.push(file2);
  } else {
    throw new CodeGeneratorError(
      `Adding same file to one directory: ${file2.name} -> ${target.name}`
    );
  }
}
function flattenResult(dir, cwd = "") {
  if (!dir.files.length && !dir.dirs.length) {
    return [];
  }
  return [
    ...dir.files.map(
      (file2) => ({
        pathName: joinPath(cwd, `${file2.name}${file2.ext ? `.${file2.ext}` : ""}`),
        content: file2.content
      })
    )
  ].concat(...dir.dirs.map((subDir) => flattenResult(subDir, joinPath(cwd, subDir.name))));
}
function findFile(result, fileGlobExpr, options = {}, resultDirPath = getResultNameOrDefault(result, "")) {
  const maxDepth = !/\/|\*\*/.test(fileGlobExpr) ? 1 : void 0;
  const files = scanFiles(result, resultDirPath, maxDepth);
  for (let [filePath, file2] of files) {
    if (nm.isMatch(filePath, fileGlobExpr, options)) {
      return file2;
    }
  }
  return null;
}
function* globFiles(result, fileGlobExpr, options = {}, resultDirPath = getResultNameOrDefault(result, "")) {
  const files = scanFiles(result, resultDirPath);
  for (let [filePath, file2] of files) {
    if (nm.isMatch(filePath, fileGlobExpr, options)) {
      yield [filePath, file2];
    }
  }
}
function* scanFiles(result, resultDirPath = getResultNameOrDefault(result, ""), maxDepth = 1e4) {
  for (let file2 of result.files) {
    const fileName = getFileNameWithExt(file2);
    yield [joinPath(resultDirPath, fileName), file2];
  }
  for (let subDir of result.dirs) {
    yield* scanFiles(subDir, joinPath(resultDirPath, subDir.name), maxDepth - 1);
  }
}
function getFileNameWithExt(file2) {
  return `${file2.name}${file2.ext ? `.${file2.ext}` : ""}`;
}
function getResultNameOrDefault(result, defaultDir = "/") {
  return result.name && result.name !== "." ? result.name : defaultDir;
}
function joinPath(...pathParts) {
  return pathParts.filter((x) => x !== "" && x !== ".").join("/").replace(/\\+/g, "/").replace(/\/+/g, "/");
}
function* scanDirs(result, resultDirPath = getResultNameOrDefault(result, ""), maxDepth = 1e4) {
  yield [resultDirPath, result];
  for (let subDir of result.dirs) {
    yield* scanDirs(subDir, joinPath(resultDirPath, subDir.name), maxDepth - 1);
  }
}
function* globDirs(result, dirGlobExpr, options = {}, resultDirPath = getResultNameOrDefault(result, "")) {
  const dirs = scanDirs(result, resultDirPath);
  for (let [dirPath, dir] of dirs) {
    if (nm.isMatch(dirPath, dirGlobExpr, options)) {
      yield [dirPath, dir];
    }
  }
}
function findDir(result, dirGlobExpr, options = {}, resultDirPath = getResultNameOrDefault(result, "")) {
  const dirs = scanDirs(result, resultDirPath);
  for (let [dirPath, dir] of dirs) {
    if (nm.isMatch(dirPath, dirGlobExpr, options)) {
      return dir;
    }
  }
  return null;
}
function removeFilesFromResult(result, filePathGlobExpr, globOptions = {}) {
  let removedCount = 0;
  const [dirPath, fileName] = splitPath(filePathGlobExpr);
  const dirs = dirPath ? globDirs(result, dirPath) : [["", result]];
  for (let [, dir] of dirs) {
    const files = globFiles(dir, fileName, globOptions, ".");
    for (let [, file2] of files) {
      dir.files.splice(dir.files.indexOf(file2), 1);
      removedCount += 1;
    }
  }
  return removedCount;
}
function removeDirsFromResult(result, dirPathGlobExpr, globOptions = {}) {
  let removedCount = 0;
  const [dirPath, fileName] = splitPath(dirPathGlobExpr);
  const dirs = dirPath ? globDirs(result, dirPath) : [["", result]];
  for (let [, dir] of dirs) {
    const foundDirs = globDirs(dir, fileName, globOptions, ".");
    for (let [, foundDir] of foundDirs) {
      dir.dirs.splice(dir.dirs.indexOf(foundDir), 1);
      removedCount += 1;
    }
  }
  return removedCount;
}
function splitPath(filePath) {
  const parts = filePath.split("/");
  const fileName = parts.pop() || "";
  return [joinPath(...parts), fileName];
}

// src/generator/ChunkBuilder.ts
function whichFamily(type) {
  const idx = FILE_TYPE_FAMILY.findIndex((family) => family.indexOf(type) >= 0);
  if (idx < 0) {
    return void 0;
  }
  return [idx, FILE_TYPE_FAMILY[idx]];
}
var groupChunks = (chunks) => {
  const tmp = {};
  const col = chunks.reduce((chunksSet, chunk) => {
    const fileKey = chunk.subModule || COMMON_SUB_MODULE_NAME;
    if (!chunksSet[fileKey]) {
      chunksSet[fileKey] = [];
    }
    const res = whichFamily(chunk.fileType);
    const info = {
      chunk
    };
    if (res) {
      const [familyIdx, family] = res;
      const rank = family.indexOf(chunk.fileType);
      if (tmp[fileKey]) {
        if (tmp[fileKey][familyIdx] !== void 0) {
          if (tmp[fileKey][familyIdx] > rank) {
            tmp[fileKey][familyIdx] = rank;
          }
        } else {
          tmp[fileKey][familyIdx] = rank;
        }
      } else {
        tmp[fileKey] = {};
        tmp[fileKey][familyIdx] = rank;
      }
      info.familyIdx = familyIdx;
    }
    chunksSet[fileKey].push(info);
    return chunksSet;
  }, {});
  const result = [];
  Object.keys(col).forEach((key) => {
    const byType = {};
    col[key].forEach((info) => {
      let t3 = info.chunk.fileType;
      if (info.familyIdx !== void 0) {
        t3 = FILE_TYPE_FAMILY[info.familyIdx][tmp[key][info.familyIdx]];
        info.chunk.fileType = t3;
      }
      if (!byType[t3]) {
        byType[t3] = [];
      }
      byType[t3].push(info.chunk);
    });
    result.push(...Object.keys(byType).map((t3) => byType[t3]));
  });
  return result;
};
var ChunkBuilder = class {
  constructor(plugins5 = []) {
    __publicField(this, "plugins");
    this.plugins = plugins5;
  }
  async run(ir, initialStructure = {
    ir,
    chunks: [],
    depNames: [],
    contextData: {}
  }) {
    const structure = initialStructure;
    const finalStructure = await this.plugins.reduce(
      async (previousPluginOperation, plugin) => {
        const modifiedStructure = await previousPluginOperation;
        return plugin(modifiedStructure);
      },
      Promise.resolve(structure)
    );
    const chunks = groupChunks(finalStructure.chunks);
    return {
      chunks
    };
  }
  getPlugins() {
    return this.plugins;
  }
  addPlugin(plugin) {
    this.plugins.push(plugin);
  }
};

// src/generator/CodeBuilder.ts
var CodeBuilder = class {
  constructor(chunkDefinitions = []) {
    __publicField(this, "chunkDefinitions", []);
    __publicField(this, "generators", {
      ["string" /* STRING */]: (str) => str,
      ["json" /* JSON */]: (json) => JSON.stringify(json)
    });
    this.chunkDefinitions = chunkDefinitions;
  }
  link(chunkDefinitions = []) {
    let zIndexA = 0;
    const chunks = chunkDefinitions || this.chunkDefinitions;
    if (chunks.length <= 0) {
      return { zIndex: 0, content: "" };
    }
    const unprocessedChunks = chunks.map((chunk) => {
      return {
        name: chunk.name,
        type: chunk.type,
        content: chunk.content,
        linkAfter: this.cleanupInvalidChunks(chunk.linkAfter, chunks),
        zIndex: chunk.zIndex || 0
      };
    });
    const resultingString = [];
    while (unprocessedChunks.length > 0) {
      let indexToRemove = 0;
      for (let index = 0; index < unprocessedChunks.length; index++) {
        if (unprocessedChunks[index].linkAfter.length <= 0) {
          indexToRemove = index;
          break;
        }
      }
      if (unprocessedChunks[indexToRemove].linkAfter.length > 0) {
        throw new CodeGeneratorError(
          "Operation aborted. Reason: cyclic dependency between chunks."
        );
      }
      const { type, content, name, zIndex } = unprocessedChunks[indexToRemove];
      const compiledContent = this.generateByType(type, content);
      if (compiledContent) {
        resultingString.push(`${compiledContent}
`);
        zIndexA = zIndex > zIndexA ? zIndex : zIndexA;
      }
      unprocessedChunks.splice(indexToRemove, 1);
      if (!unprocessedChunks.some((ch) => ch.name === name)) {
        unprocessedChunks.forEach(
          (ch) => {
            ch.linkAfter = ch.linkAfter.filter((after) => after !== name);
          }
        );
      }
    }
    return { zIndex: zIndexA, content: resultingString.join("\n") };
  }
  generateByType(type, content) {
    if (!content) {
      return "";
    }
    if (Array.isArray(content)) {
      return content.map((contentItem) => this.generateByType(type, contentItem)).join("\n");
    }
    if (!this.generators[type]) {
      throw new Error(
        `Attempted to generate unknown type ${type}. Please register a generator for this type in builder/index.ts`
      );
    }
    return this.generators[type](content);
  }
  cleanupInvalidChunks(linkAfter, chunks) {
    return linkAfter.filter((chunkName) => chunks.some((chunk) => chunk.name === chunkName));
  }
};

// src/generator/ModuleBuilder.ts
function createModuleBuilder(options = {
  plugins: [],
  postProcessors: []
}) {
  const chunkGenerator = new ChunkBuilder(options.plugins);
  const linker = new CodeBuilder();
  const generateModule = async (input) => {
    const moduleMainName = options.mainFileName || COMMON_SUB_MODULE_NAME;
    if (chunkGenerator.getPlugins().length <= 0) {
      throw new CodeGeneratorError(
        "No plugins found. Component generation cannot work without any plugins!"
      );
    }
    let files = [];
    const { chunks } = await chunkGenerator.run(input, {
      ir: input,
      chunks: [],
      depNames: [],
      contextData: options.contextData || {}
    });
    chunks.forEach((fileChunkList) => {
      const { content, zIndex } = linker.link(fileChunkList);
      const file2 = createResultFile(
        fileChunkList[0].subModule || moduleMainName,
        fileChunkList[0].fileType,
        content
      );
      file2.zIndex = zIndex;
      files.push(file2);
    });
    if (options.postProcessors.length > 0) {
      files = files.map((file2) => {
        let { content, ext: type, name } = file2;
        options.postProcessors.forEach((processer) => {
          content = processer(content, type, name);
        });
        const resultFile = createResultFile(file2.name, type, content);
        resultFile.zIndex = file2.zIndex;
        return resultFile;
      });
    }
    return {
      files
    };
  };
  const generateModuleCode = async (schema) => {
    const schemaParser = new SchemaParser();
    const parseResult = schemaParser.parse(schema);
    const containerInfo = parseResult.containers[0];
    const { files } = await generateModule(containerInfo);
    const dir = createResultDir(containerInfo.moduleName);
    files.forEach((file2) => addFile(dir, file2));
    return dir;
  };
  const linkCodeChunks = (chunks, fileName) => {
    const files = [];
    Object.keys(chunks).forEach((fileKey) => {
      const fileChunkList = chunks[fileKey];
      const { content, zIndex } = linker.link(fileChunkList);
      const file2 = createResultFile(
        fileChunkList[0].subModule || fileName,
        fileChunkList[0].fileType,
        content
      );
      file2.zIndex = zIndex;
      files.push(file2);
    });
    return files;
  };
  return {
    generateModule,
    generateModuleCode,
    linkCodeChunks,
    addPlugin: chunkGenerator.addPlugin.bind(chunkGenerator)
  };
}

// src/generator/ProjectBuilder.ts
var ProjectBuilder = class {
  constructor(builderOptions) {
    __publicField(this, "template");
    __publicField(this, "plugins");
    __publicField(this, "postProcessors");
    __publicField(this, "schemaParser");
    __publicField(this, "projectPreProcessors");
    __publicField(this, "projectPostProcessors");
    __publicField(this, "inStrictMode");
    __publicField(this, "extraContextData");
    let customBuilderOptions = builderOptions;
    if (typeof builderOptions.customizeBuilderOptions === "function") {
      customBuilderOptions = builderOptions.customizeBuilderOptions(builderOptions);
    }
    const {
      template,
      plugins: plugins5,
      postProcessors,
      schemaParser = new SchemaParser(),
      projectPreProcessors = [],
      projectPostProcessors = [],
      inStrictMode = false,
      extraContextData = {}
    } = customBuilderOptions;
    this.template = template;
    this.plugins = plugins5;
    this.postProcessors = postProcessors;
    this.schemaParser = schemaParser;
    this.projectPreProcessors = projectPreProcessors;
    this.projectPostProcessors = projectPostProcessors;
    this.inStrictMode = inStrictMode;
    this.extraContextData = extraContextData;
  }
  async generateProjectOne(originalSchema) {
    var _a, _b, _c;
    const { schemaParser } = this;
    let schema = typeof originalSchema === "string" ? JSON.parse(originalSchema) : originalSchema;
    for (const preProcessor of this.projectPreProcessors) {
      schema = await preProcessor(schema);
    }
    if (!schemaParser.validate(schema)) {
      throw new CodeGeneratorError("Schema is invalid");
    }
    const parseResult = schemaParser.parse(schema);
    const projectRoot = await this.template.generateTemplate(parseResult);
    let buildResult = [];
    const builders = this.createModuleBuilders({
      extraContextData: {
        projectRemark: (_a = parseResult == null ? void 0 : parseResult.project) == null ? void 0 : _a.projectRemark,
        template: this.template
      }
    });
    const containerBuildResult = await Promise.all(
      parseResult.containers.map(async (containerInfo) => {
        let builder;
        let path;
        let files;
        if (containerInfo.containerType === "Page") {
          if (containerInfo.state && containerInfo.state.pageType == "form") {
            builder = builders.form;
            path = this.template.slots.form.path;
            files = (await builder.generateModule(containerInfo)).files;
          } else {
            builder = builders.pages;
            path = this.template.slots.pages.path;
            files = (await builder.generateModule(containerInfo)).files;
          }
        } else {
          builder = builders.components;
          path = this.template.slots.components.path;
          files = (await builder.generateModule(containerInfo)).files;
        }
        return {
          moduleName: containerInfo.moduleName,
          path,
          files
        };
      })
    );
    buildResult = buildResult.concat(containerBuildResult);
    if (parseResult.globalRouter && builders.router) {
      const { files } = await builders.router.generateModule(parseResult.globalRouter);
      buildResult.push({
        path: this.template.slots.router.path,
        files
      });
    }
    if (parseResult.project && builders.entry) {
      const { files } = await builders.entry.generateModule(parseResult.project);
      buildResult.push({
        path: this.template.slots.entry.path,
        files
      });
    }
    if (builders.appConfig) {
      const { files } = await builders.appConfig.generateModule(parseResult);
      buildResult.push({
        path: this.template.slots.appConfig.path,
        files
      });
    }
    if (builders.buildConfig) {
      const { files } = await builders.buildConfig.generateModule(parseResult);
      buildResult.push({
        path: this.template.slots.buildConfig.path,
        files
      });
    }
    if (parseResult.project && builders.constants && this.template.slots.constants) {
      const { files } = await builders.constants.generateModule(parseResult.project);
      buildResult.push({
        path: this.template.slots.constants.path,
        files
      });
    }
    if (parseResult.globalUtils && builders.utils && this.template.slots.utils) {
      const { files } = await builders.utils.generateModule(parseResult.globalUtils);
      buildResult.push({
        path: this.template.slots.utils.path,
        files
      });
    }
    if (parseResult.globalUtils && builders.hooks && this.template.slots.hooks) {
      const { files } = await builders.hooks.generateModule(parseResult.globalUtils);
      buildResult.push({
        path: this.template.slots.hooks.path,
        files
      });
    }
    if (builders.i18n && this.template.slots.i18n) {
      const { files } = await builders.i18n.generateModule(parseResult.project);
      buildResult.push({
        path: this.template.slots.i18n.path,
        files
      });
    }
    if (parseResult.project && builders.globalStyle) {
      const { files } = await builders.globalStyle.generateModule(parseResult.project);
      buildResult.push({
        path: this.template.slots.globalStyle.path,
        files
      });
    }
    if (parseResult.project && builders.htmlEntry) {
      const { files } = await builders.htmlEntry.generateModule(parseResult.project);
      buildResult.push({
        path: this.template.slots.htmlEntry.path,
        files
      });
    }
    if (parseResult.project && builders.packageJSON) {
      const { files } = await builders.packageJSON.generateModule(parseResult.project);
      buildResult.push({
        path: this.template.slots.packageJSON.path,
        files
      });
    }
    if (parseResult.project && builders.demo) {
      const { files } = await builders.demo.generateModule(parseResult.project);
      buildResult.push({
        path: this.template.slots.demo.path,
        files
      });
    }
    await this.generateExtraSlots(builders, parseResult, buildResult);
    const isSingleComponent = (_c = (_b = parseResult == null ? void 0 : parseResult.project) == null ? void 0 : _b.projectRemark) == null ? void 0 : _c.isSingleComponent;
    buildResult.forEach((moduleInfo) => {
      let targetDir = getDirFromRoot(projectRoot, moduleInfo.path);
      if (moduleInfo.moduleName && !isSingleComponent) {
        const dir = createResultDir(moduleInfo.moduleName);
        addDirectory(targetDir, dir);
        targetDir = dir;
      }
      moduleInfo.files.forEach((file2) => addFile(targetDir, file2));
    });
    let finalResult = projectRoot;
    for (const projectPostProcessor of this.projectPostProcessors) {
      finalResult = await projectPostProcessor(finalResult, schema, originalSchema, {
        template: this.template,
        parseResult
      });
    }
    return finalResult;
  }
  async generateProject(originalSchema, resourceList) {
    if (Array.isArray(originalSchema)) {
      const routes = handleRouter(originalSchema, resourceList);
      const data = await Promise.all(originalSchema.map((schema) => {
        schema.routes = routes;
        return this.generateProjectOne(schema);
      }));
      return mergeResultDirs(data);
    }
    return await this.generateProjectOne(originalSchema);
  }
  createModuleBuilders(extraContextData = {}) {
    const builders = {};
    Object.keys(this.plugins).forEach((pluginName) => {
      if (this.plugins[pluginName].length > 0) {
        const options = {};
        if (this.template.slots[pluginName] && this.template.slots[pluginName].fileName) {
          options.mainFileName = this.template.slots[pluginName].fileName;
        }
        builders[pluginName] = createModuleBuilder({
          plugins: this.plugins[pluginName],
          postProcessors: this.postProcessors,
          contextData: {
            inStrictMode: this.inStrictMode,
            tolerateEvalErrors: true,
            evalErrorsHandler: "",
            ...this.extraContextData,
            ...extraContextData
          },
          ...options
        });
      }
    });
    return builders;
  }
  async generateExtraSlots(builders, parseResult, buildResult) {
    for (const slotName in this.template.slots) {
      if (!isBuiltinSlotName(slotName)) {
        const { files } = await builders[slotName].generateModule(parseResult);
        buildResult.push({
          path: this.template.slots[slotName].path,
          files
        });
      }
    }
  }
};
function createProjectBuilder(initOptions) {
  return new ProjectBuilder(initOptions);
}
function getDirFromRoot(root, path) {
  let current = root;
  path.forEach((p) => {
    const exist = current.dirs.find((d) => d.name === p);
    if (exist) {
      current = exist;
    } else {
      const newDir = createResultDir(p);
      addDirectory(current, newDir);
      current = newDir;
    }
  });
  return current;
}
function mergeResultDirs(dirs) {
  const result = { name: ".", dirs: [], files: [] };
  const mergeDir = (target, source) => {
    const fileMap = {};
    [...target.files, ...source.files].forEach((file2) => {
      const key = `${file2.name}.${file2.ext}`;
      if (fileMap[key]) {
        fileMap[key] = file2.zIndex > fileMap[key].zIndex ? file2 : fileMap[key];
        return;
      }
      fileMap[key] = file2;
    });
    target.files = Object.values(fileMap);
    const dirMap = {};
    target.dirs.forEach((dir) => {
      dirMap[dir.name] = dir;
    });
    source.dirs.forEach((dir) => {
      if (dirMap[dir.name]) {
        mergeDir(dirMap[dir.name], dir);
      } else {
        dirMap[dir.name] = dir;
      }
    });
    target.dirs = Object.values(dirMap);
  };
  dirs.forEach((dir) => {
    mergeDir(result, dir);
  });
  return result;
}

// src/publisher/disk/index.ts
import * as defaultFs from "fs";

// src/publisher/disk/utils.ts
import * as systemFs from "fs";
import { join } from "path";
var writeFolder = async (folder, currentPath, createProjectFolder = true, fs = systemFs) => {
  const { name, files, dirs } = folder;
  const folderPath = createProjectFolder ? join(currentPath, name) : currentPath;
  if (!fs.existsSync(folderPath)) {
    await createDirectory(folderPath, fs);
  }
  const promises = [
    writeFilesToFolder(folderPath, files, fs),
    writeSubFoldersToFolder(folderPath, dirs, fs)
  ];
  await Promise.all(promises);
};
var writeFilesToFolder = async (folderPath, files, fs) => {
  const promises = files.map((file2) => {
    const fileName = file2.ext ? `${file2.name}.${file2.ext}` : file2.name;
    const filePath = join(folderPath, fileName);
    return writeContentToFile(filePath, file2.content, "utf8", fs);
  });
  await Promise.all(promises);
};
var writeSubFoldersToFolder = async (folderPath, subFolders, fs) => {
  const promises = subFolders.map((subFolder) => {
    return writeFolder(subFolder, folderPath, true, fs);
  });
  await Promise.all(promises);
};
var createDirectory = (pathToDir, fs) => {
  return new Promise((resolve, reject) => {
    fs.mkdir(pathToDir, { recursive: true }, (err) => {
      err ? reject(err) : resolve();
    });
  });
};
var writeContentToFile = (filePath, fileContent, encoding = "utf8", fs) => {
  return new Promise((resolve, reject) => {
    fs.writeFile(filePath, fileContent, { encoding }, (err) => {
      err ? reject(err) : resolve();
    });
  });
};

// src/publisher/disk/index.ts
var createDiskPublisher = (params = {}) => {
  let { project, outputPath = "./" } = params;
  const { fs = defaultFs } = params;
  const getProject = () => {
    if (!project) {
      throw new PublisherError("MissingProject");
    }
    return project;
  };
  const setProject = (projectToSet) => {
    project = projectToSet;
  };
  const getOutputPath = () => {
    return outputPath;
  };
  const setOutputPath = (path) => {
    outputPath = path;
  };
  const publish = async (options = {}) => {
    var _a;
    const projectToPublish = options.project || project;
    if (!projectToPublish) {
      throw new PublisherError("MissingProject");
    }
    const projectOutputPath = options.outputPath || outputPath;
    const overrideProjectSlug = options.projectSlug || params.projectSlug;
    const createProjectFolder = (_a = options.createProjectFolder) != null ? _a : params.createProjectFolder;
    if (overrideProjectSlug) {
      projectToPublish.name = overrideProjectSlug;
    }
    try {
      await writeFolder(projectToPublish, projectOutputPath, createProjectFolder, fs);
      return { success: true, payload: projectOutputPath };
    } catch (error) {
      throw new PublisherError(getErrorMessage(error) || "UnknownError");
    }
  };
  return {
    publish,
    getProject,
    setProject,
    getOutputPath,
    setOutputPath
  };
};

// src/publisher/zip/utils.ts
import JSZip from "jszip";
var isNodeProcess = () => {
  return typeof process === "object" && typeof process.versions === "object" && typeof process.versions.node !== "undefined";
};
var writeZipToDisk = (zipFolderPath, content, zipName) => {
  if (!isNodeProcess()) {
    throw new Error("ZipPublisher: writeZipToDisk is only available in NodeJS");
  }
  const fs = __require("fs");
  const path = __require("path");
  if (!fs.existsSync(zipFolderPath)) {
    fs.mkdirSync(zipFolderPath, { recursive: true });
  }
  const zipPath = path.join(zipFolderPath, `${zipName}.zip`);
  const writeStream = fs.createWriteStream(zipPath);
  writeStream.write(content);
  writeStream.end();
};
var generateProjectZip = async (project) => {
  let zip = new JSZip();
  zip = writeFolderToZip(project, zip, true);
  const zipType = isNodeProcess() ? "nodebuffer" : "blob";
  return zip.generateAsync({ type: zipType });
};
var writeFolderToZip = (folder, parentFolder, ignoreFolder = false) => {
  const zipFolder = ignoreFolder ? parentFolder : parentFolder.folder(folder.name);
  if (zipFolder !== null) {
    folder.files.forEach((file2) => {
      const options = {};
      const fileName = file2.ext ? `${file2.name}.${file2.ext}` : file2.name;
      zipFolder.file(fileName, file2.content, options);
    });
    folder.dirs.forEach((subFolder) => {
      writeFolderToZip(subFolder, zipFolder);
    });
  }
  return parentFolder;
};

// src/publisher/zip/index.ts
import { saveAs } from "file-saver";
var createZipPublisher = (params = {}) => {
  let { project, outputPath } = params;
  const getProject = () => project;
  const setProject = (projectToSet) => {
    project = projectToSet;
  };
  const getOutputPath = () => outputPath;
  const setOutputPath = (path) => {
    outputPath = path;
  };
  const publish = async (options = {}) => {
    const projectToPublish = options.project || project;
    if (!projectToPublish) {
      throw new PublisherError("MissingProject");
    }
    const zipName = options.projectSlug || params.projectSlug || projectToPublish.name;
    try {
      const zipContent = await generateProjectZip(projectToPublish);
      if (isNodeProcess()) {
        const projectOutputPath = options.outputPath || outputPath;
        if (projectOutputPath) {
          await writeZipToDisk(projectOutputPath, zipContent, zipName);
        }
      } else {
        saveAs(zipContent, `${zipName}.zip`);
      }
      return { success: true, payload: zipContent };
    } catch (error) {
      throw new PublisherError(getErrorMessage(error) || "UnknownError");
    }
  };
  return {
    publish,
    getProject,
    setProject,
    getOutputPath,
    setOutputPath
  };
};

// src/plugins/common/esmodule.ts
import { flatMap as flatMap2, camelCase, get } from "lodash";
var DEP_MAIN_BLOCKLIST = ["lib", "lib/index", "es", "es/index", "main"];
var DEFAULT_EXPORT_NAME = "__default__";
function groupDepsByPack(deps) {
  const depMap = {};
  const addDep = (pkg, dep) => {
    if (!depMap[pkg]) {
      depMap[pkg] = [];
    }
    depMap[pkg].push(dep);
  };
  deps.forEach((dep) => {
    if (dep.dependencyType === "Internal" /* Internal */) {
      addDep(`${dep.moduleName}${dep.main ? `/${dep.main}` : ""}`, dep);
    } else {
      let depMain = "";
      if (dep.main && DEP_MAIN_BLOCKLIST.indexOf(dep.main) < 0) {
        depMain = dep.main;
      }
      if (depMain.substring(0, 1) === "/") {
        depMain = depMain.substring(1);
      }
      addDep(`${dep.package}${depMain ? `/${depMain}` : ""}`, dep);
    }
  });
  return depMap;
}
function getDependencyIdentifier(info) {
  return info.aliasName || info.exportName;
}
function getExportNameOfDep(dep) {
  if (dep.destructuring) {
    return dep.exportName || dep.componentName || throwNewError("destructuring dependency must have exportName or componentName");
  }
  if (!dep.subName) {
    return dep.componentName || dep.exportName || throwNewError("dependency item must have componentName or exportName");
  }
  return dep.exportName || `__$${camelCase(
    get(dep, "moduleName") || get(dep, "package") || throwNewError("dep.moduleName or dep.package is undefined")
  )}_default`;
}
function throwNewError(msg) {
  throw new Error(msg);
}
function buildPackageImport(pkg, deps, targetFileType, useAliasName) {
  if (!pkg || pkg === "undefined" || pkg === "null") {
    return [];
  }
  const chunks = [];
  const exportItems = {};
  const defaultExportNames = [];
  const depsInfo = deps.map((dep) => {
    const info = {
      exportName: getExportNameOfDep(dep),
      isDefault: !dep.destructuring,
      subName: dep.subName || void 0,
      nodeIdentifier: dep.componentName || void 0,
      source: dep
    };
    if (info.isDefault) {
      if (defaultExportNames.indexOf(info.exportName) < 0) {
        defaultExportNames.push(info.exportName);
      }
    }
    if (!info.subName) {
      if (info.nodeIdentifier === info.exportName) {
        info.nodeIdentifier = void 0;
      }
      if (info.isDefault) {
        info.aliasName = info.nodeIdentifier || info.exportName;
        info.exportName = DEFAULT_EXPORT_NAME;
      }
      if (info.nodeIdentifier) {
        info.aliasName = info.nodeIdentifier;
        info.nodeIdentifier = void 0;
      }
    } else {
      if (info.isDefault) {
        info.aliasName = info.exportName;
        info.exportName = DEFAULT_EXPORT_NAME;
      }
      if (info.nodeIdentifier === `${info.exportName}.${info.subName}`) {
        info.nodeIdentifier = void 0;
      }
    }
    return info;
  });
  depsInfo.forEach((info) => {
    if (!exportItems[info.exportName]) {
      exportItems[info.exportName] = {
        exportName: info.exportName,
        isDefault: info.isDefault,
        aliasNames: [],
        needOriginExport: false
      };
    }
    if (!info.nodeIdentifier && !info.aliasName) {
      exportItems[info.exportName].needOriginExport = true;
    }
  });
  depsInfo.forEach((info) => {
    if (info.aliasName) {
      const { aliasNames } = exportItems[info.exportName];
      if (aliasNames.indexOf(info.aliasName) < 0) {
        aliasNames.push(info.aliasName);
      }
    }
  });
  depsInfo.forEach((info) => {
    if (info.nodeIdentifier) {
      const exportItem = exportItems[info.exportName];
      if (!exportItem.needOriginExport && exportItem.aliasNames.length > 0) {
        info.aliasName = exportItem.aliasNames[0];
      }
    }
  });
  const nodeIdentifiers = depsInfo.map((info) => info.nodeIdentifier).filter(Boolean);
  const conflictInfos = flatMap2(Object.keys(exportItems), (exportName) => {
    const exportItem = exportItems[exportName];
    const usedNames = [
      ...exportItem.aliasNames,
      ...exportItem.needOriginExport || exportItem.aliasNames.length <= 0 ? [exportName] : []
    ];
    const conflictNames = usedNames.filter((n) => nodeIdentifiers.indexOf(n) >= 0);
    if (conflictNames.length > 0) {
      return [
        ...conflictNames.indexOf(exportName) >= 0 ? [[exportName, true, exportItem]] : [],
        ...conflictNames.filter((n) => n !== exportName).map((n) => [n, false, exportItem])
      ];
    }
    return [];
  });
  const conflictExports = conflictInfos.filter((c) => c[1]).map((c) => c[0]);
  const conflictAlias = conflictInfos.filter((c) => !c[1]).map((c) => c[0]);
  const solutions = {};
  depsInfo.forEach((info) => {
    if (info.aliasName && conflictAlias.indexOf(info.aliasName) >= 0) {
      let solution = solutions[info.aliasName];
      if (!solution) {
        solution = `${info.aliasName}Alias`;
        const conflictItem = (conflictInfos.find((c) => c[0] === info.aliasName) || [])[2];
        conflictItem.aliasNames = conflictItem.aliasNames.filter((a) => a !== info.aliasName);
        conflictItem.aliasNames.push(solution);
        solutions[info.aliasName] = solution;
      }
      info.aliasName = solution;
    }
    if (conflictExports.indexOf(info.exportName) >= 0) {
      let solution = solutions[info.exportName];
      if (!solution) {
        solution = `${info.exportName}Export`;
        const conflictItem = (conflictInfos.find((c) => c[0] === info.exportName) || [])[2];
        conflictItem.aliasNames.push(solution);
        conflictItem.needOriginExport = false;
        solutions[info.exportName] = solution;
      }
      info.aliasName = solution;
    }
  });
  depsInfo.forEach((info) => {
    const name = info.aliasName || info.exportName;
    if (!isValidIdentifier(name)) {
      throw new CodeGeneratorError(`Invalid Identifier [${name}]`);
    }
    if (info.nodeIdentifier && !isValidIdentifier(info.nodeIdentifier)) {
      throw new CodeGeneratorError(`Invalid Identifier [${info.nodeIdentifier}]`);
    }
  });
  const aliasDefineStatements = {};
  if (useAliasName) {
    Object.keys(exportItems).forEach((exportName) => {
      var _a;
      const aliasList = ((_a = exportItems[exportName]) == null ? void 0 : _a.aliasNames) || [];
      if (aliasList.length > 0) {
        const srcName = exportItems[exportName].needOriginExport ? exportName : aliasList[0];
        const aliasNameList = exportItems[exportName].needOriginExport ? aliasList : aliasList.slice(1);
        aliasNameList.forEach((a) => {
          if (!aliasDefineStatements[a]) {
            aliasDefineStatements[a] = `const ${a} = ${srcName};`;
          }
        });
      }
    });
  }
  function getDefaultExportName(info) {
    if (info.isDefault) {
      return defaultExportNames[0];
    }
    return info.exportName;
  }
  depsInfo.forEach((info) => {
    if (info.nodeIdentifier) {
      const ownerName = getDependencyIdentifier(info);
      chunks.push({
        type: "string" /* STRING */,
        fileType: targetFileType,
        name: COMMON_CHUNK_NAME.ImportAliasDefine,
        content: useAliasName ? `const ${info.nodeIdentifier} = ${ownerName}.${info.subName};` : "",
        linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport],
        ext: {
          originalName: `${getDefaultExportName(info)}.${info.subName}`,
          aliasName: info.nodeIdentifier,
          dependency: info.source
        }
      });
    } else if (info.aliasName) {
      if (info.isDefault && defaultExportNames.find((n) => n === info.aliasName)) {
        delete aliasDefineStatements[info.aliasName];
        return;
      }
      let contentStatement = "";
      if (aliasDefineStatements[info.aliasName]) {
        contentStatement = aliasDefineStatements[info.aliasName];
        delete aliasDefineStatements[info.aliasName];
      }
      chunks.push({
        type: "string" /* STRING */,
        fileType: targetFileType,
        name: COMMON_CHUNK_NAME.ImportAliasDefine,
        content: contentStatement,
        linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport],
        ext: {
          originalName: getDefaultExportName(info),
          aliasName: info.aliasName,
          dependency: info.source
        }
      });
    }
  });
  Object.keys(aliasDefineStatements).forEach((a) => {
    chunks.push({
      type: "string" /* STRING */,
      fileType: targetFileType,
      name: COMMON_CHUNK_NAME.ImportAliasDefine,
      content: aliasDefineStatements[a],
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport]
    });
  });
  const exportItemList = Object.keys(exportItems).map((k) => exportItems[k]);
  const defaultExport = exportItemList.filter((item) => item.isDefault);
  const otherExports = exportItemList.filter((item) => !item.isDefault);
  const statementL = ["import"];
  if (defaultExport.length > 0) {
    if (useAliasName) {
      statementL.push(defaultExportNames[0]);
    } else {
      statementL.push(defaultExport[0].aliasNames[0]);
    }
    if (otherExports.length > 0) {
      statementL.push(", ");
    }
  }
  if (otherExports.length > 0) {
    const items = otherExports.map((item) => {
      return !useAliasName || item.needOriginExport || item.aliasNames.length <= 0 ? item.exportName : `${item.exportName} as ${item.aliasNames[0]}`;
    });
    statementL.push(`{ ${items.join(", ")} }`);
  }
  statementL.push("from");
  const getInternalDependencyModuleId = () => `@/${deps[0].type}/${pkg}`;
  if (deps[0].dependencyType === "Internal" /* Internal */) {
    statementL.push(`'${getInternalDependencyModuleId()}';`);
    chunks.push({
      type: "string" /* STRING */,
      fileType: targetFileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: statementL.join(" "),
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
  } else {
    statementL.push(`'${pkg}';`);
    chunks.push({
      type: "string" /* STRING */,
      fileType: targetFileType,
      name: COMMON_CHUNK_NAME.ExternalDepsImport,
      content: statementL.join(" "),
      linkAfter: []
    });
  }
  if (defaultExportNames.length > 1) {
    if (deps[0].dependencyType === "Internal" /* Internal */) {
      defaultExportNames.slice(1).forEach((exportName) => {
        chunks.push({
          type: "string" /* STRING */,
          fileType: targetFileType,
          name: COMMON_CHUNK_NAME.InternalDepsImport,
          content: `import ${exportName} from '${getInternalDependencyModuleId()}';`,
          linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
        });
      });
    } else {
      defaultExportNames.slice(1).forEach((exportName) => {
        chunks.push({
          type: "string" /* STRING */,
          fileType: targetFileType,
          name: COMMON_CHUNK_NAME.ExternalDepsImport,
          content: `import ${exportName} from '${pkg}';`,
          linkAfter: []
        });
        chunks.push({
          type: "string" /* STRING */,
          fileType: targetFileType,
          name: COMMON_CHUNK_NAME.ImportAliasDefine,
          content: "",
          linkAfter: [],
          ext: {
            aliasName: exportName,
            originalName: exportName,
            dependency: {
              package: pkg,
              componentName: exportName
            }
          }
        });
      });
    }
  }
  return chunks;
}
var pluginFactory = (config) => {
  const cfg = {
    fileType: "js" /* JS */,
    useAliasName: true,
    ...config || {}
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    if (ir && ir.deps && ir.deps.length > 0) {
      const deps = cfg.filter ? cfg.filter(ir.deps) : ir.deps;
      const packs = groupDepsByPack(deps);
      Object.keys(packs).forEach((pkg) => {
        const chunks = buildPackageImport(pkg, packs[pkg], cfg.fileType, cfg.useAliasName);
        next.chunks.push(...chunks);
      });
    }
    return next;
  };
  return plugin;
};
var esmodule_default = pluginFactory;

// src/plugins/common/styleImport.ts
import changeCase3 from "change-case";
var pluginFactory2 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const { chunks } = next;
    if (ir && ir.deps && ir.deps.length > 0) {
      let lowcodeMaterialsStyleAdded = false;
      let fusionUIStyleAdded = false;
      let nextStyleAddedMap = {};
      ir.deps.forEach((dep) => {
        if (dep.package === "@alifd/next" && !nextStyleAddedMap[dep.exportName]) {
          chunks.push({
            type: "string" /* STRING */,
            fileType: "jsx" /* JSX */,
            name: COMMON_CHUNK_NAME.InternalDepsImport,
            content: `import '@alifd/next/lib/${changeCase3.paramCase(dep.exportName)}/style';`,
            linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
          });
          nextStyleAddedMap[dep.exportName] = true;
        } else if (dep.package === "@alilc/lowcode-materials" && !lowcodeMaterialsStyleAdded) {
          chunks.push({
            type: "string" /* STRING */,
            fileType: "jsx" /* JSX */,
            name: COMMON_CHUNK_NAME.InternalDepsImport,
            content: "import '@alilc/lowcode-materials/lib/style';",
            linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
          });
          lowcodeMaterialsStyleAdded = true;
        } else if (dep.package === "@alifd/fusion-ui" && !fusionUIStyleAdded) {
          chunks.push({
            type: "string" /* STRING */,
            fileType: "jsx" /* JSX */,
            name: COMMON_CHUNK_NAME.InternalDepsImport,
            content: "import '@alifd/fusion-ui/lib/style';",
            linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
          });
          fusionUIStyleAdded = true;
        }
      });
    }
    return next;
  };
  return plugin;
};
var styleImport_default = pluginFactory2;

// src/plugins/component/react/containerClass.ts
import changeCase4 from "change-case";

// src/plugins/component/react/const.ts
var REACT_CHUNK_NAME = {
  ClassRenderStart: "ReactComponentClassRenderStart",
  ClassRenderPre: "ReactComponentClassRenderPre",
  ClassRenderEnd: "ReactComponentClassRenderEnd",
  ClassRenderJSX: "ReactComponentClassRenderJSX",
  ClassDidMountStart: "ReactComponentClassDidMountStart",
  ClassDidMountEnd: "ReactComponentClassDidMountEnd",
  ClassDidMountContent: "ReactComponentClassDidMountContent"
};

// src/plugins/component/react/containerClass.ts
var pluginFactory3 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const componentClassName = ensureValidClassName(
      `${changeCase4.pascalCase(ir.moduleName)}$$${ir.containerType}`
    );
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.Start,
      content: `class ${componentClassName} extends React.Component {`,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine
      ]
    });
    if (ir.containerType === "Component") {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: "jsx" /* JSX */,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: `static displayName = '${ir.moduleName}';`,
        linkAfter: [
          CLASS_DEFINE_CHUNK_NAME.Start
        ]
      });
    }
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.End,
      content: "}",
      linkAfter: [
        ...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.End],
        REACT_CHUNK_NAME.ClassRenderEnd,
        REACT_CHUNK_NAME.ClassDidMountEnd
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.ConstructorStart,
      content: "constructor(props, context) { super(props); ",
      linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorStart]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.ConstructorEnd,
      content: "}",
      linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorEnd]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: REACT_CHUNK_NAME.ClassDidMountStart,
      content: "componentDidMount() {",
      linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.End]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: REACT_CHUNK_NAME.ClassDidMountEnd,
      content: "}",
      linkAfter: [REACT_CHUNK_NAME.ClassDidMountContent, REACT_CHUNK_NAME.ClassDidMountStart]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: REACT_CHUNK_NAME.ClassRenderStart,
      content: "render() {",
      linkAfter: [
        ...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.End],
        REACT_CHUNK_NAME.ClassDidMountEnd
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: REACT_CHUNK_NAME.ClassRenderEnd,
      content: "}",
      linkAfter: [
        REACT_CHUNK_NAME.ClassRenderStart,
        REACT_CHUNK_NAME.ClassRenderPre,
        REACT_CHUNK_NAME.ClassRenderJSX
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.FileExport,
      content: `export default ${componentClassName};`,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine,
        CLASS_DEFINE_CHUNK_NAME.End
      ]
    });
    return next;
  };
  return plugin;
};
var containerClass_default = pluginFactory3;

// src/utils/compositeType.ts
var compositeType_exports = {};
__export(compositeType_exports, {
  generateCompositeType: () => generateCompositeType
});
import {
  isJSExpression as isJSExpression3,
  isJSFunction as isJSFunction3,
  isJSSlot as isJSSlot3
} from "@alilc/lowcode-types";
import _2 from "lodash";

// src/utils/jsExpression.ts
var jsExpression_exports = {};
__export(jsExpression_exports, {
  generateExpression: () => generateExpression,
  generateFunction: () => generateFunction,
  isBroadJSFunction: () => isBroadJSFunction,
  parseExpression: () => parseExpression3,
  parseExpressionGetState: () => parseExpressionGetState
});
import * as parser2 from "@babel/parser";
import generate2 from "@babel/generator";
import traverse2 from "@babel/traverse";
import * as t2 from "@babel/types";
import { isJSExpression as isJSExpression2, isJSFunction as isJSFunction2 } from "@alilc/lowcode-types";

// src/utils/expressionParser.ts
var expressionParser_exports = {};
__export(expressionParser_exports, {
  ParseError: () => ParseError,
  parseExpression: () => parseExpression2,
  parseExpressionConvertThis2Context: () => parseExpressionConvertThis2Context,
  parseExpressionGetGlobalVariables: () => parseExpressionGetGlobalVariables,
  parseExpressionGetKeywords: () => parseExpressionGetKeywords,
  transformExpressionLocalRef: () => transformExpressionLocalRef
});
import * as parser from "@babel/parser";
import generate from "@babel/generator";
import traverse from "@babel/traverse";
import * as t from "@babel/types";
import { isIdentifier } from "@babel/types";

// src/utils/OrderedSet.ts
var OrderedSet = class {
  constructor(items) {
    __publicField(this, "_set", /* @__PURE__ */ new Set());
    __publicField(this, "_arr", []);
    if (items) {
      this._set = new Set(items);
      this._arr = items.slice(0);
    }
  }
  add(item) {
    if (!this._set.has(item)) {
      this._set.add(item);
      this._arr.push(item);
    }
  }
  delete(item) {
    if (this._set.has(item)) {
      this._set.delete(item);
      this._arr.splice(this._arr.indexOf(item), 1);
    }
  }
  has(item) {
    return this._set.has(item);
  }
  toArray() {
    return this._arr.slice(0);
  }
};

// src/utils/expressionParser.ts
var ParseError = class extends Error {
  constructor(expr, detail) {
    super(`Failed to parse expression "${typeof expr === "string" ? expr : generate(expr)}"`);
    __publicField(this, "expr");
    __publicField(this, "detail");
    this.expr = expr;
    this.detail = detail;
    Object.setPrototypeOf(this, new.target.prototype);
  }
};
var MAYBE_EXPRESSIONS = {
  ArrayExpression: { fields: ["elements"] },
  AssignmentExpression: { fields: ["left", "right"] },
  BinaryExpression: { fields: ["left", "right"] },
  CallExpression: { fields: ["arguments", "callee"] },
  ConditionalExpression: { fields: ["test", "consequent", "alternate"] },
  DoWhileStatement: { fields: ["test"] },
  ExpressionStatement: { fields: ["expression"] },
  ForInStatement: { fields: ["right"] },
  ForStatement: { fields: ["init", "test", "update"] },
  IfStatement: { fields: ["test"] },
  LogicalExpression: { fields: ["left", "right"] },
  MemberExpression: {
    fields: (node) => {
      return node.type === "MemberExpression" && node.computed ? ["object", "property"] : ["object"];
    }
  },
  NewExpression: { fields: ["callee", "arguments"] },
  ObjectMethod: {
    fields: (node) => {
      return node.type === "ObjectMethod" && node.computed ? ["key"] : [];
    }
  },
  ObjectProperty: {
    fields: (node) => {
      return node.type === "ObjectProperty" && node.computed ? ["key", "value"] : ["value"];
    }
  },
  ReturnStatement: { fields: ["argument"] },
  SequenceExpression: { fields: ["expressions"] },
  ParenthesizedExpression: { fields: ["expression"] },
  SwitchCase: { fields: ["test"] },
  SwitchStatement: { fields: ["discriminant"] },
  ThrowStatement: { fields: ["argument"] },
  UnaryExpression: { fields: ["argument"] },
  UpdateExpression: { fields: ["argument"] },
  VariableDeclarator: { fields: ["init"] },
  WhileStatement: { fields: ["test"] },
  WithStatement: { fields: ["object"] },
  AssignmentPattern: { fields: ["right"] },
  ArrowFunctionExpression: { fields: ["body"] },
  ClassExpression: { fields: ["superClass"] },
  ClassDeclaration: { fields: ["superClass"] },
  ExportDefaultDeclaration: { fields: ["declaration"] },
  ForOfStatement: { fields: ["right"] },
  ClassMethod: {
    fields: (node) => {
      return node.type === "ClassMethod" && node.computed ? ["key"] : [];
    }
  },
  SpreadElement: { fields: ["argument"] },
  TaggedTemplateExpression: { fields: ["tag"] },
  TemplateLiteral: { fields: ["expressions"] },
  YieldExpression: { fields: ["argument"] },
  AwaitExpression: { fields: ["argument"] },
  OptionalMemberExpression: {
    fields: (node) => {
      return node.type === "OptionalMemberExpression" && node.computed ? ["object", "property"] : ["object"];
    }
  },
  OptionalCallExpression: { fields: ["callee", "arguments"] },
  JSXSpreadAttribute: { fields: ["argument"] },
  BindExpression: { fields: ["object", "callee"] },
  ClassProperty: {
    fields: (node) => {
      return node.type === "ClassProperty" && node.computed ? ["key", "value"] : ["value"];
    }
  },
  PipelineTopicExpression: { fields: ["expression"] },
  PipelineBareFunction: { fields: ["callee"] },
  ClassPrivateProperty: { fields: ["value"] },
  Decorator: { fields: ["expression"] },
  TupleExpression: { fields: ["elements"] },
  TSDeclareMethod: {
    fields: (node) => {
      return node.type === "TSDeclareMethod" && node.computed ? ["key"] : [];
    }
  },
  TSPropertySignature: {
    fields: (node) => {
      return node.type === "TSPropertySignature" && node.computed ? ["key", "initializer"] : ["initializer"];
    }
  },
  TSMethodSignature: {
    fields: (node) => {
      return node.type === "TSMethodSignature" && node.computed ? ["key"] : [];
    }
  },
  TSAsExpression: { fields: ["expression"] },
  TSTypeAssertion: { fields: ["expression"] },
  TSEnumDeclaration: { fields: ["initializer"] },
  TSEnumMember: { fields: ["initializer"] },
  TSNonNullExpression: { fields: ["expression"] },
  TSExportAssignment: { fields: ["expression"] }
};
var CROSS_THIS_SCOPE_TYPE_NODE = {
  ArrowFunctionExpression: false,
  FunctionExpression: true,
  FunctionDeclaration: true,
  ClassDeclaration: true,
  ClassExpression: true,
  ClassBody: true,
  ClassImplements: true,
  ClassMethod: true,
  ClassPrivateMethod: true,
  ClassProperty: true,
  ClassPrivateProperty: true,
  DeclareClass: true
};
var JS_KEYWORDS = ["arguments", "this", "super"];
function parseExpressionGetKeywords(expr) {
  if (!expr) {
    return [];
  }
  try {
    const keywordVars = new OrderedSet();
    const ast = parser.parse(`!(${expr});`, {
      plugins: [
        "jsx"
      ]
    });
    const addIdentifierIfNeeded = (x) => {
      if (typeof x === "object" && isIdentifier(x) && JS_KEYWORDS.includes(x.name)) {
        keywordVars.add(x.name);
      }
    };
    traverse(ast, {
      enter(path) {
        var _a;
        const { node } = path;
        const expressionFields = (_a = MAYBE_EXPRESSIONS[node.type]) == null ? void 0 : _a.fields;
        if (expressionFields) {
          (typeof expressionFields === "function" ? expressionFields(node) : expressionFields).forEach((fieldName) => {
            const fieldValue = node[fieldName];
            if (typeof fieldValue === "object") {
              if (Array.isArray(fieldValue)) {
                fieldValue.forEach((item) => {
                  addIdentifierIfNeeded(item);
                });
              } else {
                addIdentifierIfNeeded(fieldValue);
              }
            }
          });
        }
      }
    });
    return keywordVars.toArray().filter(Boolean);
  } catch (e) {
    throw new ParseError(expr, e);
  }
}
function parseExpressionGetGlobalVariables(expr, { filter = () => true } = {}) {
  if (!expr) {
    return [];
  }
  try {
    const undeclaredVars = new OrderedSet();
    const ast = parser.parse(`!(${expr});`);
    const addUndeclaredIdentifierIfNeeded = (x, path) => {
      if (typeof x === "object" && isIdentifier(x) && !path.scope.hasBinding(x.name)) {
        undeclaredVars.add(x.name);
      }
    };
    traverse(ast, {
      enter(path) {
        var _a;
        const { node } = path;
        const expressionFields = (_a = MAYBE_EXPRESSIONS[node.type]) == null ? void 0 : _a.fields;
        if (expressionFields) {
          (typeof expressionFields === "function" ? expressionFields(node) : expressionFields).forEach((fieldName) => {
            const fieldValue = node[fieldName];
            if (typeof fieldValue === "object") {
              if (Array.isArray(fieldValue)) {
                fieldValue.forEach((item) => {
                  addUndeclaredIdentifierIfNeeded(item, path);
                });
              } else {
                addUndeclaredIdentifierIfNeeded(fieldValue, path);
              }
            }
          });
        }
      }
    });
    return undeclaredVars.toArray().filter(filter);
  } catch (e) {
    throw new ParseError(expr, e);
  }
}
function parseExpressionConvertThis2Context(expr, contextName = "__$$context", localVariables = []) {
  if (!expr) {
    return expr;
  }
  try {
    const exprAst = typeof expr === "string" ? parser.parseExpression(expr) : expr;
    const exprWrapAst = t.expressionStatement(exprAst);
    const fileAst = t.file(t.program([exprWrapAst]));
    const localVariablesSet = new Set(localVariables);
    let thisScopeLevel = CROSS_THIS_SCOPE_TYPE_NODE[exprAst.type] ? -1 : 0;
    traverse(fileAst, {
      enter(path) {
        if (CROSS_THIS_SCOPE_TYPE_NODE[path.node.type]) {
          thisScopeLevel++;
        }
      },
      exit(path) {
        if (CROSS_THIS_SCOPE_TYPE_NODE[path.node.type]) {
          thisScopeLevel--;
        }
      },
      MemberExpression(path) {
        if (!path.isMemberExpression()) {
          return;
        }
        const obj = path.get("object");
        if (!obj.isThisExpression()) {
          return;
        }
        if (!path.node.computed) {
          const prop = path.get("property");
          if (prop.isIdentifier() && localVariablesSet.has(prop.node.name)) {
            path.replaceWith(t.identifier(prop.node.name));
            return;
          }
        }
        if (thisScopeLevel <= 0) {
          obj.replaceWith(t.identifier(contextName));
        }
      },
      ThisExpression(path) {
        if (!path.isThisExpression()) {
          return;
        }
        if (path.parent.type === "MemberExpression") {
          return;
        }
        if (thisScopeLevel <= 0) {
          path.replaceWith(t.identifier(contextName));
        }
      }
    });
    const { code } = generate(exprWrapAst.expression, { sourceMaps: false });
    return code;
  } catch (e) {
    throw new ParseError(expr, e);
  }
}
function parseExpression2(expr) {
  try {
    return parser.parseExpression(expr);
  } catch (e) {
    throw new ParseError(expr, e);
  }
}
function transformExpressionLocalRef(expr, scope) {
  if (!expr) {
    return expr;
  }
  if (!scope) {
    throw new Error("transform expression without scope");
  }
  try {
    const exprAst = typeof expr === "string" ? parser.parseExpression(expr) : expr;
    const exprWrapAst = t.expressionStatement(exprAst);
    const fileAst = t.file(t.program([exprWrapAst]));
    traverse(fileAst, {
      MemberExpression(path) {
        if (!path.isMemberExpression()) {
          return;
        }
        const obj = path.get("object");
        if (!obj.isThisExpression()) {
          return;
        }
        const prop = path.get("property");
        let memberName = "";
        if (!path.node.computed && prop.isIdentifier()) {
          memberName = prop.node.name;
        } else if (path.node.computed && prop.isStringLiteral()) {
          memberName = prop.node.value;
        }
        if (memberName && scope.bindings && scope.bindings.hasBinding(memberName)) {
          path.replaceWith(t.identifier(memberName));
        }
      }
    });
    const { code } = generate(exprWrapAst.expression, { sourceMaps: false });
    return code;
  } catch (e) {
    throw new ParseError(expr, e);
  }
}

// src/utils/changeCase.ts
function toFirstUpperCase(str) {
  let name = str.toLowerCase();
  return name.charAt(0).toUpperCase() + name.slice(1);
}
function lineToUppercase(str) {
  if (!str) {
    return "";
  }
  function upper(all, letter) {
    return letter.toUpperCase();
  }
  return str.replace(/_(\w)/g, upper);
}

// src/utils/jsExpression.ts
function parseFunction(content, isToVue, isBelongTemplate = false) {
  try {
    const ast = parser2.parse(`(${content});`, {
      plugins: ["jsx"]
    });
    let resultNode = null;
    traverse2(ast, {
      FunctionExpression(path) {
        resultNode = path.node;
      },
      CallExpression(path) {
        if (isToVue) {
          convertSetState(path, isBelongTemplate);
        }
      },
      MemberExpression(path) {
        if (isToVue) {
          convertState(path, isBelongTemplate);
        }
      }
    });
    return resultNode;
  } catch (e) {
    throw new ParseError(content, e);
  }
}
function transformFuncExpr2MethodMember(methodName, content, isToVue, isBelongTemplate) {
  const funcNode = parseFunction(content, isToVue, isBelongTemplate);
  if (funcNode) {
    const targetNode = t2.classMethod(
      "method",
      methodName && t2.identifier(methodName) || funcNode.id || t2.identifier("notDefineName"),
      funcNode.params,
      funcNode.body,
      void 0,
      void 0,
      void 0,
      funcNode.async || void 0
    );
    const { code: resultCode } = generate2(targetNode, { sourceMaps: false });
    return resultCode;
  }
  throw new Error("Can not find Function Statement");
}
function getArrowFunction(content) {
  const funcNode = parseFunction(content);
  if (funcNode) {
    const targetNode = t2.arrowFunctionExpression(
      funcNode.params,
      funcNode.body,
      funcNode.async || void 0
    );
    const { code: resultCode } = generate2(targetNode, { sourceMaps: false });
    return resultCode;
  }
  throw new Error("Can not find Function Statement");
}
function getBodyStatements(content, isToVue, isBelongTemplate) {
  const funcNode = parseFunction(content, isToVue, isBelongTemplate);
  if (funcNode) {
    const statements = funcNode.body.body;
    const targetNode = t2.program(statements, void 0, "module", void 0);
    const { code: resultCode } = generate2(targetNode, { sourceMaps: false });
    return resultCode;
  }
  throw new Error("Can not find Function Statement");
}
function isBroadJSFunction(value) {
  return isJSExpressionFn(value) || isJSFunction2(value);
}
function generateExpression(value, scope) {
  if (isJSExpression2(value)) {
    const exprVal = value.value.trim();
    if (!exprVal) {
      return "null";
    }
    const afterProcessWithLocals = getExpressionBody(exprVal, true, true, true);
    return afterProcessWithLocals;
  }
  throw new CodeGeneratorError("Not a JSExpression");
}
function getFunctionSource(cfg) {
  return cfg.source || cfg.value || cfg.compiled;
}
function generateFunction(value, config = {
  name: void 0,
  isMember: false,
  isBlock: false,
  isArrow: false,
  isBindExpr: false,
  isToVue: false,
  isDeleteLastSemicolon: false,
  isBelongTemplate: false
}) {
  function extractFunctionCalls(str) {
    const regex = /(\w+)\.apply\(\w+,\s*Array\.prototype\.slice\.call\(arguments\)\.concat\(\[(.*?)\]\)/g;
    const matches = [];
    let match;
    while ((match = regex.exec(str)) !== null) {
      const functionName = match[1];
      let params = match[2].replace(/"([a-zA-Z0-9_]+)":/g, "'$1':").replace(/:"([^"]+)"/g, ":'$1'");
      matches.push(`${functionName}(${params})`);
    }
    return matches;
  }
  if (isBroadJSFunction(value)) {
    const functionCfg = value;
    const functionSource = getFunctionSource(functionCfg);
    if (config.isMember) {
      return transformFuncExpr2MethodMember(config.name || "", functionSource, config.isToVue, config.isBelongTemplate);
    }
    if (config.isBlock) {
      return getBodyStatements(functionSource, config.isToVue, config.isBelongTemplate);
    }
    if (config.isArrow) {
      return getArrowFunction(functionSource);
    }
    if (config.isBindExpr) {
      return `${extractFunctionCalls(functionSource)}`;
    }
    return functionSource;
  }
  if (isJSExpression2(value)) {
    if (config.isToVue) {
      return getExpressionBody(value.value, config.isToVue, config.isDeleteLastSemicolon, config.isBelongTemplate);
    }
    return value.value;
  }
  throw new CodeGeneratorError("Not a JSFunction or JSExpression");
}
function convertSetState(path, isBelongTemplate) {
  var _a;
  const node = path.node;
  if (node.callee.type === "MemberExpression" && node.callee.object.type === "ThisExpression" && node.callee.property.name === "setState") {
    const args = node.arguments[0].properties;
    const stateFunction = node.arguments[1];
    const expressionStatementArray = [];
    args.forEach((arg) => {
      if (arg.key.type == "Identifier") {
        arg.key.name = lineToUppercase(arg.key.name);
      }
      if (arg.key.type == "Literal" || arg.key.type == "StringLiteral") {
        arg.key.value = lineToUppercase(arg.key.value);
        arg.key = t2.identifier(arg.key.value);
      }
      let left1 = t2.memberExpression(t2.thisExpression(), arg.key, true);
      if (!isBelongTemplate) {
        left1 = t2.memberExpression(left1, t2.identifier("value"));
      }
      const assignment = t2.assignmentExpression("=", left1, arg.value);
      expressionStatementArray.push(t2.expressionStatement(assignment));
    });
    if (stateFunction) {
      const functionBody = (_a = stateFunction.body) == null ? void 0 : _a.body;
      expressionStatementArray.push(...functionBody);
    }
    const expressionStatementPath = path.parentPath;
    expressionStatementPath.replaceWithMultiple(expressionStatementArray);
  }
}
function convertState(path, isBelongTemplate) {
  const node = path.node;
  if (node.object.type === "ThisExpression" && node.property.name === "state") {
    const parentPath = path.parentPath;
    const parentNode = parentPath.node;
    const name = lineToUppercase(parentNode.property.value || parentNode.property.name);
    if (isBelongTemplate) {
      parentPath.replaceWith(t2.identifier(name));
    } else {
      parentPath.replaceWith(t2.memberExpression(t2.identifier(name), t2.identifier("value")));
    }
  } else if (node.object.type === "ThisExpression") {
    path.replaceWith(node.property);
  }
}
function getStateName(path) {
  const node = path.node;
  if (!(node.object.type === "ThisExpression") || !(node.property.name === "state")) {
    return "";
  }
  const parentPath = path.parentPath;
  const parentNode = parentPath.node;
  return lineToUppercase(parentNode.property.value || parentNode.property.name);
}
function parseExpression3(content, isToVue, isBelongTemplate) {
  try {
    const ast = parser2.parse(`(${content})`, {
      plugins: ["jsx"]
    });
    let resultNode = ast;
    traverse2(ast, {
      MemberExpression(path) {
        if (isToVue) {
          convertState(path, isBelongTemplate);
        }
      }
    });
    return resultNode;
  } catch (e) {
    throw new ParseError(content, e);
  }
}
function parseExpressionGetState(content) {
  try {
    const ast = parser2.parse(`(${content})`, {
      plugins: ["jsx"]
    });
    const refSet = /* @__PURE__ */ new Set();
    traverse2(ast, {
      MemberExpression(path) {
        refSet.add(getStateName(path));
      }
    });
    return refSet;
  } catch (e) {
    throw new ParseError(content, e);
  }
}
function getExpressionBody(content, isToVue, isDeleteLastSemicolon, isBelongTemplate) {
  const funcNode = parseExpression3(content, isToVue, isBelongTemplate);
  if (funcNode) {
    const { code: resultCode } = generate2(funcNode, { sourceMaps: false });
    if (resultCode) {
      if (isDeleteLastSemicolon && resultCode.endsWith(";")) {
        return resultCode.slice(0, -1);
      }
    }
    return resultCode;
  }
  throw new Error("Can not find Function Statement");
}

// src/utils/jsSlot.ts
var jsSlot_exports = {};
__export(jsSlot_exports, {
  generateJsSlot: () => generateJsSlot
});
import { isJSSlot as isJSSlot2 } from "@alilc/lowcode-types";

// src/utils/jsxHelpers.ts
function unwrapJsExprQuoteInJsx(jsxExpr) {
  if (jsxExpr.length >= 2 && jsxExpr[0] === "{" && jsxExpr[jsxExpr.length - 1] === "}") {
    return jsxExpr.slice(1, jsxExpr.length - 1);
  }
  return jsxExpr;
}

// src/utils/jsSlot.ts
function generateSingleLineComment(commentText) {
  return `/* ${commentText.split("\n").join(" ").replace(/\*\//g, "*-/")}*/`;
}
function generateJsSlot(slot, scope, generator) {
  if (isJSSlot2(slot)) {
    const { title, params, value } = slot;
    const slotScope = params ? scope.createSubScope(params || []) : scope;
    const contentExpr = !value ? "null" : generateNodeDataOrArrayForJsSlot(value, generator, slotScope);
    if (params) {
      return [
        title && generateSingleLineComment(title),
        "(",
        (params || []).join(", "),
        ") => ((__$$context) => (",
        contentExpr,
        "))(",
        `  __$$createChildContext(__$$context, { ${(params || []).join(", ")} }`,
        "))"
      ].filter(Boolean).join("");
    }
    return contentExpr || "[]";
  }
  throw new CodeGeneratorError("Not a JSSlot");
}
function generateNodeDataOrArrayForJsSlot(value, generator, scope) {
  if (Array.isArray(value)) {
    if (value.length === 0) {
      return "[]";
    }
    if (value.length === 1) {
      return unwrapJsExprQuoteInJsx(generator(value, scope)) || "null";
    }
    return `[
${value.map((v) => {
      if (typeof v === "string") {
        return JSON.stringify(v);
      }
      return unwrapJsExprQuoteInJsx(generator(v, scope)) || "null";
    }).join(",\n") || "null"}
]`;
  }
  return unwrapJsExprQuoteInJsx(generator(value, scope)) || "null";
}

// src/utils/aopHelper.ts
function executeFunctionStack(input, scope, funcs, baseFunc, config) {
  const funcList = [];
  if (Array.isArray(funcs)) {
    funcList.push(...funcs);
  } else {
    funcList.push(funcs);
  }
  let next = baseFunc;
  while (funcList.length > 0) {
    const func = funcList.pop();
    if (func) {
      const warppedFunc = ((nextFunc) => (i, s, cfg) => func(i, s, cfg, nextFunc))(next);
      next = warppedFunc;
    }
  }
  return next(input, scope, config);
}

// src/utils/compositeType.ts
function isVariable(v) {
  if (_2.isObject(v) && v.type === "variable") {
    return true;
  }
  return false;
}
function isDataSource(v) {
  return typeof v === "object" && v != null && v.type === "DataSource";
}
function generateArray(value, scope, options = {}) {
  const body = value.map((v) => generateUnknownType(v, scope, options)).join(",");
  return `[${body}]`;
}
function generateObject(value, scope, options = {}) {
  if (value.type === "i18n") {
    if (value.params && typeof value.params === "object") {
      return `this._i18nText(${generateUnknownType(_2.omit(value, "type"), scope, options)})`;
    }
    return `this._i18nText(${JSON.stringify(_2.omit(value, "type"))})`;
  }
  const body = Object.keys(value).map((key) => {
    const propName = key;
    const v = generateUnknownType(value[key], scope, options);
    return `${propName}: ${v}`;
  }).join(",");
  return `{${body}}`;
}
function generateString(value) {
  const escapeString = (val) => {
    return JSON.stringify(val).slice(1, -1);
  };
  const data = escapeString(value);
  console.log(data);
  return `'${escapeString(value)}'`;
}
function generateNumber(value) {
  return String(value);
}
function generateBool(value) {
  return value ? "true" : "false";
}
function genFunction(value) {
  const globalVars = parseExpressionGetKeywords(value.value);
  if (globalVars.includes("arguments")) {
    return generateFunction(value, { isBindExpr: true });
  }
  return generateFunction(value, { isArrow: true });
}
function genJsSlot(value, scope, options = {}) {
  if (options.nodeGenerator) {
    return generateJsSlot(value, scope, options.nodeGenerator);
  }
  return "";
}
function generateUnknownType(value, scope, options = {}) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i;
  if (_2.isUndefined(value)) {
    return "undefined";
  }
  if (_2.isNull(value)) {
    return "null";
  }
  if (_2.isArray(value)) {
    if ((_a = options.handlers) == null ? void 0 : _a.array) {
      return executeFunctionStack(value, scope, options.handlers.array, generateArray, options);
    }
    return generateArray(value, scope, options);
  }
  if (isVariable(value)) {
    const transValue = {
      type: "JSExpression",
      value: value.variable
    };
    if ((_b = options.handlers) == null ? void 0 : _b.expression) {
      const expression = executeFunctionStack(
        transValue,
        scope,
        options.handlers.expression,
        generateExpression,
        options
      );
      return expression || "undefined";
    }
    return generateExpression(transValue, scope);
  }
  if (isJSExpression3(value)) {
    if ((_c = options.handlers) == null ? void 0 : _c.expression) {
      return executeFunctionStack(
        value,
        scope,
        options.handlers.expression,
        generateExpression,
        options
      );
    }
    return generateExpression(value, scope);
  }
  if (isJSFunction3(value) || isJSExpressionFn(value)) {
    if ((_d = options.handlers) == null ? void 0 : _d.function) {
      return executeFunctionStack(value, scope, options.handlers.function, genFunction, options);
    }
    return genFunction(value);
  }
  if (isJSSlot3(value)) {
    if ((_e = options.handlers) == null ? void 0 : _e.slot) {
      return executeFunctionStack(value, scope, options.handlers.slot, genJsSlot, options);
    }
    return genJsSlot(value, scope, options);
  }
  if (isDataSource(value)) {
    return generateUnknownType(
      {
        type: "JSExpression",
        value: `this.dataSourceMap[${JSON.stringify(value.id)}]`
      },
      scope,
      options
    );
  }
  if (_2.isObject(value)) {
    if ((_f = options.handlers) == null ? void 0 : _f.object) {
      return executeFunctionStack(value, scope, options.handlers.object, generateObject, options);
    }
    return generateObject(value, scope, options);
  }
  if (_2.isString(value)) {
    if ((_g = options.handlers) == null ? void 0 : _g.string) {
      return executeFunctionStack(value, scope, options.handlers.string, generateString, options);
    }
    return generateString(value);
  }
  if (_2.isNumber(value)) {
    if ((_h = options.handlers) == null ? void 0 : _h.number) {
      return executeFunctionStack(value, scope, options.handlers.number, generateNumber, options);
    }
    return generateNumber(value);
  }
  if (_2.isBoolean(value)) {
    if ((_i = options.handlers) == null ? void 0 : _i.boolean) {
      return executeFunctionStack(value, scope, options.handlers.boolean, generateBool, options);
    }
    return generateBool(value);
  }
  throw new CodeGeneratorError("Meet unknown composite value type");
}
function generateCompositeType(value, scope, options = {}) {
  const result = generateUnknownType(value, scope, options);
  return result;
}

// src/utils/Scope.ts
var Scope_exports = {};
__export(Scope_exports, {
  Scope: () => Scope
});

// src/utils/ScopeBindings.ts
var ScopeBindings = class {
  constructor(p = null) {
    __publicField(this, "parent");
    __publicField(this, "_bindings", new OrderedSet());
    this.parent = p;
  }
  hasBinding(varName) {
    var _a;
    return this._bindings.has(varName) || !!((_a = this.parent) == null ? void 0 : _a.hasBinding(varName));
  }
  hasOwnBinding(varName) {
    return this._bindings.has(varName);
  }
  addBinding(varName) {
    this._bindings.add(varName);
  }
  removeBinding(varName) {
    this._bindings.delete(varName);
  }
  getAllBindings() {
    const allBindings = new OrderedSet(this._bindings.toArray());
    for (let { parent } = this; parent; parent = parent == null ? void 0 : parent.parent) {
      parent.getAllOwnedBindings().forEach((varName) => {
        allBindings.add(varName);
      });
    }
    return allBindings.toArray();
  }
  getAllOwnedBindings() {
    return this._bindings.toArray();
  }
};

// src/utils/Scope.ts
var Scope = class {
  constructor(parent = null) {
    this.parent = parent;
    __publicField(this, "bindings");
    this.bindings = void 0;
  }
  static createRootScope() {
    return new Scope();
  }
  createSubScope(ownIdentifiers) {
    const originalScopeBindings = this.bindings;
    const newScopeBindings = new ScopeBindings(originalScopeBindings);
    ownIdentifiers.forEach((identifier3) => {
      newScopeBindings.addBinding(identifier3);
    });
    const newScope = new Scope(this);
    newScope.bindings = newScopeBindings;
    return newScope;
  }
};

// src/plugins/component/react/containerInitState.ts
var pluginFactory4 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    implementType: "inConstructor",
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const scope = Scope.createRootScope();
    const state = ir.state || {};
    const fields = Object.keys(state).map((stateName) => {
      const value = generateCompositeType(state[stateName], scope);
      return `${stateName}: ${value},`;
    });
    if (cfg.implementType === "inConstructor") {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
        content: `this.state = { ${fields.join("")} };`,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorContent]]
      });
    } else if (cfg.implementType === "insMember") {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: `state = { ${fields.join("")} };`,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsVar]]
      });
    }
    return next;
  };
  return plugin;
};
var containerInitState_default = pluginFactory4;

// src/plugins/component/react/containerInjectContext.ts
var pluginFactory5 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const scope = Scope.createRootScope();
    const { inStrictMode } = next.contextData;
    if (!inStrictMode) {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: `
          _context = this;
        `,
        linkAfter: [CLASS_DEFINE_CHUNK_NAME.Start]
      });
    } else {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: `
          _context = this._createContext();
        `,
        linkAfter: [CLASS_DEFINE_CHUNK_NAME.Start]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
        content: `
          _createContext() {
            const self = this;
            const context = {
              get state() { return self.state; },
              setState(newState, callback) { self.setState(newState, callback); },
              get dataSourceMap() { return self._dataSourceEngine.dataSourceMap || {}; },
              async reloadDataSource() { await self._dataSourceEngine.reloadDataSource(); },
              get utils() { return self.utils; },
              get page() { return context; },
              get component() { return context; },
              get props() { return self.props; },
              get constants() { return self.constants; },
              get $() { return self.$ },
              get $$() { return self.$$ },
              ...this._methods,
            };
  
            return context;
          }
        `,
        linkAfter: DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod]
      });
    }
    return next;
  };
  return plugin;
};
var containerInjectContext_default = pluginFactory5;

// src/utils/pathHelper.ts
var pathHelper_exports = {};
__export(pathHelper_exports, {
  getSlotRelativePath: () => getSlotRelativePath
});
function relativePath(from, to) {
  const length = Math.min(from.length, to.length);
  let samePartsLength = length;
  for (let i = 0; i < length; i++) {
    if (from[i] !== to[i]) {
      samePartsLength = i;
      break;
    }
  }
  if (samePartsLength === 0) {
    return to;
  }
  let outputParts = [];
  for (let i = samePartsLength; i < from.length; i++) {
    outputParts.push("..");
  }
  outputParts = [...outputParts, ...to.slice(samePartsLength)];
  if (outputParts[0] !== "..") {
    outputParts.unshift(".");
  }
  return outputParts;
}
function getSlotRelativePath(options) {
  var _a, _b, _c;
  const { contextData, from, to } = options;
  const isSingleComponent = (_b = (_a = contextData == null ? void 0 : contextData.extraContextData) == null ? void 0 : _a.projectRemark) == null ? void 0 : _b.isSingleComponent;
  const template = (_c = contextData == null ? void 0 : contextData.extraContextData) == null ? void 0 : _c.template;
  let toPath = template.slots[to].path;
  toPath = [...toPath, template.slots[to].fileName];
  let fromPath = template.slots[from].path;
  if (!isSingleComponent && ["components", "pages"].indexOf(from) !== -1) {
    fromPath = [...fromPath, "pageName"];
  }
  return relativePath(fromPath, toPath).join("/");
}

// src/plugins/component/react/containerInjectUtils.ts
var pluginFactory6 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    var _a;
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.contextData.useRefApi = true;
    const useRef = !!((_a = ir.analyzeResult) == null ? void 0 : _a.isUsingRef);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: `
        import utils${useRef ? ", { RefsManager }" : ""} from '${getSlotRelativePath({ contextData: next.contextData, from: "components", to: "utils" })}';
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    if (cfg.preferClassProperty) {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: "utils = utils;",
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsVar]]
      });
    } else {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
        content: "this.utils = utils;",
        linkAfter: [CLASS_DEFINE_CHUNK_NAME.ConstructorStart]
      });
    }
    if (useRef) {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
        content: "this._refsManager = new RefsManager();",
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorContent]]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsMethod,
        content: `
          $ = (refName) => {
            return this._refsManager.get(refName);
          }
        `,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsMethod]]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsMethod,
        content: `
          $$ = (refName) => {
            return this._refsManager.getAll(refName);
          }
        `,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsMethod]]
      });
    } else {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsMethod,
        content: " $ = () => null; ",
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsMethod]]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsMethod,
        content: " $$ = () => [];        ",
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsMethod]]
      });
    }
    return next;
  };
  return plugin;
};
var containerInjectUtils_default = pluginFactory6;

// src/plugins/component/react/containerInjectDataSourceEngine.ts
import {
  isJSExpression as isJSExpression4,
  isJSFunction as isJSFunction4
} from "@alilc/lowcode-types";
import changeCase5 from "change-case";
var pluginFactory7 = (config) => {
  const cfg = {
    ...config,
    fileType: (config == null ? void 0 : config.fileType) || "jsx" /* JSX */
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const scope = Scope.createRootScope();
    const dataSourceConfig = isValidContainerType(pre.ir) ? pre.ir.dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    const dataSourceEngineOptions = { runtimeConfig: true };
    if (dataSourceItems.length > 0) {
      const requestHandlersMap = {};
      dataSourceItems.forEach((ds) => {
        var _a, _b;
        const dsType = ds.type || "fetch";
        if (!(dsType in requestHandlersMap) && dsType !== "custom") {
          const handlerFactoryName = `__$$create${changeCase5.pascal(dsType)}RequestHandler`;
          requestHandlersMap[dsType] = {
            type: "JSExpression",
            value: handlerFactoryName + (dsType === "urlParams" ? "(window.location.search)" : "()")
          };
          const handlerFactoryExportName = `create${changeCase5.pascal(dsType)}Handler`;
          const handlerPkgName = ((_b = (_a = cfg.datasourceConfig) == null ? void 0 : _a.handlersPackages) == null ? void 0 : _b[dsType]) || `@alilc/lowcode-datasource-${changeCase5.kebab(dsType)}-handler`;
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "jsx" /* JSX */,
            name: COMMON_CHUNK_NAME.ExternalDepsImport,
            content: `
              import { ${handlerFactoryExportName} as ${handlerFactoryName} } from '${handlerPkgName}';
            `,
            linkAfter: []
          });
        }
      });
      Object.assign(dataSourceEngineOptions, { requestHandlersMap });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: "jsx" /* JSX */,
        name: COMMON_CHUNK_NAME.ExternalDepsImport,
        content: `
          import { create as __$$createDataSourceEngine } from '@alilc/lowcode-datasource-engine/runtime';
        `,
        linkAfter: []
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: `
          _dataSourceConfig = this._defineDataSourceConfig();
          _dataSourceEngine = __$$createDataSourceEngine(
            this._dataSourceConfig,
            this,
            ${generateCompositeType(dataSourceEngineOptions, scope)}
          );

          get dataSourceMap() {
            return this._dataSourceEngine.dataSourceMap || {};
          }

          reloadDataSource = async () => {
            await this._dataSourceEngine.reloadDataSource();
          }

          `,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsVar]]
      });
      next.chunks.unshift({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: REACT_CHUNK_NAME.ClassDidMountContent,
        content: `
          this._dataSourceEngine.reloadDataSource();
        `,
        linkAfter: [REACT_CHUNK_NAME.ClassDidMountStart]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsMethod,
        content: `
  _defineDataSourceConfig() {
    const _this = this;
    return (${generateCompositeType(
          {
            ...dataSourceConfig,
            list: [
              ...dataSourceItems.map((item) => ({
                ...item,
                isInit: wrapAsFunction(item.isInit, scope),
                options: wrapAsFunction(item.options, scope)
              }))
            ]
          },
          scope,
          {
            handlers: {
              function: (jsFunc) => parseExpressionConvertThis2Context(jsFunc.value, "_this"),
              expression: (jsExpr) => parseExpressionConvertThis2Context(jsExpr.value, "_this")
            }
          }
        )});
  }
        `,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsMethod]]
      });
    }
    return next;
  };
  return plugin;
};
var containerInjectDataSourceEngine_default = pluginFactory7;
function wrapAsFunction(value, scope) {
  if (isJSExpression4(value) || isJSFunction4(value) || isJSExpressionFn(value)) {
    return {
      type: "JSExpression",
      value: `function(){ return ((${value.value}))}.bind(this)`
    };
  }
  return {
    type: "JSExpression",
    value: `function(){return((${generateCompositeType(value, scope)}))}.bind(this)`
  };
}

// src/plugins/component/react/containerInjectConstants.ts
var pluginFactory8 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: "import __$$constants from '../../constants';",
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsVar,
      content: `
        get constants() {
          return __$$constants || {};
        }
        `,
      linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsVar]]
    });
    return next;
  };
  return plugin;
};
var containerInjectConstants_default = pluginFactory8;

// src/plugins/component/react/containerInjectI18n.ts
var pluginFactory9 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: `
        import * as __$$i18n from '${getSlotRelativePath({ contextData: next.contextData, from: "components", to: "i18n" })}';
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
      content: `
        __$$i18n._inject2(this);
      `,
      linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorContent]]
    });
    return next;
  };
  return plugin;
};
var containerInjectI18n_default = pluginFactory9;

// src/plugins/component/react/containerLifeCycle.ts
import { isJSFunction as isJSFunction5, isJSExpression as isJSExpression5 } from "@alilc/lowcode-types";
var pluginFactory10 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    exportNameMapping: {},
    normalizeNameMapping: {},
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    if (ir.lifeCycles) {
      const { lifeCycles } = ir;
      const chunks = Object.keys(lifeCycles).map((lifeCycleName) => {
        var _a;
        if (!isJSFunction5(lifeCycles[lifeCycleName]) && !isJSExpressionFn(lifeCycles[lifeCycleName]) && !isJSExpression5(lifeCycles[lifeCycleName])) {
          return null;
        }
        let normalizeName;
        if (lifeCycleName === "constructor") {
          normalizeName = lifeCycleName;
        } else {
          normalizeName = cfg.normalizeNameMapping[lifeCycleName] || lifeCycleName;
        }
        if ((_a = cfg == null ? void 0 : cfg.exclude) == null ? void 0 : _a.includes(normalizeName)) {
          return null;
        }
        const exportName = cfg.exportNameMapping[lifeCycleName] || lifeCycleName;
        if (normalizeName === "constructor") {
          return {
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
            content: generateFunction(lifeCycles[lifeCycleName], { isBlock: true }),
            linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorStart]]
          };
        }
        if (normalizeName === "componentDidMount") {
          return {
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: REACT_CHUNK_NAME.ClassDidMountContent,
            content: generateFunction(lifeCycles[lifeCycleName], { isBlock: true }),
            linkAfter: [REACT_CHUNK_NAME.ClassDidMountStart]
          };
        }
        if (normalizeName === "render") {
          return {
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: REACT_CHUNK_NAME.ClassRenderPre,
            content: generateFunction(lifeCycles[lifeCycleName], { isBlock: true }),
            linkAfter: [REACT_CHUNK_NAME.ClassRenderStart]
          };
        }
        return {
          type: "string" /* STRING */,
          fileType: cfg.fileType,
          name: CLASS_DEFINE_CHUNK_NAME.InsMethod,
          content: generateFunction(lifeCycles[lifeCycleName], {
            name: exportName,
            isMember: true
          }),
          linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsMethod]]
        };
      }).filter((i) => !!i);
      next.chunks.push(...chunks.filter((x) => x !== null));
    }
    return next;
  };
  return plugin;
};
var containerLifeCycle_default = pluginFactory10;

// src/plugins/component/react/containerMethod.ts
var pluginFactory11 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const { inStrictMode } = next.contextData;
    if (!ir.methods) {
      return next;
    }
    const { methods } = ir;
    const chunks = Object.keys(methods).map((methodName) => ({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsMethod,
      content: generateFunction(methods[methodName], { name: methodName, isMember: true }),
      linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsMethod]]
    }));
    next.chunks.push(...chunks);
    if (inStrictMode) {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
        content: Object.keys(ir.methods).map(
          (methodName) => isValidIdentifier(methodName) ? `.${methodName}` : `[${JSON.stringify(methodName)}]`
        ).map((method) => `this._context${method} = this${method};`).join("\n"),
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorContent]]
      });
    }
    return next;
  };
  return plugin;
};
var containerMethod_default = pluginFactory11;

// src/utils/nodeToJSX.ts
var nodeToJSX_exports = {};
__export(nodeToJSX_exports, {
  createNodeGenerator: () => createNodeGenerator,
  createReactNodeGenerator: () => createReactNodeGenerator,
  generateConditionReactCtrl: () => generateConditionReactCtrl,
  generateReactExprInJS: () => generateReactExprInJS,
  generateReactLoopCtrl: () => generateReactLoopCtrl,
  isPureString: () => isPureString
});
import _4 from "lodash";
import { pipe } from "fp-ts/function";
import { isNodeSchema as isNodeSchema2 } from "@alilc/lowcode-types";

// src/utils/encodeJsxAttrString.ts
import _3 from "lodash";
var SPECIAL_CHARS = `
\r'"<>&`;
var SPECIAL_CHARS_REG = new RegExp(
  `[${SPECIAL_CHARS.split("").map((c) => `\\x${_3.padStart(c.charCodeAt(0).toString(16), 2, "0")}`).join("")}]`,
  "g"
);
function encodeJsxStringNode(str) {
  return str.replace(SPECIAL_CHARS_REG, (c) => `&#${c.charCodeAt(0)};`);
}

// src/core/jsx/handlers/transformThis2Context.ts
import generate3 from "@babel/generator";
function transformThis2Context(expr, scope, { ignoreRootScope = false } = {}) {
  var _a;
  if (ignoreRootScope && scope.parent == null) {
    return typeof expr === "string" ? expr : generate3(expr).code;
  }
  return parseExpressionConvertThis2Context(
    expr,
    "__$$context",
    ((_a = scope.bindings) == null ? void 0 : _a.getAllBindings()) || []
  );
}

// src/utils/nodeToJSX.ts
function mergeNodeGeneratorConfig(cfg1, cfg2 = {}) {
  const resCfg = {};
  if (cfg1.handlers || cfg2.handlers) {
    resCfg.handlers = {
      ...cfg1.handlers || {},
      ...cfg2.handlers || {}
    };
  }
  if (cfg1.tagMapping || cfg2.tagMapping) {
    resCfg.tagMapping = cfg2.tagMapping || cfg1.tagMapping;
  }
  if (cfg1.attrPlugins || cfg2.attrPlugins) {
    resCfg.attrPlugins = [];
    resCfg.attrPlugins.push(...cfg2.attrPlugins || []);
    resCfg.attrPlugins.push(...cfg1.attrPlugins || []);
  }
  if (cfg1.nodePlugins || cfg2.nodePlugins) {
    resCfg.nodePlugins = [];
    resCfg.nodePlugins.push(...cfg2.nodePlugins || []);
    resCfg.nodePlugins.push(...cfg1.nodePlugins || []);
  }
  return resCfg;
}
function isPureString(v) {
  return v[0] === "'" && v[v.length - 1] === "'" || v[0] === '"' && v[v.length - 1] === '"';
}
function generateAttrValue(attrData, scope, config) {
  const valueStr = generateCompositeType(attrData.attrValue, scope, {
    handlers: config == null ? void 0 : config.handlers,
    nodeGenerator: config == null ? void 0 : config.self
  });
  return [
    {
      type: "NodeCodePieceAttr" /* ATTR */,
      name: attrData.attrName,
      value: valueStr
    }
  ];
}
function generateAttr(attrName, attrValue, scope, config) {
  let pieces;
  if (config == null ? void 0 : config.attrPlugins) {
    pieces = executeFunctionStack(
      { attrName, attrValue },
      scope,
      config.attrPlugins,
      generateAttrValue,
      config
    );
  } else {
    pieces = generateAttrValue({ attrName, attrValue }, scope, config);
  }
  pieces = pieces.map((p) => {
    let newValue;
    if (p.value && isPureString(p.value)) {
      const content = getStaticExprValue(p.value);
      newValue = JSON.stringify(encodeJsxStringNode(content));
    } else {
      newValue = `{${p.value}}`;
    }
    return {
      value: `${p.name}=${newValue}`,
      type: "NodeCodePieceAttr" /* ATTR */
    };
  });
  return pieces;
}
function generateAttrs(nodeItem, scope, config) {
  const { props } = nodeItem;
  let pieces = [];
  if (props) {
    if (!Array.isArray(props)) {
      Object.keys(props).forEach((propName) => {
        if (isValidIdentifier(propName)) {
          pieces = pieces.concat(generateAttr(propName, props[propName], scope, config));
        }
      });
    } else {
      props.forEach((prop) => {
        if (prop.name && isValidIdentifier(prop.name) && !prop.spread) {
          pieces = pieces.concat(generateAttr(prop.name, prop.value, scope, config));
        }
      });
    }
  }
  return pieces;
}
function generateBasicNode(nodeItem, scope, config) {
  const pieces = [];
  const tagName = ((config == null ? void 0 : config.tagMapping) || _4.identity)(nodeItem.componentName);
  pieces.push({
    value: tagName || "",
    type: "NodeCodePieceTag" /* TAG */
  });
  return pieces;
}
function generateSimpleNode(nodeItem, scope, config) {
  const basicParts = generateBasicNode(nodeItem, scope, config) || [];
  const attrParts = generateAttrs(nodeItem, scope, config) || [];
  const childrenParts = [];
  if (nodeItem.children && (config == null ? void 0 : config.self)) {
    const childrenStr = config.self(nodeItem.children, scope);
    childrenParts.push({
      type: "NodeCodePieceChildren" /* CHILDREN */,
      value: childrenStr
    });
  }
  return [...basicParts, ...attrParts, ...childrenParts];
}
function linkPieces(pieces) {
  const tagsPieces = pieces.filter((p) => p.type === "NodeCodePieceTag" /* TAG */);
  if (tagsPieces.length !== 1) {
    throw new CodeGeneratorError("Only one tag definition required", tagsPieces);
  }
  const tagName = tagsPieces[0].value;
  const beforeParts = pieces.filter((p) => p.type === "NodeCodePieceBefore" /* BEFORE */).map((p) => p.value).join("");
  const afterParts = pieces.filter((p) => p.type === "NodeCodePieceAfter" /* AFTER */).map((p) => p.value).join("");
  const childrenParts = pieces.filter((p) => p.type === "NodeCodePieceChildren" /* CHILDREN */).map((p) => p.value).join("");
  let attrsParts = pieces.filter((p) => p.type === "NodeCodePieceAttr" /* ATTR */).map((p) => p.value).join(" ");
  attrsParts = attrsParts ? ` ${attrsParts}` : "";
  if (childrenParts) {
    return `${beforeParts}<${tagName}${attrsParts}>${childrenParts}</${tagName}>${afterParts}`;
  }
  return `${beforeParts}<${tagName}${attrsParts} />${afterParts}`;
}
function generateNodeSchema(nodeItem, scope, config) {
  const pieces = [];
  if (config == null ? void 0 : config.nodePlugins) {
    const res = executeFunctionStack(
      nodeItem,
      scope,
      config.nodePlugins,
      generateSimpleNode,
      config
    );
    pieces.push(...res);
  } else {
    pieces.push(...generateSimpleNode(nodeItem, scope, config));
  }
  return linkPieces(pieces);
}
function generateReactLoopCtrl(nodeItem, scope, config, next) {
  var _a, _b, _c;
  if (nodeItem.loop) {
    const tolerateEvalErrors = (_a = config == null ? void 0 : config.tolerateEvalErrors) != null ? _a : true;
    const loopItemName = ((_b = nodeItem.loopArgs) == null ? void 0 : _b[0]) || "item";
    const loopIndexName = ((_c = nodeItem.loopArgs) == null ? void 0 : _c[1]) || "index";
    const subScope = scope.createSubScope([loopItemName, loopIndexName]);
    const pieces = next ? next(nodeItem, subScope, config) : [];
    const loopDataExpr = pipe(
      nodeItem.loop,
      (expr) => generateCompositeType(expr, scope, {
        handlers: config == null ? void 0 : config.handlers,
        tolerateEvalErrors: false
      }),
      (expr) => transformThis2Context(expr, scope, { ignoreRootScope: true }),
      (expr) => tolerateEvalErrors ? `__$$evalArray(() => (${expr}))` : expr
    );
    pieces.unshift({
      value: `(${loopDataExpr}).map((${loopItemName}, ${loopIndexName}) => ((__$$context) => (`,
      type: "NodeCodePieceBefore" /* BEFORE */
    });
    pieces.push({
      value: `))(__$$createChildContext(__$$context, { ${loopItemName}, ${loopIndexName} })))`,
      type: "NodeCodePieceAfter" /* AFTER */
    });
    return pieces;
  }
  return next ? next(nodeItem, scope, config) : [];
}
function generateConditionReactCtrl(nodeItem, scope, config, next) {
  const pieces = next ? next(nodeItem, scope, config) : [];
  if (nodeItem.condition != null && nodeItem.condition !== true) {
    const value = generateCompositeType(nodeItem.condition, scope, {
      handlers: config == null ? void 0 : config.handlers
    });
    pieces.unshift({
      value: `!!(${value}) && (`,
      type: "NodeCodePieceBefore" /* BEFORE */
    });
    pieces.push({
      value: ")",
      type: "NodeCodePieceAfter" /* AFTER */
    });
  }
  return pieces;
}
function generateReactExprInJS(nodeItem, scope, config, next) {
  const pieces = next ? next(nodeItem, scope, config) : [];
  if (nodeItem.condition != null && nodeItem.condition !== true || nodeItem.loop != null) {
    pieces.unshift({
      value: "{",
      type: "NodeCodePieceBefore" /* BEFORE */
    });
    pieces.push({
      value: "}",
      type: "NodeCodePieceAfter" /* AFTER */
    });
  }
  return pieces;
}
var handleChildren = (v) => v.join("");
function createNodeGenerator(cfg = {}) {
  const generateNode = (nodeItem, scope) => {
    if (_4.isArray(nodeItem)) {
      const resList = nodeItem.map((n) => generateNode(n, scope));
      return handleChildren(resList);
    }
    if (isNodeSchema2(nodeItem)) {
      return generateNodeSchema(nodeItem, scope, {
        ...cfg,
        self: generateNode
      });
    }
    const valueStr = generateCompositeType(nodeItem, scope, {
      handlers: cfg.handlers,
      nodeGenerator: generateNode
    });
    if (isPureString(valueStr)) {
      return encodeJsxStringNode(getStaticExprValue(valueStr));
    }
    return `{${valueStr}}`;
  };
  return (nodeItem, scope) => unwrapJsExprQuoteInJsx(generateNode(nodeItem, scope));
}
var defaultReactGeneratorConfig = {
  nodePlugins: [generateReactExprInJS, generateReactLoopCtrl, generateConditionReactCtrl]
};
function createReactNodeGenerator(cfg) {
  const newCfg = mergeNodeGeneratorConfig(defaultReactGeneratorConfig, cfg);
  return createNodeGenerator(newCfg);
}

// src/core/jsx/util/isLiteralAtomicExpr.ts
function isLiteralAtomicExpr(expr) {
  return expr === "null" || expr === "undefined" || expr === "true" || expr === "false" || /^-?\d+(\.\d+)?$/.test(expr);
}

// src/core/jsx/util/isSimpleStraightLiteral.ts
function isSimpleStraightLiteral(expr) {
  switch (expr.type) {
    case "BigIntLiteral":
    case "BooleanLiteral":
    case "DecimalLiteral":
    case "NullLiteral":
    case "NumericLiteral":
    case "RegExpLiteral":
    case "StringLiteral":
      return true;
    default:
      return false;
  }
}

// src/core/jsx/handlers/transformJsExpression.ts
function transformJsExpr(expr, scope, { dontWrapEval = false, dontTransformThis2ContextAtRootScope = false } = {}) {
  if (!expr) {
    return "undefined";
  }
  if (isLiteralAtomicExpr(expr)) {
    return expr;
  }
  const exprAst = parseExpression2(expr);
  if (isSimpleStraightLiteral(exprAst)) {
    return expr;
  }
  if (dontWrapEval) {
    return transformThis2Context(exprAst, scope, {
      ignoreRootScope: dontTransformThis2ContextAtRootScope
    });
  }
  switch (exprAst.type) {
    case "ArrowFunctionExpression":
    case "FunctionExpression":
      return transformThis2Context(exprAst, scope, {
        ignoreRootScope: dontTransformThis2ContextAtRootScope
      });
    default:
      break;
  }
  return `__$$eval(() => (${transformThis2Context(exprAst, scope, {
    ignoreRootScope: dontTransformThis2ContextAtRootScope
  })}))`;
}

// src/plugins/component/react/jsx.ts
var pluginFactory12 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    nodeTypeMapping: {},
    ...config
  };
  const { nodeTypeMapping } = cfg;
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const { tolerateEvalErrors = true, evalErrorsHandler = "" } = next.contextData;
    const customHandlers = {
      expression(input, scope2, config2) {
        var _a;
        return transformJsExpr(generateExpression(input, scope2), scope2, {
          dontWrapEval: !((_a = config2 == null ? void 0 : config2.tolerateEvalErrors) != null ? _a : tolerateEvalErrors),
          dontTransformThis2ContextAtRootScope: true
        });
      },
      function(input, scope2) {
        return transformThis2Context(
          generateCompositeType(
            {
              type: "JSFunction",
              value: input.value || "function () {}"
            },
            Scope.createRootScope()
          ),
          scope2,
          { ignoreRootScope: true }
        );
      }
    };
    const generatorPlugins = {
      handlers: customHandlers,
      tagMapping: (v) => nodeTypeMapping[v] || v,
      tolerateEvalErrors
    };
    if (next.contextData.useRefApi) {
      generatorPlugins.attrPlugins = [
        (attrData, scope2, pluginCfg, nextFunc) => {
          if (attrData.attrName === "ref") {
            return [
              {
                name: attrData.attrName,
                value: `this._refsManager.linkRef('${attrData.attrValue}')`,
                type: "NodeCodePieceAttr" /* ATTR */
              }
            ];
          }
          return nextFunc ? nextFunc(attrData, scope2, pluginCfg) : [];
        }
      ];
    }
    const generator = createReactNodeGenerator(generatorPlugins);
    const ir = next.ir;
    const scope = Scope.createRootScope();
    const jsxContent = generator(ir, scope);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: REACT_CHUNK_NAME.ClassRenderJSX,
      content: `
        const __$$context = this._context || this;
        const { state } = __$$context;
        return ${jsxContent};
      `,
      linkAfter: [REACT_CHUNK_NAME.ClassRenderStart, REACT_CHUNK_NAME.ClassRenderPre]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.CustomContent,
      content: [
        tolerateEvalErrors && `
          function __$$eval(expr) {
            try {
              return expr();
            } catch (error) {
              ${evalErrorsHandler}
            }
          }

          function __$$evalArray(expr) {
            const res = __$$eval(expr);
            return Array.isArray(res) ? res : [];
          }
      `,
        `
        function __$$createChildContext(oldContext, ext) {
          const childContext = {
            ...oldContext,
            ...ext,
          };
          childContext.__proto__ = oldContext;
          return childContext;
        }
      `
      ].filter(Boolean).join("\n"),
      linkAfter: [COMMON_CHUNK_NAME.FileExport]
    });
    return next;
  };
  return plugin;
};
var jsx_default = pluginFactory12;

// src/plugins/component/react/reactCommonDeps.ts
var pluginFactory13 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.ExternalDepsImport,
      content: `
// \u6CE8\u610F: \u51FA\u7801\u5F15\u64CE\u6CE8\u5165\u7684\u4E34\u65F6\u53D8\u91CF\u9ED8\u8BA4\u90FD\u4EE5 "__$$" \u5F00\u5934\uFF0C\u7981\u6B62\u5728\u642D\u5EFA\u7684\u4EE3\u7801\u4E2D\u76F4\u63A5\u8BBF\u95EE\u3002
// \u4F8B\u5916\uFF1Areact \u6846\u67B6\u7684\u5BFC\u51FA\u540D\u548C\u5404\u79CD\u7EC4\u4EF6\u540D\u9664\u5916\u3002
import React from 'react';`,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var reactCommonDeps_default = pluginFactory13;

// src/plugins/component/style/css.ts
var pluginFactory14 = (config) => {
  const cfg = {
    fileType: "css" /* CSS */,
    moduleFileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.StyleCssContent,
      content: ir.css,
      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.moduleFileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: `import './index.${cfg.fileType}';`,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    return next;
  };
  return plugin;
};
var css_default = pluginFactory14;

// src/plugins/project/constants.ts
var pluginFactory15 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const scope = Scope.createRootScope();
    const constantStr = generateCompositeType(ir.constants || {}, scope);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileVarDefine,
      content: `
        const __$$constants = (${constantStr});
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileExport,
      content: `
        export default __$$constants;
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine,
        COMMON_CHUNK_NAME.FileMainContent
      ]
    });
    return next;
  };
  return plugin;
};
var constants_default = pluginFactory15;

// src/plugins/project/i18n.ts
var pluginFactory16 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const i18nStr = ir.i18n ? JSON.stringify(ir.i18n, null, 2) : "{}";
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: `
        const i18nConfig = ${i18nStr};

        let locale = typeof navigator === 'object' && typeof navigator.language === 'string' ? navigator.language : 'zh-CN';

        const getLocale = () => locale;

        const setLocale = (target) => {
          locale = target;
        };

        const isEmptyVariables = variables => (
          Array.isArray(variables) && variables.length === 0
          || typeof variables === 'object' && (!variables || Object.keys(variables).length === 0)
        );

        // \u6309\u4F4E\u4EE3\u7801\u89C4\u8303\u91CC\u9762\u7684\u8981\u6C42\u8FDB\u884C\u53D8\u91CF\u66FF\u6362
        const format = (msg, variables) => (
          typeof msg === 'string'
            ? msg.replace(/\\$?\\{(\\w+)\\}/g, (match, key) => variables?.[key] ?? '')
            : msg
        );

        const i18nFormat = ({ id, defaultMessage, fallback }, variables) => {
          const msg = i18nConfig[locale]?.[id] ??  i18nConfig[locale.replace('-', '_')]?.[id] ??  defaultMessage;
          if (msg == null) {
            console.warn('[i18n]: unknown message id: %o (locale=%o)', id, locale);
            return fallback === undefined ? \`\${id}\` : fallback;
          }

          return format(msg, variables);
        }

        const i18n = (id, params) => {
          return i18nFormat({ id }, params);
        };

        // \u5C06\u56FD\u9645\u5316\u7684\u4E00\u4E9B\u65B9\u6CD5\u6CE8\u5165\u5230\u76EE\u6807\u5BF9\u8C61&\u4E0A\u4E0B\u6587\u4E2D
        const _inject2 = (target) => {
          target.i18n = i18n;
          target.getLocale = getLocale;
          target.setLocale = (locale) => {
            setLocale(locale);
            target.forceUpdate();
          };
          target._i18nText = (t) => {
            // \u4F18\u5148\u53D6\u76F4\u63A5\u4F20\u8FC7\u6765\u7684\u8BED\u6599
            const localMsg = t[locale] ?? t[String(locale).replace('-', '_')]
            if (localMsg != null) {
              return format(localMsg, t.params);
            }

            // \u5176\u6B21\u7528\u9879\u76EE\u7EA7\u522B\u7684
            const projectMsg = i18nFormat({ id: t.key, fallback: null }, t.params);
            if (projectMsg != null) {
              return projectMsg;
            }

            // \u515C\u5E95\u7528 use \u6307\u5B9A\u7684\u6216\u9ED8\u8BA4\u8BED\u8A00\u7684
            return format(t[t.use || "zh-CN"] ?? t.en_US, t.params);
          }

          // \u6CE8\u5165\u5230\u4E0A\u4E0B\u6587\u4E2D\u53BB
          if (target._context && target._context !== target) {
            Object.assign(target._context, {
              i18n,
              getLocale, setLocale: target.setLocale
            });
          }
        }
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileExport,
      content: `
        export {
          getLocale,
          setLocale,
          i18n,
          i18nFormat,
          _inject2,
        };
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine,
        COMMON_CHUNK_NAME.FileMainContent
      ]
    });
    return next;
  };
  return plugin;
};
var i18n_default = pluginFactory16;

// src/plugins/project/utils.ts
var pluginFactory17 = (baseFramework) => {
  const plugin = async (pre) => {
    const framework = baseFramework || "react";
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.ExternalDepsImport,
      content: `
        import { createRef } from '${framework}';
      `,
      linkAfter: []
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileUtilDefine,
      content: `
        export class RefsManager {
          constructor() {
            this.refInsStore = {};
          }

          clearNullRefs() {
            Object.keys(this.refInsStore).forEach((refName) => {
              const filteredInsList = this.refInsStore[refName].filter(insRef => !!insRef.current);
              if (filteredInsList.length > 0) {
                this.refInsStore[refName] = filteredInsList;
              } else {
                delete this.refInsStore[refName];
              }
            });
          }

          get(refName) {
            this.clearNullRefs();
            if (this.refInsStore[refName] && this.refInsStore[refName].length > 0) {
              return this.refInsStore[refName][0].current;
            }

            return null;
          }

          getAll(refName) {
            this.clearNullRefs();
            if (this.refInsStore[refName] && this.refInsStore[refName].length > 0) {
              return this.refInsStore[refName].map(i => i.current);
            }

            return [];
          }

          linkRef(refName) {
            const refIns = createRef();
            this.refInsStore[refName] = this.refInsStore[refName] || [];
            this.refInsStore[refName].push(refIns);
            return refIns;
          }
        }
      `,
      linkAfter: [...DEFAULT_LINK_AFTER[COMMON_CHUNK_NAME.FileUtilDefine]]
    });
    if (ir.utils) {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: "js" /* JS */,
        name: COMMON_CHUNK_NAME.FileExport,
        content: `
          export default {
        `,
        linkAfter: [
          COMMON_CHUNK_NAME.ExternalDepsImport,
          COMMON_CHUNK_NAME.InternalDepsImport,
          COMMON_CHUNK_NAME.ImportAliasDefine,
          COMMON_CHUNK_NAME.FileVarDefine,
          COMMON_CHUNK_NAME.FileUtilDefine,
          COMMON_CHUNK_NAME.FileMainContent
        ]
      });
      ir.utils.forEach((util) => {
        if (util.type === "function") {
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "js" /* JS */,
            name: COMMON_CHUNK_NAME.FileVarDefine,
            content: `
              const ${util.name} = ${util.content.value};
            `,
            linkAfter: [
              COMMON_CHUNK_NAME.ExternalDepsImport,
              COMMON_CHUNK_NAME.InternalDepsImport,
              COMMON_CHUNK_NAME.ImportAliasDefine
            ]
          });
        }
        next.chunks.push({
          type: "string" /* STRING */,
          fileType: "js" /* JS */,
          name: COMMON_CHUNK_NAME.FileExport,
          content: `${util.name},`,
          linkAfter: [
            COMMON_CHUNK_NAME.ExternalDepsImport,
            COMMON_CHUNK_NAME.InternalDepsImport,
            COMMON_CHUNK_NAME.ImportAliasDefine,
            COMMON_CHUNK_NAME.FileVarDefine,
            COMMON_CHUNK_NAME.FileUtilDefine,
            COMMON_CHUNK_NAME.FileMainContent
          ]
        });
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: "js" /* JS */,
        name: COMMON_CHUNK_NAME.FileExport,
        content: `
          };
        `,
        linkAfter: [
          COMMON_CHUNK_NAME.ExternalDepsImport,
          COMMON_CHUNK_NAME.InternalDepsImport,
          COMMON_CHUNK_NAME.ImportAliasDefine,
          COMMON_CHUNK_NAME.FileVarDefine,
          COMMON_CHUNK_NAME.FileUtilDefine,
          COMMON_CHUNK_NAME.FileMainContent
        ]
      });
    }
    return next;
  };
  return plugin;
};
var utils_default = pluginFactory17;

// src/utils/templateHelper.ts
var templateHelper_exports = {};
__export(templateHelper_exports, {
  insertFile: () => insertFile,
  runFileGenerator: () => runFileGenerator
});
function insertFile(root, path, file2) {
  let current = root;
  path.forEach((pathNode) => {
    const dir = current.dirs.find((d) => d.name === pathNode);
    if (dir) {
      current = dir;
    } else {
      const newDir = createResultDir(pathNode);
      addDirectory(current, newDir);
      current = newDir;
    }
  });
  addFile(current, file2);
}
function runFileGenerator(root, fun) {
  try {
    const result = fun();
    const [path, file2] = result;
    insertFile(root, path, file2);
  } catch (error) {
    throw new Error(`Error: ${typeof fun}`);
  }
}

// src/plugins/project/framework/icejs/template/files/abc.json.ts
function getFile() {
  return [
    [],
    {
      name: "abc",
      ext: "json",
      content: `
{
  "type": "ice-app",
  "builder": "@ali/builder-ice-app"
}
    `
    }
  ];
}

// src/plugins/project/framework/icejs/template/files/build.json.ts
function getFile2() {
  return [
    [],
    {
      name: "build",
      ext: "json",
      content: `
{
  "entry": "src/app.js",
  "plugins": [
    [
      "build-plugin-fusion",
      {
        "themePackage": "@alifd/theme-design-pro"
      }
    ],
    [
      "build-plugin-moment-locales",
      {
        "locales": [
          "zh-cn"
        ]
      }
    ]
  ]
}
      `
    }
  ];
}

// src/plugins/project/framework/icejs/template/files/editorconfig.ts
function getFile3() {
  const file2 = createResultFile(
    ".editorconfig",
    "",
    `
# http://editorconfig.org
root = true

[*]
indent_style = space
indent_size = 2
charset = utf-8
trim_trailing_whitespace = true
insert_final_newline = true

[*.md]
trim_trailing_whitespace = false
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/eslintignore.ts
function getFile4() {
  const file2 = createResultFile(
    ".eslintignore",
    "",
    `
# \u5FFD\u7565\u76EE\u5F55
build/
tests/
demo/
.ice/

# node \u8986\u76D6\u7387\u6587\u4EF6
coverage/

# \u5FFD\u7565\u6587\u4EF6
**/*-min.js
**/*.min.js

package-lock.json
yarn.lock
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/eslintrc.js.ts
function getFile5() {
  const file2 = createResultFile(
    ".eslintrc",
    "js",
    `
const { eslint } = require('@ice/spec');

module.exports = eslint;
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/gitignore.ts
function getFile6() {
  const file2 = createResultFile(
    ".gitignore",
    "",
    `
# See https://help.github.com/ignore-files/ for more about ignoring files.

# dependencies
node_modules/

# production
build/
dist/
tmp/
lib/

# misc
.idea/
.happypack
.DS_Store
*.swp
*.dia~
.ice

npm-debug.log*
yarn-debug.log*
yarn-error.log*
index.module.scss.d.ts
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/jsconfig.json.ts
function getFile7() {
  const file2 = createResultFile(
    "jsconfig",
    "json",
    `
{
  "compilerOptions": {
    "baseUrl": ".",
    "jsx": "react",
    "paths": {
      "@/*": ["./src/*"],
      "ice": [".ice/index.ts"],
      "ice/*": [".ice/pages/*"]
    }
  }
}
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/prettierignore.ts
function getFile8() {
  const file2 = createResultFile(
    ".prettierignore",
    "",
    `
build/
tests/
demo/
.ice/
coverage/
**/*-min.js
**/*.min.js
package-lock.json
yarn.lock
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/prettierrc.js.ts
function getFile9() {
  const file2 = createResultFile(
    ".prettierrc",
    "js",
    `
const { prettier } = require('@ice/spec');

module.exports = prettier;
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/README.md.ts
function getFile10() {
  const file2 = createResultFile(
    "README",
    "md",
    `
## Scaffold Lite

> \u8F7B\u91CF\u7EA7\u6A21\u677F\uFF0C\u4F7F\u7528 JavaScript\uFF0C\u4EC5\u5305\u542B\u57FA\u7840\u7684 Layout\u3002

## \u4F7F\u7528

\`\`\`bash
# \u5B89\u88C5\u4F9D\u8D56
$ npm install

# \u542F\u52A8\u670D\u52A1
$ npm start  # visit http://localhost:3333
\`\`\`

[More docs](https://ice.work/docs/guide/about).

## \u76EE\u5F55

\`\`\`md
\u251C\u2500\u2500 build/                         # \u6784\u5EFA\u4EA7\u7269
\u251C\u2500\u2500 mock/                          # \u672C\u5730\u6A21\u62DF\u6570\u636E
\u2502   \u251C\u2500\u2500 index.[j,t]s
\u251C\u2500\u2500 public/
\u2502   \u251C\u2500\u2500 index.html                 # \u5E94\u7528\u5165\u53E3 HTML
\u2502   \u2514\u2500\u2500 favicon.png                # Favicon
\u251C\u2500\u2500 src/                           # \u6E90\u7801\u8DEF\u5F84
\u2502   \u251C\u2500\u2500 components/                # \u81EA\u5B9A\u4E49\u4E1A\u52A1\u7EC4\u4EF6
\u2502   \u2502   \u2514\u2500\u2500 Guide/
\u2502   \u2502       \u251C\u2500\u2500 index.[j,t]sx
\u2502   \u2502       \u251C\u2500\u2500 index.module.scss
\u2502   \u251C\u2500\u2500 layouts/                   # \u5E03\u5C40\u7EC4\u4EF6
\u2502   \u2502   \u2514\u2500\u2500 BasicLayout/
\u2502   \u2502       \u251C\u2500\u2500 index.[j,t]sx
\u2502   \u2502       \u2514\u2500\u2500 index.module.scss
\u2502   \u251C\u2500\u2500 pages/                     # \u9875\u9762
\u2502   \u2502   \u2514\u2500\u2500 Home/                  # home \u9875\u9762\uFF0C\u7EA6\u5B9A\u8DEF\u7531\u8F6C\u6210\u5C0F\u5199
\u2502   \u2502       \u251C\u2500\u2500 components/        # \u9875\u9762\u7EA7\u81EA\u5B9A\u4E49\u4E1A\u52A1\u7EC4\u4EF6
\u2502   \u2502       \u251C\u2500\u2500 models.[j,t]sx     # \u9875\u9762\u7EA7\u6570\u636E\u72B6\u6001
\u2502   \u2502       \u251C\u2500\u2500 index.[j,t]sx      # \u9875\u9762\u5165\u53E3
\u2502   \u2502       \u2514\u2500\u2500 index.module.scss  # \u9875\u9762\u6837\u5F0F\u6587\u4EF6
\u2502   \u251C\u2500\u2500 configs/                   # [\u53EF\u9009] \u914D\u7F6E\u6587\u4EF6
\u2502   \u2502   \u2514\u2500\u2500 menu.[j,t]s            # [\u53EF\u9009] \u83DC\u5355\u914D\u7F6E
\u2502   \u251C\u2500\u2500 models/                    # [\u53EF\u9009] \u5E94\u7528\u7EA7\u6570\u636E\u72B6\u6001
\u2502   \u2502   \u2514\u2500\u2500 user.[j,t]s
\u2502   \u251C\u2500\u2500 utils/                     # [\u53EF\u9009] \u5DE5\u5177\u5E93
\u2502   \u251C\u2500\u2500 global.scss                # \u5168\u5C40\u6837\u5F0F
\u2502   \u251C\u2500\u2500 routes.[j,t]s              # \u8DEF\u7531\u914D\u7F6E
\u2502   \u2514\u2500\u2500 app.[j,t]s[x]              # \u5E94\u7528\u5165\u53E3\u811A\u672C
\u251C\u2500\u2500 build.json                     # \u5DE5\u7A0B\u914D\u7F6E
\u251C\u2500\u2500 README.md
\u251C\u2500\u2500 package.json
\u251C\u2500\u2500 .editorconfig
\u251C\u2500\u2500 .eslintignore
\u251C\u2500\u2500 .eslintrc.[j,t]s
\u251C\u2500\u2500 .gitignore
\u251C\u2500\u2500 .stylelintignore
\u251C\u2500\u2500 .stylelintrc.[j,t]s
\u251C\u2500\u2500 .gitignore
\u2514\u2500\u2500 [j,t]sconfig.json
\`\`\`
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/src/layouts/BasicLayout/components/Footer/index.jsx.ts
function getFile11() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `
import React from 'react';
import styles from './index.module.scss';

export default function Footer() {
  return (
    <p className={styles.footer}>
      <span className={styles.logo}>Alibaba Fusion</span>
      <br />
      <span className={styles.copyright}>\xA9 2019-\u73B0\u5728 Alibaba Fusion & ICE</span>
    </p>
  );
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Footer"], file2];
}

// src/plugins/project/framework/icejs/template/files/src/layouts/BasicLayout/components/Footer/index.style.ts
function getFile12() {
  const file2 = createResultFile(
    "index",
    "module.scss",
    `
.footer {
  line-height: 20px;
  text-align: center;
}

.logo {
  font-weight: bold;
  font-size: 16px;
}

.copyright {
  font-size: 12px;
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Footer"], file2];
}

// src/plugins/project/framework/icejs/template/files/src/layouts/BasicLayout/components/Logo/index.jsx.ts
function getFile13() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `
import React from 'react';
import { Link } from 'ice';
import styles from './index.module.scss';

export default function Logo({ image, text, url }) {
  return (
    <div className="logo">
      <Link to={url || '/'} className={styles.logo}>
        {image && <img src={image} alt="logo" />}
        <span>{text}</span>
      </Link>
    </div>
  );
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Logo"], file2];
}

// src/plugins/project/framework/icejs/template/files/src/layouts/BasicLayout/components/Logo/index.style.ts
function getFile14() {
  const file2 = createResultFile(
    "index",
    "module.scss",
    `
.logo{
  display: flex;
  align-items: center;
  justify-content: center;
  color: $color-text1-1;
  font-weight: bold;
  font-size: 14px;
  line-height: 22px;

  &:visited, &:link {
    color: $color-text1-1;
  }

  img {
    height: 24px;
    margin-right: 10px;
  }
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Logo"], file2];
}

// src/plugins/project/framework/icejs/template/files/src/layouts/BasicLayout/components/PageNav/index.jsx.ts
function getFile15() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `
import React from 'react';
import PropTypes from 'prop-types';
import { Link, withRouter } from 'ice';
import { Nav } from '@alifd/next';
import { asideMenuConfig } from '../../menuConfig';

const { SubNav } = Nav;
const NavItem = Nav.Item;

function getNavMenuItems(menusData) {
  if (!menusData) {
    return [];
  }

  return menusData
    .filter(item => item.name && !item.hideInMenu)
    .map((item, index) => getSubMenuOrItem(item, index));
}

function getSubMenuOrItem(item, index) {
  if (item.children && item.children.some(child => child.name)) {
    const childrenItems = getNavMenuItems(item.children);

    if (childrenItems && childrenItems.length > 0) {
      const subNav = (
        <SubNav key={index} icon={item.icon} label={item.name}>
          {childrenItems}
        </SubNav>
      );
      return subNav;
    }

    return null;
  }

  const navItem = (
    <NavItem key={item.path} icon={item.icon}>
      <Link to={item.path}>{item.name}</Link>
    </NavItem>
  );
  return navItem;
}

const Navigation = (props, context) => {
  const { location } = props;
  const { pathname } = location;
  const { isCollapse } = context;
  return (
    <Nav
      type="primary"
      selectedKeys={[pathname]}
      defaultSelectedKeys={[pathname]}
      embeddable
      openMode="single"
      iconOnly={isCollapse}
      hasArrow={false}
      mode={isCollapse ? 'popup' : 'inline'}
    >
      {getNavMenuItems(asideMenuConfig)}
    </Nav>
  );
};

Navigation.contextTypes = {
  isCollapse: PropTypes.bool,
};
const PageNav = withRouter(Navigation);
export default PageNav;
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "PageNav"], file2];
}

// src/plugins/project/framework/icejs/template/files/src/layouts/BasicLayout/index.jsx.ts
function getFile16() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `
import React, { useState } from 'react';
import { Shell, ConfigProvider } from '@alifd/next';
import PageNav from './components/PageNav';
import Logo from './components/Logo';
import Footer from './components/Footer';

(function() {
  const throttle = function(type, name, obj = window) {
    let running = false;

    const func = () => {
      if (running) {
        return;
      }

      running = true;
      requestAnimationFrame(() => {
        obj.dispatchEvent(new CustomEvent(name));
        running = false;
      });
    };

    obj.addEventListener(type, func);
  };

  throttle('resize', 'optimizedResize');
})();

export default function BasicLayout({ children }) {
  const getDevice = width => {
    const isPhone =
      typeof navigator !== 'undefined' && navigator && navigator.userAgent.match(/phone/gi);

    if (width < 680 || isPhone) {
      return 'phone';
    }
    if (width < 1280 && width > 680) {
      return 'tablet';
    }
    return 'desktop';
  };

  const [device, setDevice] = useState(getDevice(NaN));
  window.addEventListener('optimizedResize', e => {
    setDevice(getDevice(e && e.target && e.target.innerWidth));
  });
  return (
    <ConfigProvider device={device}>
      <Shell
        type="dark"
        style={{
          minHeight: '100vh',
        }}
      >
        <Shell.Branding>
          <Logo
            image="https://img.alicdn.com/tfs/TB1.ZBecq67gK0jSZFHXXa9jVXa-904-826.png"
            text="Logo"
          />
        </Shell.Branding>
        <Shell.Navigation
          direction="hoz"
          style={{
            marginRight: 10,
          }}
        ></Shell.Navigation>
        <Shell.Action></Shell.Action>
        <Shell.Navigation>
          <PageNav />
        </Shell.Navigation>

        <Shell.Content>{children}</Shell.Content>
        <Shell.Footer>
          <Footer />
        </Shell.Footer>
      </Shell>
    </ConfigProvider>
  );
}
    `
  );
  return [["src", "layouts", "BasicLayout"], file2];
}

// src/plugins/project/framework/icejs/template/files/src/layouts/BasicLayout/menuConfig.js.ts
function getFile17() {
  const file2 = createResultFile(
    "menuConfig",
    "js",
    `
const headerMenuConfig = [];
const asideMenuConfig = [
  {
    name: 'Dashboard',
    path: '/',
    icon: 'smile',
  },
];
export { headerMenuConfig, asideMenuConfig };
    `
  );
  return [["src", "layouts", "BasicLayout"], file2];
}

// src/plugins/project/framework/icejs/template/files/stylelintignore.ts
function getFile18() {
  const file2 = createResultFile(
    ".stylelintignore",
    "",
    `
# \u5FFD\u7565\u76EE\u5F55
build/
tests/
demo/

# node \u8986\u76D6\u7387\u6587\u4EF6
coverage/
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/stylelintrc.js.ts
function getFile19() {
  const file2 = createResultFile(
    ".stylelintrc",
    "js",
    `
const { stylelint } = require('@ice/spec');

module.exports = stylelint;
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/files/tsconfig.json.ts
function getFile20() {
  const file2 = createResultFile(
    "tsconfig",
    "json",
    `
{
  "compileOnSave": false,
  "buildOnSave": false,
  "compilerOptions": {
    "baseUrl": ".",
    "outDir": "build",
    "module": "esnext",
    "target": "es6",
    "jsx": "react",
    "moduleResolution": "node",
    "allowSyntheticDefaultImports": true,
    "lib": ["es6", "dom"],
    "sourceMap": true,
    "allowJs": true,
    "rootDir": "./",
    "forceConsistentCasingInFileNames": true,
    "noImplicitReturns": true,
    "noImplicitThis": true,
    "noImplicitAny": false,
    "importHelpers": true,
    "strictNullChecks": true,
    "suppressImplicitAnyIndexErrors": true,
    "noUnusedLocals": true,
    "skipLibCheck": true,
    "paths": {
      "@/*": ["./src/*"],
      "ice": [".ice/index.ts"],
      "ice/*": [".ice/pages/*"]
    }
  },
  "include": ["src/*", ".ice"],
  "exclude": ["node_modules", "build", "public"]
}
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs/template/static-files.ts
function generateStaticFiles(root = createResultDir(".")) {
  runFileGenerator(root, getFile20);
  runFileGenerator(root, getFile19);
  runFileGenerator(root, getFile18);
  runFileGenerator(root, getFile9);
  runFileGenerator(root, getFile8);
  runFileGenerator(root, getFile7);
  runFileGenerator(root, getFile6);
  runFileGenerator(root, getFile5);
  runFileGenerator(root, getFile4);
  runFileGenerator(root, getFile3);
  runFileGenerator(root, getFile2);
  runFileGenerator(root, getFile);
  runFileGenerator(root, getFile10);
  runFileGenerator(root, getFile16);
  runFileGenerator(root, getFile17);
  runFileGenerator(root, getFile11);
  runFileGenerator(root, getFile12);
  runFileGenerator(root, getFile13);
  runFileGenerator(root, getFile14);
  runFileGenerator(root, getFile15);
  return root;
}

// src/plugins/project/framework/icejs/template/index.ts
var icejsTemplate = {
  slots: {
    components: {
      path: ["src", "components"]
    },
    pages: {
      path: ["src", "pages"]
    },
    router: {
      path: ["src"],
      fileName: "routes"
    },
    entry: {
      path: ["src"],
      fileName: "app"
    },
    constants: {
      path: ["src"],
      fileName: "constants"
    },
    utils: {
      path: ["src"],
      fileName: "utils"
    },
    i18n: {
      path: ["src"],
      fileName: "i18n"
    },
    globalStyle: {
      path: ["src"],
      fileName: "global"
    },
    htmlEntry: {
      path: ["public"],
      fileName: "index"
    },
    packageJSON: {
      path: [],
      fileName: "package"
    }
  },
  generateTemplate() {
    return generateStaticFiles();
  }
};
var template_default = icejsTemplate;

// src/plugins/project/framework/icejs/plugins/entry.ts
var pluginFactory18 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.ExternalDepsImport,
      content: `
        import { createApp } from 'ice';
      `,
      linkAfter: []
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: `
        const appConfig = {
          app: {
            rootId: 'app',
          },
          router: {
            type: 'hash',
          },
        };
        createApp(appConfig);
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine
      ]
    });
    return next;
  };
  return plugin;
};
var entry_default = pluginFactory18;

// src/plugins/project/framework/icejs/plugins/entryHtml.ts
var pluginFactory19 = () => {
  const plugin = async (pre) => {
    var _a;
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "html" /* HTML */,
      name: COMMON_CHUNK_NAME.HtmlContent,
      content: `
        <!DOCTYPE html>
        <html>
          <head>
            <meta charset="utf-8" />
            <meta http-equiv="x-ua-compatible" content="ie=edge,chrome=1" />
            <meta name="viewport" content="width=device-width" />
            <title>${((_a = ir == null ? void 0 : ir.meta) == null ? void 0 : _a.name) || "Ice App"}</title>
          </head>
          <body>
            <div id="app"></div>
          </body>
        </html>
      `,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var entryHtml_default = pluginFactory19;

// src/plugins/project/framework/icejs/plugins/globalStyle.ts
var pluginFactory20 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "scss" /* SCSS */,
      name: COMMON_CHUNK_NAME.StyleDepsImport,
      content: `
        // \u5F15\u5165\u9ED8\u8BA4\u5168\u5C40\u6837\u5F0F
        @import '@alifd/next/reset.scss';
      `,
      linkAfter: []
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "scss" /* SCSS */,
      name: COMMON_CHUNK_NAME.StyleCssContent,
      content: `
        body {
          -webkit-font-smoothing: antialiased;
        }
      `,
      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "scss" /* SCSS */,
      name: COMMON_CHUNK_NAME.StyleCssContent,
      content: ir.css || "",
      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport]
    });
    return next;
  };
  return plugin;
};
var globalStyle_default = pluginFactory20;

// src/utils/dataSource.ts
var dataSource_exports = {};
__export(dataSource_exports, {
  buildDataSourceDependencies: () => buildDataSourceDependencies
});
import changeCase6 from "change-case";
function buildDataSourceDependencies(ir, cfg = {}) {
  return {
    [cfg.enginePackage || "@alilc/lowcode-datasource-engine"]: cfg.engineVersion || "^1.0.0",
    ...(ir.dataSourcesTypes || []).reduce(
      (acc, dsType) => {
        var _a;
        return {
          ...acc,
          [getDataSourceHandlerPackageName(dsType)]: ((_a = cfg.handlersVersion) == null ? void 0 : _a[dsType]) || "^1.0.0"
        };
      },
      {}
    )
  };
  function getDataSourceHandlerPackageName(dsType) {
    var _a;
    return ((_a = cfg.handlersPackages) == null ? void 0 : _a[dsType]) || `@alilc/lowcode-datasource-${changeCase6.kebab(dsType)}-handler`;
  }
}

// src/plugins/project/framework/icejs/plugins/packageJSON.ts
var pluginFactory21 = (cfg) => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const packageJson = {
      name: (cfg == null ? void 0 : cfg.packageName) || "icejs-demo-app",
      version: (cfg == null ? void 0 : cfg.packageVersion) || "0.1.5",
      description: "\u8F7B\u91CF\u7EA7\u6A21\u677F\uFF0C\u4F7F\u7528 JavaScript\uFF0C\u4EC5\u5305\u542B\u57FA\u7840\u7684 Layout\u3002",
      dependencies: {
        moment: "^2.24.0",
        react: "^16.4.1",
        "react-dom": "^16.4.1",
        "react-router": "^5.2.1",
        "@alifd/theme-design-pro": "^0.x",
        "intl-messageformat": "^9.3.6",
        "@ice/store": "^1.4.3",
        "@loadable/component": "^5.15.2",
        ...buildDataSourceDependencies(ir, cfg == null ? void 0 : cfg.datasourceConfig)
      },
      devDependencies: {
        "@ice/spec": "^1.0.0",
        "build-plugin-fusion": "^0.1.0",
        "build-plugin-moment-locales": "^0.1.0",
        eslint: "^6.0.1",
        "ice.js": "^1.0.0",
        stylelint: "^13.2.0"
      },
      scripts: {
        start: "icejs start",
        build: "icejs build",
        lint: "npm run eslint && npm run stylelint",
        eslint: "eslint --cache --ext .js,.jsx ./",
        stylelint: "stylelint ./**/*.scss"
      },
      ideMode: {
        name: "ice-react"
      },
      iceworks: {
        type: "react",
        adapter: "adapter-react-v3"
      },
      engines: {
        node: ">=8.0.0"
      },
      repository: {
        type: "git",
        url: "http://gitlab.xxx.com/msd/leak-scan/tree/master"
      },
      private: true,
      originTemplate: "@alifd/scaffold-lite-js"
    };
    ir.packages.forEach((packageInfo) => {
      packageJson.dependencies[packageInfo.package] = packageInfo.version;
    });
    next.chunks.push({
      type: "json" /* JSON */,
      fileType: "json" /* JSON */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: packageJson,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var packageJSON_default = pluginFactory21;

// src/plugins/project/framework/icejs/plugins/router.ts
var pluginFactory22 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: `
        import BasicLayout from '@/layouts/BasicLayout';
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileVarDefine,
      content: `
        const routerConfig = [
          {
            path: '/',
            component: BasicLayout,
            children: [
              ${ir.routes.map(
        (route) => `
                    {
                      path: '${route.path}',
                      component: ${route.componentName},
                    }
                  `
      ).join(",")}
            ],
          },
        ];
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileUtilDefine
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileExport,
      content: `
        export default routerConfig;
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.FileUtilDefine,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileMainContent
      ]
    });
    return next;
  };
  return plugin;
};
var router_default = pluginFactory22;

// src/plugins/project/framework/icejs/index.ts
var icejs_default = {
  template: template_default,
  plugins: {
    entry: entry_default,
    entryHtml: entryHtml_default,
    globalStyle: globalStyle_default,
    packageJSON: packageJSON_default,
    router: router_default
  }
};

// src/postprocessor/prettier/index.ts
import prettier from "prettier";
import parserBabel from "prettier/parser-babel";
import parserPostCss from "prettier/parser-postcss";
import parserHtml from "prettier/parser-html";
var PARSERS = ["css", "scss", "less", "json", "html", "vue"];
var factory = (config) => {
  const cfg = {
    customFileTypeParser: {},
    ...config
  };
  const codePrettier = (content, fileType) => {
    let parser3;
    if (fileType === "js" || fileType === "jsx" || fileType === "ts" || fileType === "tsx") {
      parser3 = "babel-ts";
    } else if (fileType === "json") {
      parser3 = "json-stringify";
    } else if (PARSERS.indexOf(fileType) >= 0) {
      parser3 = fileType;
    } else if (cfg.customFileTypeParser[fileType]) {
      parser3 = cfg.customFileTypeParser[fileType];
    } else {
      return content;
    }
    return prettier.format(content, {
      parser: parser3,
      plugins: [parserBabel, parserPostCss, parserHtml, ...cfg.plugins || []],
      singleQuote: true,
      jsxSingleQuote: false
    });
  };
  return codePrettier;
};
var prettier_default = factory;

// src/solutions/icejs.ts
function createIceJsProjectBuilder(options) {
  return createProjectBuilder({
    inStrictMode: options == null ? void 0 : options.inStrictMode,
    extraContextData: { ...options },
    template: icejs_default.template,
    plugins: {
      components: [
        reactCommonDeps_default(),
        esmodule_default({
          fileType: "jsx"
        }),
        styleImport_default(),
        containerClass_default(),
        containerInjectContext_default(),
        containerInjectUtils_default(),
        containerInjectDataSourceEngine_default(),
        containerInjectI18n_default(),
        containerInjectConstants_default(),
        containerInitState_default(),
        containerLifeCycle_default(),
        containerMethod_default(),
        jsx_default({
          nodeTypeMapping: {
            Div: "div",
            Component: "div",
            Page: "div",
            Block: "div"
          }
        }),
        css_default()
      ],
      pages: [
        reactCommonDeps_default(),
        esmodule_default({
          fileType: "jsx"
        }),
        styleImport_default(),
        containerClass_default(),
        containerInjectContext_default(),
        containerInjectUtils_default(),
        containerInjectDataSourceEngine_default(),
        containerInjectI18n_default(),
        containerInjectConstants_default(),
        containerInitState_default(),
        containerLifeCycle_default(),
        containerMethod_default(),
        jsx_default({
          nodeTypeMapping: {
            Div: "div",
            Component: "div",
            Page: "div",
            Block: "div"
          }
        }),
        css_default()
      ],
      router: [esmodule_default(), icejs_default.plugins.router()],
      entry: [icejs_default.plugins.entry()],
      constants: [constants_default()],
      utils: [esmodule_default(), utils_default("react")],
      i18n: [i18n_default()],
      globalStyle: [icejs_default.plugins.globalStyle()],
      htmlEntry: [icejs_default.plugins.entryHtml()],
      packageJSON: [icejs_default.plugins.packageJSON()]
    },
    postProcessors: [prettier_default()],
    customizeBuilderOptions: options == null ? void 0 : options.customizeBuilderOptions
  });
}
var plugins = {
  containerClass: containerClass_default,
  containerInjectContext: containerInjectContext_default,
  containerInjectUtils: containerInjectUtils_default,
  containerInjectDataSourceEngine: containerInjectDataSourceEngine_default,
  containerInjectI18n: containerInjectI18n_default,
  containerInjectConstants: containerInjectConstants_default,
  containerInitState: containerInitState_default,
  containerLifeCycle: containerLifeCycle_default,
  containerMethod: containerMethod_default,
  jsx: jsx_default,
  commonDeps: reactCommonDeps_default,
  reactCommonDeps: reactCommonDeps_default
};

// src/plugins/project/framework/icejs3/template/files/gitignore.ts
function getFile21() {
  const file2 = createResultFile(
    ".gitignore",
    "",
    `
# See https://help.github.com/ignore-files/ for more about ignoring files.

# dependencies
node_modules/

# production
build/
dist/
tmp/
lib/

# misc
.idea/
.happypack
.DS_Store
*.swp
*.dia~
.ice

npm-debug.log*
yarn-debug.log*
yarn-error.log*
index.module.scss.d.ts
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs3/template/files/README.md.ts
function getFile22() {
  const file2 = createResultFile(
    "README",
    "md",
    "This project is generated by lowcode-code-generator & lowcode-solution-icejs3."
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs3/template/files/browserslistrc.ts
function getFile23() {
  const file2 = createResultFile(
    ".browserslistrc",
    "",
    `defaults
ios_saf 9
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/icejs3/template/files/typings.ts
function getFile24() {
  const file2 = createResultFile(
    "typings.d",
    "ts",
    `/// <reference types="@ice/app/types" />

export {};
declare global {
  interface Window {
    g_config: Record<string, any>;
  }
}
    `
  );
  return [["src"], file2];
}

// src/plugins/project/framework/icejs3/template/files/document.ts
function getFile25() {
  const file2 = createResultFile(
    "document",
    "tsx",
    `import React from 'react';
import { Meta, Title, Links, Main, Scripts } from 'ice';

export default function Document() {
  return (
    <html>
      <head>
        <meta charSet="utf-8" />
        <meta name="description" content="ice.js 3 lite scaffold" />
        <link rel="icon" href="/favicon.ico" />
        <link rel="stylesheet" href="//alifd.alicdn.com/npm/@alifd/next/1.21.16/next.min.css" />
        <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" />
        <Meta />
        <Title />
        <Links />
      </head>
      <body>
        <Main />
        <script crossOrigin="anonymous" src="//g.alicdn.com/code/lib/react/18.2.0/umd/react.development.js" />
        <script crossOrigin="anonymous" src="//g.alicdn.com/code/lib/react-dom/18.2.0/umd/react-dom.development.js" />
        <script crossOrigin="anonymous" src="//g.alicdn.com/code/lib/??react-router/6.9.0/react-router.production.min.js,react-router-dom/6.9.0/react-router-dom.production.min.js" />
        <script crossOrigin="anonymous" src="//g.alicdn.com/code/lib/alifd__next/1.26.22/next.min.js" />
        <script crossOrigin="anonymous" src="//g.alicdn.com/code/lib/prop-types/15.7.2/prop-types.js" />
        <script crossOrigin="anonymous" src="//g.alicdn.com/platform/c/??lodash/4.6.1/lodash.min.js,immutable/3.7.6/dist/immutable.min.js" />
        <Scripts />
      </body>
    </html>
  );
}`
  );
  return [["src"], file2];
}

// src/plugins/project/framework/icejs3/template/files/src/layouts/BasicLayout/components/Footer/index.jsx.ts
function getFile26() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `
import React from 'react';
import styles from './index.module.scss';

export default function Footer() {
  return (
    <p className={styles.footer}>
      <span className={styles.logo}>Alibaba Fusion</span>
      <br />
      <span className={styles.copyright}>\xA9 2019-\u73B0\u5728 Alibaba Fusion & ICE</span>
    </p>
  );
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Footer"], file2];
}

// src/plugins/project/framework/icejs3/template/files/src/layouts/BasicLayout/components/Footer/index.style.ts
function getFile27() {
  const file2 = createResultFile(
    "index",
    "module.scss",
    `
.footer {
  line-height: 20px;
  text-align: center;
}

.logo {
  font-weight: bold;
  font-size: 16px;
}

.copyright {
  font-size: 12px;
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Footer"], file2];
}

// src/plugins/project/framework/icejs3/template/files/src/layouts/BasicLayout/components/Logo/index.jsx.ts
function getFile28() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `
import React from 'react';
import { Link } from 'ice';
import styles from './index.module.scss';

export default function Logo({ image, text, url }) {
  return (
    <div className="logo">
      <Link to={url || '/'} className={styles.logo}>
        {image && <img src={image} alt="logo" />}
        <span>{text}</span>
      </Link>
    </div>
  );
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Logo"], file2];
}

// src/plugins/project/framework/icejs3/template/files/src/layouts/BasicLayout/components/Logo/index.style.ts
function getFile29() {
  const file2 = createResultFile(
    "index",
    "module.scss",
    `
.logo{
  display: flex;
  align-items: center;
  justify-content: center;
  color: #FF7300;
  font-weight: bold;
  font-size: 14px;
  line-height: 22px;

  &:visited, &:link {
    color: #FF7300;
  }

  img {
    height: 24px;
    margin-right: 10px;
  }
}
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "Logo"], file2];
}

// src/plugins/project/framework/icejs3/template/files/src/layouts/BasicLayout/components/PageNav/index.jsx.ts
function getFile30() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `import React from 'react';
import PropTypes from 'prop-types';
import { Link, useLocation } from 'ice';
import { Nav } from '@alifd/next';
import { asideMenuConfig } from '../../menuConfig';

const { SubNav } = Nav;
const NavItem = Nav.Item;

function getNavMenuItems(menusData) {
  if (!menusData) {
    return [];
  }

  return menusData
    .filter(item => item.name && !item.hideInMenu)
    .map((item, index) => getSubMenuOrItem(item, index));
}

function getSubMenuOrItem(item, index) {
  if (item.children && item.children.some(child => child.name)) {
    const childrenItems = getNavMenuItems(item.children);

    if (childrenItems && childrenItems.length > 0) {
      const subNav = (
        <SubNav key={index} icon={item.icon} label={item.name}>
          {childrenItems}
        </SubNav>
      );
      return subNav;
    }

    return null;
  }

  const navItem = (
    <NavItem key={item.path} icon={item.icon}>
      <Link to={item.path}>{item.name}</Link>
    </NavItem>
  );
  return navItem;
}

const Navigation = (props, context) => {
  const location = useLocation();
  const { pathname } = location;
  const { isCollapse } = context;
  return (
    <Nav
      type="primary"
      selectedKeys={[pathname]}
      defaultSelectedKeys={[pathname]}
      embeddable
      openMode="single"
      iconOnly={isCollapse}
      hasArrow={false}
      mode={isCollapse ? 'popup' : 'inline'}
    >
      {getNavMenuItems(asideMenuConfig)}
    </Nav>
  );
};

Navigation.contextTypes = {
  isCollapse: PropTypes.bool,
};
export default Navigation;
    `
  );
  return [["src", "layouts", "BasicLayout", "components", "PageNav"], file2];
}

// src/plugins/project/framework/icejs3/template/files/src/layouts/BasicLayout/index.jsx.ts
function getFile31() {
  const file2 = createResultFile(
    "index",
    "jsx",
    `
import React, { useState } from 'react';
import { Shell, ConfigProvider } from '@alifd/next';
import PageNav from './components/PageNav';
import Logo from './components/Logo';
import Footer from './components/Footer';

(function() {
  const throttle = function(type, name, obj = window) {
    let running = false;

    const func = () => {
      if (running) {
        return;
      }

      running = true;
      requestAnimationFrame(() => {
        obj.dispatchEvent(new CustomEvent(name));
        running = false;
      });
    };

    obj.addEventListener(type, func);
  };

  throttle('resize', 'optimizedResize');
})();

export default function BasicLayout({ children }) {
  const getDevice = width => {
    const isPhone =
      typeof navigator !== 'undefined' && navigator && navigator.userAgent.match(/phone/gi);

    if (width < 680 || isPhone) {
      return 'phone';
    }
    if (width < 1280 && width > 680) {
      return 'tablet';
    }
    return 'desktop';
  };

  const [device, setDevice] = useState(getDevice(NaN));
  window.addEventListener('optimizedResize', e => {
    setDevice(getDevice(e && e.target && e.target.innerWidth));
  });
  return (
    <ConfigProvider device={device}>
      <Shell
        type="dark"
        style={{
          minHeight: '100vh',
        }}
      >
        <Shell.Branding>
          <Logo
            image="https://img.alicdn.com/tfs/TB1.ZBecq67gK0jSZFHXXa9jVXa-904-826.png"
            text="Logo"
          />
        </Shell.Branding>
        <Shell.Navigation
          direction="hoz"
          style={{
            marginRight: 10,
          }}
        ></Shell.Navigation>
        <Shell.Action></Shell.Action>
        <Shell.Navigation>
          <PageNav />
        </Shell.Navigation>

        <Shell.Content>{children}</Shell.Content>
        <Shell.Footer>
          <Footer />
        </Shell.Footer>
      </Shell>
    </ConfigProvider>
  );
}
    `
  );
  return [["src", "layouts", "BasicLayout"], file2];
}

// src/plugins/project/framework/icejs3/template/files/src/layouts/BasicLayout/menuConfig.js.ts
function getFile32() {
  const file2 = createResultFile(
    "menuConfig",
    "js",
    `
const headerMenuConfig = [];
const asideMenuConfig = [
  {
    name: 'Dashboard',
    path: '/',
    icon: 'smile',
  },
];
export { headerMenuConfig, asideMenuConfig };
    `
  );
  return [["src", "layouts", "BasicLayout"], file2];
}

// src/plugins/project/framework/icejs3/template/static-files.ts
function generateStaticFiles2(root = createResultDir(".")) {
  runFileGenerator(root, getFile21);
  runFileGenerator(root, getFile22);
  runFileGenerator(root, getFile23);
  runFileGenerator(root, getFile24);
  runFileGenerator(root, getFile25);
  runFileGenerator(root, getFile26);
  runFileGenerator(root, getFile27);
  runFileGenerator(root, getFile28);
  runFileGenerator(root, getFile29);
  runFileGenerator(root, getFile30);
  runFileGenerator(root, getFile31);
  runFileGenerator(root, getFile32);
  return root;
}

// src/plugins/project/framework/icejs3/template/index.ts
var icejs3Template = {
  slots: {
    components: {
      path: ["src", "components"],
      fileName: "index"
    },
    pages: {
      path: ["src", "pages"],
      fileName: "index"
    },
    entry: {
      path: ["src"],
      fileName: "app"
    },
    constants: {
      path: ["src"],
      fileName: "constants"
    },
    utils: {
      path: ["src"],
      fileName: "utils"
    },
    i18n: {
      path: ["src"],
      fileName: "i18n"
    },
    globalStyle: {
      path: ["src"],
      fileName: "global"
    },
    packageJSON: {
      path: [],
      fileName: "package"
    },
    appConfig: {
      path: ["src"],
      fileName: "app"
    },
    buildConfig: {
      path: [],
      fileName: "ice.config"
    },
    layout: {
      path: ["src", "pages"],
      fileName: "layout"
    }
  },
  generateTemplate() {
    return generateStaticFiles2();
  }
};
var template_default2 = icejs3Template;

// src/plugins/project/framework/icejs3/plugins/globalStyle.ts
var pluginFactory23 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "scss" /* SCSS */,
      name: COMMON_CHUNK_NAME.StyleDepsImport,
      content: `
        // \u5F15\u5165\u9ED8\u8BA4\u5168\u5C40\u6837\u5F0F
        @import '@alifd/next/reset.scss';
      `,
      linkAfter: []
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "scss" /* SCSS */,
      name: COMMON_CHUNK_NAME.StyleCssContent,
      content: `
        body {
          -webkit-font-smoothing: antialiased;
        }
      `,
      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "scss" /* SCSS */,
      name: COMMON_CHUNK_NAME.StyleCssContent,
      content: ir.css || "",
      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport]
    });
    return next;
  };
  return plugin;
};
var globalStyle_default2 = pluginFactory23;

// src/plugins/project/framework/icejs3/plugins/packageJSON.ts
var pluginFactory24 = (cfg) => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const packageJson = {
      name: (cfg == null ? void 0 : cfg.packageName) || "icejs3-demo-app",
      version: (cfg == null ? void 0 : cfg.packageVersion) || "0.1.5",
      description: "icejs 3 \u8F7B\u91CF\u7EA7\u6A21\u677F\uFF0C\u4F7F\u7528 JavaScript\uFF0C\u4EC5\u5305\u542B\u57FA\u7840\u7684 Layout\u3002",
      dependencies: {
        moment: "^2.24.0",
        react: "^18.2.0",
        "react-dom": "^18.2.0",
        "react-router": "^6.9.0",
        "react-router-dom": "^6.9.0",
        "intl-messageformat": "^9.3.6",
        "@alifd/next": "1.26.15",
        "@ice/runtime": "~1.1.0",
        ...buildDataSourceDependencies(ir, cfg == null ? void 0 : cfg.datasourceConfig)
      },
      devDependencies: {
        "@ice/app": "~3.1.0",
        "@types/react": "^18.0.0",
        "@types/react-dom": "^18.0.0",
        "@types/node": "^18.11.17",
        "@ice/plugin-fusion": "^1.0.1",
        "@ice/plugin-moment-locales": "^1.0.0",
        eslint: "^6.0.1",
        stylelint: "^13.2.0"
      },
      scripts: {
        start: "ice start",
        build: "ice build",
        lint: "npm run eslint && npm run stylelint",
        eslint: "eslint --cache --ext .js,.jsx ./",
        stylelint: "stylelint ./**/*.scss"
      },
      engines: {
        node: ">=14.0.0"
      },
      repository: {
        type: "git",
        url: "http://gitlab.xxx.com/msd/leak-scan/tree/master"
      },
      private: true,
      originTemplate: "@alifd/scaffold-lite-js"
    };
    ir.packages.forEach((packageInfo) => {
      packageJson.dependencies[packageInfo.package] = packageInfo.version;
    });
    next.chunks.push({
      type: "json" /* JSON */,
      fileType: "json" /* JSON */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: packageJson,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var packageJSON_default2 = pluginFactory24;

// src/plugins/project/framework/icejs3/plugins/layout.ts
var pluginFactory25 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: `
      import { Outlet } from 'ice';
      import BasicLayout from '@/layouts/BasicLayout';

      export default function Layout() {
        return (
          <BasicLayout>
            <Outlet />
          </BasicLayout>
        );;
      }
      `,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var layout_default = pluginFactory25;

// src/plugins/project/framework/icejs3/plugins/appConfig.ts
function getContent() {
  return `import { defineAppConfig } from 'ice';

// App config, see https://v3.ice.work/docs/guide/basic/app
export default defineAppConfig(() => ({
  // Set your configs here.
  app: {
    rootId: 'App',
  },
  router: {
    type: 'browser',
    basename: '/',
  },
}));`;
}
var pluginFactory26 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: getContent(),
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var appConfig_default = pluginFactory26;

// src/utils/format.ts
import prettier2 from "prettier";
import parserBabel2 from "prettier/parser-babel";
function format(content, options = {}) {
  return prettier2.format(content, {
    parser: "babel",
    plugins: [parserBabel2],
    singleQuote: true,
    jsxSingleQuote: false,
    ...options
  });
}

// src/utils/theme.ts
function getThemeInfo(theme) {
  const sepIdx = theme.indexOf("@", 1);
  if (sepIdx === -1) {
    return { name: theme };
  }
  return {
    name: theme.slice(0, sepIdx),
    version: theme.slice(sepIdx + 1)
  };
}

// src/plugins/project/framework/icejs3/plugins/buildConfig.ts
function getContent2(cfg, routesContent) {
  return `
import { join } from 'path';
import { defineConfig } from '@ice/app';
import _ from 'lodash';
import fusion from '@ice/plugin-fusion';
import locales from '@ice/plugin-moment-locales';
import type { Plugin } from '@ice/app/esm/types';

interface PluginOptions {
  id: string;
}

const plugin: Plugin<PluginOptions> = (options) => ({
  // name \u53EF\u9009\uFF0C\u63D2\u4EF6\u540D\u79F0
  name: 'plugin-name',
  // setup \u5FC5\u9009\uFF0C\u7528\u4E8E\u5B9A\u5236\u5DE5\u7A0B\u6784\u5EFA\u914D\u7F6E
  setup: ({ onGetConfig, modifyUserConfig }) => {
    modifyUserConfig('codeSplitting', 'page');

    onGetConfig((config) => {
      config.entry = {
        web: join(process.cwd(), '.ice/entry.client.tsx'),
      };

      config.cssFilename = '[name].css';

      config.configureWebpack = config.configureWebpack || [];
      config.configureWebpack?.push((webpackConfig) => {
        if (webpackConfig.output) {
          webpackConfig.output.filename = '[name].js';
          webpackConfig.output.chunkFilename = '[name].js';
        }
        return webpackConfig;
      });

      config.swcOptions = _.merge(config.swcOptions, {
        compilationConfig: {
          jsc: {
            transform: {
              react: {
                runtime: 'classic',
              },
            },
          },
        }
      });

      // \u89E3\u51B3 webpack publicPath \u95EE\u9898
      config.transforms = config.transforms || [];
      config.transforms.push((source: string, id: string) => {
        if (id.includes('.ice/entry.client.tsx')) {
          let code = \`
          if (!__webpack_public_path__?.startsWith('http') && document.currentScript) {
            // @ts-ignore
            __webpack_public_path__ = document.currentScript.src.replace(/^(.*\\\\/)[^/]+$/, '$1');
            window.__ICE_ASSETS_MANIFEST__ = window.__ICE_ASSETS_MANIFEST__ || {};
            window.__ICE_ASSETS_MANIFEST__.publicPath = __webpack_public_path__;
          }
          \`;
          code += source;
          return { code };
        }
      });
    });
  },
});

// The project config, see https://v3.ice.work/docs/guide/basic/config
const minify = process.env.NODE_ENV === 'production' ? 'swc' : false;
export default defineConfig(() => ({
  ssr: false,
  ssg: false,
  minify,
  ${routesContent}
  externals: {
    react: 'React',
    'react-dom': 'ReactDOM',
    'react-dom/client': 'ReactDOM',
    '@alifd/next': 'Next',
    lodash: 'var window._',
    '@alilc/lowcode-engine': 'var window.AliLowCodeEngine',
  },
  plugins: [
    fusion(${(cfg == null ? void 0 : cfg.themePackage) ? `{
      importStyle: 'sass',
      themePackage: '${getThemeInfo(cfg.themePackage).name}',
    }` : `{
      importStyle: 'sass',
    }`}),
    locales(),
    plugin(),
  ]
}));
  `;
}
function getRoutesContent(navData, needShell = true) {
  const routes = [
    "routes: {",
    "  defineRoutes: route => {"
  ];
  function _getRoutes(nav, _routes = []) {
    const { slug, children } = nav;
    if (children && children.length > 0) {
      children.forEach((_nav) => _getRoutes(_nav, _routes));
    } else if (slug) {
      _routes.push(`route('/${slug}', '${slug}/index.jsx');`);
    }
  }
  if (needShell) {
    routes.push("    route('/', 'layout.jsx', () => {");
  }
  navData == null ? void 0 : navData.forEach((nav) => {
    _getRoutes(nav, routes);
  });
  if (needShell) {
    routes.push("    });");
  }
  routes.push("  }");
  routes.push("  },");
  return routes.join("\n");
}
var pluginFactory27 = (cfg) => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const { navConfig } = next.contextData;
    const routesContent = (navConfig == null ? void 0 : navConfig.data) ? getRoutesContent(navConfig.data, true) : "";
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "mts" /* MTS */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: format(getContent2(cfg, routesContent)),
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var buildConfig_default = pluginFactory27;

// src/plugins/project/framework/icejs3/index.ts
var icejs3_default = {
  template: template_default2,
  plugins: {
    appConfig: appConfig_default,
    buildConfig: buildConfig_default,
    globalStyle: globalStyle_default2,
    packageJSON: packageJSON_default2,
    layout: layout_default
  }
};

// src/solutions/icejs3.ts
function createIceJsProjectBuilder2(options) {
  return createProjectBuilder({
    inStrictMode: options == null ? void 0 : options.inStrictMode,
    extraContextData: { ...options },
    template: icejs3_default.template,
    plugins: {
      components: [
        reactCommonDeps_default(),
        esmodule_default({
          fileType: "jsx"
        }),
        styleImport_default(),
        containerClass_default(),
        containerInjectContext_default(),
        containerInjectUtils_default(),
        containerInjectDataSourceEngine_default(),
        containerInjectI18n_default(),
        containerInjectConstants_default(),
        containerInitState_default(),
        containerLifeCycle_default(),
        containerMethod_default(),
        jsx_default({
          nodeTypeMapping: {
            Div: "div",
            Component: "div",
            Page: "div",
            Block: "div"
          }
        }),
        css_default()
      ],
      pages: [
        reactCommonDeps_default(),
        esmodule_default({
          fileType: "jsx"
        }),
        styleImport_default(),
        containerClass_default(),
        containerInjectContext_default(),
        containerInjectUtils_default(),
        containerInjectDataSourceEngine_default(),
        containerInjectI18n_default(),
        containerInjectConstants_default(),
        containerInitState_default(),
        containerLifeCycle_default(),
        containerMethod_default(),
        jsx_default({
          nodeTypeMapping: {
            Div: "div",
            Component: "div",
            Page: "div",
            Block: "div",
            Box: "div"
          }
        }),
        css_default()
      ],
      constants: [constants_default()],
      utils: [esmodule_default(), utils_default("react")],
      i18n: [i18n_default()],
      globalStyle: [icejs3_default.plugins.globalStyle()],
      packageJSON: [icejs3_default.plugins.packageJSON()],
      buildConfig: [icejs3_default.plugins.buildConfig()],
      appConfig: [icejs3_default.plugins.appConfig()],
      layout: [icejs3_default.plugins.layout()]
    },
    postProcessors: [prettier_default()],
    customizeBuilderOptions: options == null ? void 0 : options.customizeBuilderOptions
  });
}
var plugins2 = {
  containerClass: containerClass_default,
  containerInitState: containerInitState_default,
  containerInjectContext: containerInjectContext_default,
  containerInjectUtils: containerInjectUtils_default,
  containerInjectI18n: containerInjectI18n_default,
  containerInjectDataSourceEngine: containerInjectDataSourceEngine_default,
  containerLifeCycle: containerLifeCycle_default,
  containerMethod: containerMethod_default,
  jsx: jsx_default,
  commonDeps: reactCommonDeps_default
};

// src/plugins/component/rax/containerClass.ts
import changeCase7 from "change-case";

// src/plugins/component/rax/const.ts
var RAX_CHUNK_NAME = {
  ClassDidMountBegin: "RaxComponentClassDidMountBegin",
  ClassDidMountContent: "RaxComponentClassDidMountContent",
  ClassDidMountEnd: "RaxComponentClassDidMountEnd",
  ClassWillUnmountBegin: "RaxComponentClassWillUnmountBegin",
  ClassWillUnmountContent: "RaxComponentClassWillUnmountContent",
  ClassWillUnmountEnd: "RaxComponentClassWillUnmountEnd",
  ClassRenderBegin: "RaxComponentClassRenderBegin",
  ClassRenderPre: "RaxComponentClassRenderPre",
  ClassRenderJSX: "RaxComponentClassRenderJSX",
  ClassRenderEnd: "RaxComponentClassRenderEnd",
  MethodsBegin: "RaxComponentMethodsBegin",
  MethodsContent: "RaxComponentMethodsContent",
  MethodsEnd: "RaxComponentMethodsEnd",
  LifeCyclesBegin: "RaxComponentLifeCyclesBegin",
  LifeCyclesContent: "RaxComponentLifeCyclesContent",
  LifeCyclesEnd: "RaxComponentLifeCyclesEnd"
};

// src/plugins/component/rax/containerClass.ts
var pluginFactory28 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const componentClassName = ensureValidClassName(
      `${changeCase7.pascalCase(ir.moduleName)}$$Page`
    );
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.Start,
      content: `class ${componentClassName} extends Component {`,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.End,
      content: "}",
      linkAfter: [
        CLASS_DEFINE_CHUNK_NAME.Start,
        CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
        RAX_CHUNK_NAME.ClassRenderEnd,
        RAX_CHUNK_NAME.MethodsEnd
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.ConstructorStart,
      content: "constructor(props, context) { super(props); ",
      linkAfter: DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorStart]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: CLASS_DEFINE_CHUNK_NAME.ConstructorEnd,
      content: "} /* end of constructor */",
      linkAfter: DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorEnd]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: RAX_CHUNK_NAME.ClassDidMountBegin,
      content: "componentDidMount() {",
      linkAfter: [
        CLASS_DEFINE_CHUNK_NAME.Start,
        CLASS_DEFINE_CHUNK_NAME.InsVar,
        CLASS_DEFINE_CHUNK_NAME.InsMethod,
        CLASS_DEFINE_CHUNK_NAME.ConstructorEnd
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: RAX_CHUNK_NAME.ClassDidMountEnd,
      content: "} /* end of componentDidMount */",
      linkAfter: [RAX_CHUNK_NAME.ClassDidMountBegin, RAX_CHUNK_NAME.ClassDidMountContent]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: RAX_CHUNK_NAME.ClassWillUnmountBegin,
      content: "componentWillUnmount() {",
      linkAfter: [
        CLASS_DEFINE_CHUNK_NAME.Start,
        CLASS_DEFINE_CHUNK_NAME.InsVar,
        CLASS_DEFINE_CHUNK_NAME.InsMethod,
        RAX_CHUNK_NAME.ClassDidMountEnd
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: RAX_CHUNK_NAME.ClassWillUnmountEnd,
      content: "} /* end of componentWillUnmount */",
      linkAfter: [RAX_CHUNK_NAME.ClassWillUnmountBegin, RAX_CHUNK_NAME.ClassWillUnmountContent]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: RAX_CHUNK_NAME.ClassRenderBegin,
      content: "render() {",
      linkAfter: [RAX_CHUNK_NAME.ClassDidMountEnd, RAX_CHUNK_NAME.ClassWillUnmountEnd]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: RAX_CHUNK_NAME.ClassRenderEnd,
      content: "} /* end of render */",
      linkAfter: [
        RAX_CHUNK_NAME.ClassRenderBegin,
        RAX_CHUNK_NAME.ClassRenderPre,
        RAX_CHUNK_NAME.ClassRenderJSX
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.FileExport,
      content: `export default ${componentClassName};`,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine,
        CLASS_DEFINE_CHUNK_NAME.End
      ]
    });
    return next;
  };
  return plugin;
};
var containerClass_default2 = pluginFactory28;

// src/plugins/component/rax/containerLifeCycle.ts
import _5 from "lodash";
import { isJSExpression as isJSExpression6, isJSFunction as isJSFunction6 } from "@alilc/lowcode-types";

// src/utils/debug.ts
import createDebug from "debug";
var debug = createDebug("code-generator");

// src/plugins/component/rax/containerLifeCycle.ts
var pluginFactory29 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    exportNameMapping: {},
    normalizeNameMapping: {
      didMount: "componentDidMount",
      willUnmount: "componentWillUnmount"
    },
    ...config
  };
  const exportNameMapping = new Map(Object.entries(cfg.exportNameMapping));
  const normalizeNameMapping = new Map(Object.entries(cfg.normalizeNameMapping));
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const { lifeCycles } = ir;
    if (lifeCycles && !_5.isEmpty(lifeCycles)) {
      Object.entries(lifeCycles).forEach(([lifeCycleName, lifeCycleMethodExpr]) => {
        if (!isJSFunction6(lifeCycles[lifeCycleName]) && !isJSExpressionFn(lifeCycles[lifeCycleName]) && !isJSExpression6(lifeCycles[lifeCycleName])) {
          return;
        }
        const normalizeName = normalizeNameMapping.get(lifeCycleName) || lifeCycleName;
        const exportName = exportNameMapping.get(lifeCycleName) || lifeCycleName;
        next.chunks.push({
          type: "string" /* STRING */,
          fileType: cfg.fileType,
          name: RAX_CHUNK_NAME.LifeCyclesContent,
          content: `${exportName}: (${lifeCycleMethodExpr.value}),`,
          linkAfter: [RAX_CHUNK_NAME.LifeCyclesBegin]
        });
        if (normalizeName === "constructor") {
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
            content: `this._lifeCycles.${exportName}();`,
            linkAfter: [CLASS_DEFINE_CHUNK_NAME.ConstructorStart]
          });
        } else if (normalizeName === "componentDidMount") {
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: RAX_CHUNK_NAME.ClassDidMountContent,
            content: `this._lifeCycles.${exportName}();`,
            linkAfter: [RAX_CHUNK_NAME.ClassDidMountBegin]
          });
        } else if (normalizeName === "componentWillUnmount") {
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: RAX_CHUNK_NAME.ClassWillUnmountContent,
            content: `this._lifeCycles.${exportName}();`,
            linkAfter: [RAX_CHUNK_NAME.ClassWillUnmountBegin]
          });
        } else {
          debug(`[CodeGen]: unknown life cycle: ${lifeCycleName}`);
        }
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: "_lifeCycles = this._defineLifeCycles();",
        linkAfter: [CLASS_DEFINE_CHUNK_NAME.Start]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: RAX_CHUNK_NAME.LifeCyclesBegin,
        content: `
          _defineLifeCycles() {
            const __$$lifeCycles = ({
        `,
        linkAfter: [RAX_CHUNK_NAME.ClassRenderEnd, CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: RAX_CHUNK_NAME.LifeCyclesEnd,
        content: `
            });

            // \u4E3A\u6240\u6709\u7684\u65B9\u6CD5\u7ED1\u5B9A\u4E0A\u4E0B\u6587
            Object.entries(__$$lifeCycles).forEach(([lifeCycleName, lifeCycleMethod]) => {
              if (typeof lifeCycleMethod === 'function') {
                __$$lifeCycles[lifeCycleName] = (...args) => {
                  return lifeCycleMethod.apply(this._context, args);
                }
              }
            });

            return __$$lifeCycles;
          }
        `,
        linkAfter: [RAX_CHUNK_NAME.LifeCyclesBegin, RAX_CHUNK_NAME.LifeCyclesContent]
      });
    }
    return next;
  };
  return plugin;
};
var containerLifeCycle_default2 = pluginFactory29;

// src/plugins/component/rax/containerMethods.ts
var pluginFactory30 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsVar,
      content: `
         _methods = this._defineMethods();
      `,
      linkAfter: [CLASS_DEFINE_CHUNK_NAME.Start]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: RAX_CHUNK_NAME.MethodsBegin,
      content: `
        _defineMethods() {
          return ({
      `,
      linkAfter: [
        RAX_CHUNK_NAME.ClassRenderEnd,
        CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
        RAX_CHUNK_NAME.LifeCyclesEnd
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: RAX_CHUNK_NAME.MethodsEnd,
      content: `
          });
        }
      `,
      linkAfter: [RAX_CHUNK_NAME.MethodsBegin, RAX_CHUNK_NAME.MethodsContent]
    });
    if (ir.methods && Object.keys(ir.methods).length > 0) {
      Object.entries(ir.methods).forEach(([methodName, methodDefine]) => {
        next.chunks.push({
          type: "string" /* STRING */,
          fileType: cfg.fileType,
          name: RAX_CHUNK_NAME.MethodsContent,
          content: `${methodName}: (${methodDefine.value}),`,
          linkAfter: [RAX_CHUNK_NAME.MethodsBegin]
        });
      });
    }
    return next;
  };
  return plugin;
};
var containerMethods_default = pluginFactory30;

// src/plugins/component/rax/containerInitState.ts
var pluginFactory31 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    implementType: "insMember",
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const scope = Scope.createRootScope();
    const state = ir.state || {};
    const fields = Object.keys(state).map((stateName) => {
      const value = generateCompositeType(state[stateName], scope);
      return `${JSON.stringify(stateName)}: ${value}`;
    });
    if (cfg.implementType === "inConstructor") {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
        content: `this.state = { ${fields.join(",")} };`,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorContent]]
      });
    } else if (cfg.implementType === "insMember") {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: CLASS_DEFINE_CHUNK_NAME.InsVar,
        content: `state = { ${fields.join(",")} };`,
        linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.InsVar]]
      });
    }
    return next;
  };
  return plugin;
};
var containerInitState_default2 = pluginFactory31;

// src/plugins/component/rax/containerInjectContext.ts
var pluginFactory32 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    var _a;
    const next = {
      ...pre
    };
    const ir = next.ir;
    const useRef = !!((_a = ir.analyzeResult) == null ? void 0 : _a.isUsingRef);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: "import __$$constants from '../../constants';",
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: "import * as __$$i18n from '../../i18n';",
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.ConstructorContent,
      content: `
        __$$i18n._inject2(this);
      `,
      linkAfter: [...DEFAULT_LINK_AFTER[CLASS_DEFINE_CHUNK_NAME.ConstructorContent]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsVar,
      content: `
        _context = this._createContext();
      `,
      linkAfter: [CLASS_DEFINE_CHUNK_NAME.Start]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
      content: `
        _createContext() {
          const self = this;
          const context = {
            get state() {
              return self.state;
            },
            setState(newState, callback) {
              self.setState(newState, callback);
            },
            get dataSourceMap() {
              return self._dataSourceEngine.dataSourceMap || {};
            },
            async reloadDataSource() {
              await self._dataSourceEngine.reloadDataSource();
            },
            get utils() {
              return self._utils;
            },
            get page() {
              return context;
            },
            get component() {
              return context;
            },
            get props() {
              return self.props;
            },
            get constants() {
              return __$$constants;
            },
            i18n: __$$i18n.i18n,
            i18nFormat: __$$i18n.i18nFormat,
            getLocale: __$$i18n.getLocale,
            setLocale(locale) {
              __$$i18n.setLocale(locale);
              self.forceUpdate();
            },${useRef ? `
                  $(refName) {
                    return self._refsManager.get(refName);
                  },
                  $$(refName) {
                    return self._refsManager.getAll(refName);
                  },
                  get _refsManager() {
                    if (!self._refsManager) {
                      self._refsManager = new RefsManager();
                    }
                    return self._refsManager;
                  },
                ` : ""}
            ...this._methods,
          };

          return context;
        }
      `,
      linkAfter: [RAX_CHUNK_NAME.ClassRenderEnd]
    });
    return next;
  };
  return plugin;
};
var containerInjectContext_default2 = pluginFactory32;

// src/plugins/component/rax/containerInjectDataSourceEngine.ts
import {
  isJSExpression as isJSExpression7,
  isJSFunction as isJSFunction7
} from "@alilc/lowcode-types";
import changeCase8 from "change-case";
var pluginFactory33 = (config) => {
  var _a;
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config,
    dataSourceHandlersPackageMap: (config == null ? void 0 : config.dataSourceHandlersPackageMap) || ((_a = config == null ? void 0 : config.datasourceConfig) == null ? void 0 : _a.handlersPackages)
  };
  const plugin = async (pre) => {
    var _a2;
    const next = {
      ...pre
    };
    const scope = Scope.createRootScope();
    const dataSourceConfig = isContainerSchema(pre.ir) ? pre.ir.dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    const dataSourceEngineOptions = { runtimeConfig: true };
    if (dataSourceItems.length > 0) {
      const requestHandlersMap = {};
      dataSourceItems.forEach((ds) => {
        var _a3;
        const dsType = ds.type || "fetch";
        if (!(dsType in requestHandlersMap) && dsType !== "custom") {
          const handlerFactoryName = `__$$create${changeCase8.pascal(dsType)}RequestHandler`;
          requestHandlersMap[dsType] = {
            type: "JSExpression",
            value: `${handlerFactoryName}(${dsType === "urlParams" ? "__$$getSearchParams()" : ""})`
          };
          const handlerFactoryExportName = `create${changeCase8.pascal(dsType)}Handler`;
          const handlerPkgName = ((_a3 = cfg.dataSourceHandlersPackageMap) == null ? void 0 : _a3[dsType]) || `@alilc/lowcode-datasource-${changeCase8.kebab(dsType)}-handler`;
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "jsx" /* JSX */,
            name: COMMON_CHUNK_NAME.ExternalDepsImport,
            content: `
              import { ${handlerFactoryExportName} as ${handlerFactoryName} } from '${handlerPkgName}';
            `,
            linkAfter: []
          });
        }
      });
      Object.assign(dataSourceEngineOptions, { requestHandlersMap });
    }
    const datasourceEnginePackageName = ((_a2 = cfg.datasourceConfig) == null ? void 0 : _a2.enginePackage) || "@alilc/lowcode-datasource-engine";
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.ExternalDepsImport,
      content: `
        import { create as __$$createDataSourceEngine } from '${datasourceEnginePackageName}/runtime';
      `,
      linkAfter: []
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsVar,
      content: `
        _dataSourceConfig = this._defineDataSourceConfig();
        _dataSourceEngine = __$$createDataSourceEngine(
          this._dataSourceConfig,
          this._context,
          ${generateCompositeType(dataSourceEngineOptions, scope)}
        );`,
      linkAfter: [CLASS_DEFINE_CHUNK_NAME.Start]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: RAX_CHUNK_NAME.ClassDidMountContent,
      content: `
        this._dataSourceEngine.reloadDataSource();
      `,
      linkAfter: [RAX_CHUNK_NAME.ClassDidMountBegin]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
      content: `
_defineDataSourceConfig() {
  const __$$context = this._context;
  return (${generateCompositeType(
        {
          ...dataSourceConfig,
          list: [
            ...dataSourceItems.map((item) => {
              var _a3;
              return {
                errorHandler: {
                  type: "JSFunction",
                  value: `function (err){
              setTimeout(() => {
                this.setState({ __refresh: Date.now() + Math.random() });
              }, 0);
              throw err;
            }`
                },
                ...item,
                isInit: typeof item.isInit === "boolean" || typeof item.isInit === "undefined" ? (_a3 = item.isInit) != null ? _a3 : true : wrapAsFunction2(item.isInit, scope),
                options: wrapAsFunction2(item.options, scope)
              };
            })
          ]
        },
        scope,
        {
          handlers: {
            function: (jsFunc) => parseExpressionConvertThis2Context(jsFunc.value, "__$$context"),
            expression: (jsExpr) => parseExpressionConvertThis2Context(jsExpr.value, "__$$context")
          }
        }
      )});
}
      `,
      linkAfter: [RAX_CHUNK_NAME.ClassRenderEnd]
    });
    return next;
  };
  return plugin;
};
var containerInjectDataSourceEngine_default2 = pluginFactory33;
function wrapAsFunction2(value, scope) {
  if (isJSExpression7(value) || isJSFunction7(value)) {
    return {
      type: "JSExpression",
      value: `function(){ return ((${value.value}))}`
    };
  }
  return {
    type: "JSExpression",
    value: `function(){return((${generateCompositeType(value, scope)}))}`
  };
}

// src/plugins/component/rax/containerInjectUtils.ts
var pluginFactory34 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    var _a;
    const next = {
      ...pre
    };
    const ir = next.ir;
    const useRef = !!((_a = ir.analyzeResult) == null ? void 0 : _a.isUsingRef);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: `
        import __$$projectUtils${useRef ? ", { RefsManager }" : ""} from '../../utils';
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsVar,
      content: "_utils = this._defineUtils();",
      linkAfter: [CLASS_DEFINE_CHUNK_NAME.Start]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: CLASS_DEFINE_CHUNK_NAME.InsPrivateMethod,
      content: `
        _defineUtils() {
          return {
            ...__$$projectUtils,
          };
        }`,
      linkAfter: [RAX_CHUNK_NAME.ClassRenderEnd]
    });
    return next;
  };
  return plugin;
};
var containerInjectUtils_default2 = pluginFactory34;

// src/plugins/component/rax/jsx.ts
import {
  isJSExpression as isJSExpression8
} from "@alilc/lowcode-types";
import _6 from "lodash";
import changeCase9 from "change-case";
var pluginFactory35 = (config) => {
  const cfg = {
    fileType: "jsx" /* JSX */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const rootScope = Scope.createRootScope();
    const { tolerateEvalErrors = true, evalErrorsHandler = "" } = next.contextData;
    const componentsNameAliasMap = /* @__PURE__ */ new Map();
    next.chunks.forEach((chunk) => {
      if (isImportAliasDefineChunk(chunk)) {
        componentsNameAliasMap.set(chunk.ext.aliasName, chunk.ext.originalName);
      }
    });
    const mapComponentNameToAliasOrKeepIt = (componentName) => componentsNameAliasMap.get(componentName) || componentName;
    next.chunks = next.chunks.filter((chunk) => !isImportAliasDefineChunk(chunk));
    const customHandlers = {
      expression(input, scope) {
        return transformJsExpr(generateExpression(input, scope), scope, {
          dontWrapEval: !tolerateEvalErrors
        });
      },
      function(input, scope) {
        return transformThis2Context(input.value || "null", scope);
      }
    };
    const commonNodeGenerator = createNodeGenerator({
      handlers: customHandlers,
      tagMapping: mapComponentNameToAliasOrKeepIt,
      nodePlugins: [generateReactExprInJS, generateConditionReactCtrl, generateRaxLoopCtrl],
      attrPlugins: [generateNodeAttrForRax.bind({ cfg })]
    });
    const jsxContent = commonNodeGenerator(ir, rootScope);
    if (!cfg.ignoreMiniApp) {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: COMMON_CHUNK_NAME.ExternalDepsImport,
        content: "import { isMiniApp as __$$isMiniApp } from 'universal-env';",
        linkAfter: []
      });
    }
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: RAX_CHUNK_NAME.ClassRenderPre,
      content: `
        const __$$context = this._context;
        const { state, setState, dataSourceMap, reloadDataSource, utils, constants, i18n, i18nFormat, getLocale, setLocale } = __$$context;
      `,
      linkAfter: [RAX_CHUNK_NAME.ClassRenderBegin]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: RAX_CHUNK_NAME.ClassRenderJSX,
      content: `return ${jsxContent};`,
      linkAfter: [RAX_CHUNK_NAME.ClassRenderBegin, RAX_CHUNK_NAME.ClassRenderPre]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.CustomContent,
      content: [
        tolerateEvalErrors && `
        function __$$eval(expr) {
          try {
            return expr();
          } catch (error) {
            ${evalErrorsHandler}
          }
        }

        function __$$evalArray(expr) {
          const res = __$$eval(expr);
          return Array.isArray(res) ? res : [];
        }
        `,
        `
        function __$$createChildContext(oldContext, ext) {
          return Object.assign({}, oldContext, ext);
        }
      `
      ].filter(Boolean).join("\n"),
      linkAfter: [COMMON_CHUNK_NAME.FileExport]
    });
    return next;
    function generateRaxLoopCtrl(nodeItem, scope, config2, next2) {
      var _a, _b;
      if (nodeItem.loop) {
        const loopItemName = ((_a = nodeItem.loopArgs) == null ? void 0 : _a[0]) || "item";
        const loopIndexName = ((_b = nodeItem.loopArgs) == null ? void 0 : _b[1]) || "index";
        const subScope = scope.createSubScope([loopItemName, loopIndexName]);
        const pieces = next2 ? next2(nodeItem, subScope, config2) : [];
        const loopDataExpr = tolerateEvalErrors ? `__$$evalArray(() => (${transformThis2Context(
          generateCompositeType(nodeItem.loop, scope, { handlers: config2 == null ? void 0 : config2.handlers }),
          scope
        )}))` : `(${transformThis2Context(
          generateCompositeType(nodeItem.loop, scope, { handlers: config2 == null ? void 0 : config2.handlers }),
          scope
        )})`;
        pieces.unshift({
          value: `${loopDataExpr}.map((${loopItemName}, ${loopIndexName}) => ((__$$context) => (`,
          type: "NodeCodePieceBefore" /* BEFORE */
        });
        pieces.push({
          value: `))(__$$createChildContext(__$$context, { ${loopItemName}, ${loopIndexName} })))`,
          type: "NodeCodePieceAfter" /* AFTER */
        });
        return pieces;
      }
      return next2 ? next2(nodeItem, scope, config2) : [];
    }
  };
  return plugin;
};
var jsx_default2 = pluginFactory35;
function isImportAliasDefineChunk(chunk) {
  var _a;
  return chunk.name === COMMON_CHUNK_NAME.ImportAliasDefine && !!chunk.ext && typeof chunk.ext.aliasName === "string" && typeof chunk.ext.originalName === "string" && !!((_a = chunk.ext.dependency) == null ? void 0 : _a.componentName);
}
function generateNodeAttrForRax(attrData, scope, config, next) {
  if (!this.cfg.ignoreMiniApp && /^on/.test(attrData.attrName)) {
    return generateEventHandlerAttrForRax(attrData.attrName, attrData.attrValue, scope, config);
  }
  if (attrData.attrName === "ref") {
    return [
      {
        name: attrData.attrName,
        value: `__$$context._refsManager.linkRef('${attrData.attrValue}')`,
        type: "NodeCodePieceAttr" /* ATTR */
      }
    ];
  }
  return next ? next(attrData, scope, config) : [];
}
function generateEventHandlerAttrForRax(attrName, attrValue, scope, config) {
  var _a;
  const valueExpr = generateCompositeType(
    isJSExpression8(attrValue) ? { type: "JSFunction", value: attrValue.value } : attrValue,
    scope,
    {
      handlers: config == null ? void 0 : config.handlers
    }
  );
  const currentScopeVariables = ((_a = scope.bindings) == null ? void 0 : _a.getAllBindings()) || [];
  if (currentScopeVariables.length <= 0) {
    return [
      {
        type: "NodeCodePieceAttr" /* ATTR */,
        name: attrName,
        value: valueExpr
      }
    ];
  }
  const undeclaredVariablesInValueExpr = parseExpressionGetGlobalVariables(valueExpr);
  const referencedLocalVariables = _6.intersection(
    undeclaredVariablesInValueExpr,
    currentScopeVariables
  );
  if (referencedLocalVariables.length <= 0) {
    return [
      {
        type: "NodeCodePieceAttr" /* ATTR */,
        name: attrName,
        value: valueExpr
      }
    ];
  }
  const wrappedAttrValueExpr = [
    "(...__$$args) => {",
    "  if (__$$isMiniApp) {",
    "    const __$$event = __$$args[0];",
    ...referencedLocalVariables.map(
      (localVar) => `const ${localVar} = __$$event.target.dataset.${localVar};`
    ),
    `    return (${valueExpr}).apply(this, __$$args);`,
    "  } else {",
    `    return (${valueExpr}).apply(this, __$$args);`,
    "  }",
    "}"
  ].join("\n");
  return [
    ...referencedLocalVariables.map((localVar) => ({
      type: "NodeCodePieceAttr" /* ATTR */,
      name: `data-${changeCase9.snake(localVar)}`,
      value: localVar
    })),
    {
      type: "NodeCodePieceAttr" /* ATTR */,
      name: attrName,
      value: wrappedAttrValueExpr
    }
  ];
}

// src/plugins/component/rax/commonDeps.ts
var pluginFactory36 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.ExternalDepsImport,
      content: `
        // \u6CE8\u610F: \u51FA\u7801\u5F15\u64CE\u6CE8\u5165\u7684\u4E34\u65F6\u53D8\u91CF\u9ED8\u8BA4\u90FD\u4EE5 "__$$" \u5F00\u5934\uFF0C\u7981\u6B62\u5728\u642D\u5EFA\u7684\u4EE3\u7801\u4E2D\u76F4\u63A5\u8BBF\u95EE\u3002
        // \u4F8B\u5916\uFF1Arax \u6846\u67B6\u7684\u5BFC\u51FA\u540D\u548C\u5404\u79CD\u7EC4\u4EF6\u540D\u9664\u5916\u3002
        import { createElement, Component } from 'rax';
        import { getSearchParams as __$$getSearchParams } from 'rax-app';
      `,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var commonDeps_default = pluginFactory36;

// src/plugins/project/framework/rax/template/files/.eslintignore.ts
function getFile33() {
  return [
    ["."],
    {
      name: ".eslintignore",
      ext: "",
      content: "node_modules/\nlib/\ndist/\nbuild/\ncoverage/\ndemo/\nes/\n.rax/\n"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/.eslintrc.js.ts
function getFile34() {
  return [
    ["."],
    {
      name: ".eslintrc",
      ext: "js",
      content: "const { getESLintConfig } = require('@iceworks/spec');\n\n// https://www.npmjs.com/package/@iceworks/spec\nmodule.exports = {\n  ...getESLintConfig('rax'),\n  rules: {\n    'max-len': ['error', { code: 200 }],\n    'function-paren-newline': 'off',\n    '@typescript-eslint/indent': 'off',\n    'prettier/prettier': 'off',\n    'no-empty': 'off',\n    'no-unused-vars': 'off',\n    '@iceworks/best-practices/recommend-functional-component': 'off',\n  },\n};\n"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/.gitignore.ts
function getFile35() {
  return [
    ["."],
    {
      name: ".gitignore",
      ext: "",
      content: "# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.\n\n*~\n*.swp\n*.log\n\n.DS_Store\n.idea/\n.temp/\n\nbuild/\ndist/\nlib/\ncoverage/\nnode_modules/\n.rax/\n\ntemplate.yml"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/.prettierignore.ts
function getFile36() {
  return [
    ["."],
    {
      name: ".prettierignore",
      ext: "",
      content: "node_modules/\nlib/\ndist/\nbuild/\ncoverage/\ndemo/\nes/\n.rax/\n"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/.prettierrc.js.ts
function getFile37() {
  return [
    ["."],
    {
      name: ".prettierrc",
      ext: "js",
      content: "const { getPrettierConfig } = require('@iceworks/spec');\n\nmodule.exports = getPrettierConfig('rax');\n"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/.stylelintignore.ts
function getFile38() {
  return [
    ["."],
    {
      name: ".stylelintignore",
      ext: "",
      content: "node_modules/\nlib/\ndist/\nbuild/\ncoverage/\ndemo/\nes/\n.rax/\n"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/.stylelintrc.js.ts
function getFile39() {
  return [
    ["."],
    {
      name: ".stylelintrc",
      ext: "js",
      content: "const { getStylelintConfig } = require('@iceworks/spec');\n\nmodule.exports = getStylelintConfig('rax');\n"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/jsconfig.json.ts
function getFile40() {
  return [
    ["."],
    {
      name: "jsconfig",
      ext: "json",
      content: '{\n  "compilerOptions": {\n    "baseUrl": ".",\n    "jsx": "react",\n    "paths": {\n      "@/*": ["./src/*"],\n      "rax-app": [".rax/index.ts"]\n    }\n  }\n}\n'
    }
  ];
}

// src/plugins/project/framework/rax/template/files/README.md.ts
function getFile41() {
  return [
    ["."],
    {
      name: "README",
      ext: "md",
      content: "# rax-materials-basic-app\n\n## Getting Started\n\n### `npm run start`\n\nRuns the app in development mode.\n\nOpen [http://localhost:3333](http://localhost:3333) to view it in the browser.\n\nThe page will reload if you make edits.\n\n### `npm run build`\n\nBuilds the app for production to the `build` folder.\n"
    }
  ];
}

// src/plugins/project/framework/rax/template/files/tsconfig.json.ts
function getFile42() {
  return [
    ["."],
    {
      name: "tsconfig",
      ext: "json",
      content: '{\n  "compileOnSave": false,\n  "buildOnSave": false,\n  "compilerOptions": {\n    "baseUrl": ".",\n    "outDir": "build",\n    "module": "esnext",\n    "target": "es6",\n    "jsx": "preserve",\n    "jsxFactory": "createElement",\n    "moduleResolution": "node",\n    "allowSyntheticDefaultImports": true,\n    "lib": ["es6", "dom"],\n    "sourceMap": true,\n    "allowJs": true,\n    "rootDir": "./",\n    "forceConsistentCasingInFileNames": true,\n    "noImplicitReturns": true,\n    "noImplicitThis": true,\n    "noImplicitAny": false,\n    "importHelpers": true,\n    "strictNullChecks": true,\n    "suppressImplicitAnyIndexErrors": true,\n    "noUnusedLocals": true,\n    "skipLibCheck": true,\n    "paths": {\n      "@/*": ["./src/*"],\n      "rax-app": [".rax/index.ts"]\n    }\n  },\n  "include": ["src", ".rax"],\n  "exclude": ["node_modules", "build", "public"]\n}'
    }
  ];
}

// src/plugins/project/framework/rax/template/static-files.ts
function generateStaticFiles3(root = createResultDir(".")) {
  runFileGenerator(root, getFile33);
  runFileGenerator(root, getFile34);
  runFileGenerator(root, getFile35);
  runFileGenerator(root, getFile36);
  runFileGenerator(root, getFile37);
  runFileGenerator(root, getFile38);
  runFileGenerator(root, getFile39);
  runFileGenerator(root, getFile40);
  runFileGenerator(root, getFile41);
  runFileGenerator(root, getFile42);
  return root;
}

// src/plugins/project/framework/rax/template/index.ts
var raxAppTemplate = {
  slots: {
    components: {
      path: ["src", "components"]
    },
    pages: {
      path: ["src", "pages"]
    },
    router: {
      path: ["src"],
      fileName: "router"
    },
    entry: {
      path: ["src"],
      fileName: "app"
    },
    appConfig: {
      path: ["src"],
      fileName: "app"
    },
    buildConfig: {
      path: [],
      fileName: "build"
    },
    constants: {
      path: ["src"],
      fileName: "constants"
    },
    utils: {
      path: ["src"],
      fileName: "utils"
    },
    i18n: {
      path: ["src"],
      fileName: "i18n"
    },
    globalStyle: {
      path: ["src"],
      fileName: "global"
    },
    htmlEntry: {
      path: ["src", "document"],
      fileName: "index"
    },
    packageJSON: {
      path: [],
      fileName: "package"
    }
  },
  async generateTemplate() {
    return generateStaticFiles3();
  }
};
var template_default3 = raxAppTemplate;

// src/plugins/project/framework/rax/plugins/entry.ts
var pluginFactory37 = (cfg) => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.ExternalDepsImport,
      content: `
import { runApp } from 'rax-app';

import './global.${(cfg == null ? void 0 : cfg.globalStylesFileType) || "css"}';
`,
      linkAfter: []
    });
    const appConfig = (cfg == null ? void 0 : cfg.appConfig) || {};
    Object.assign(appConfig, {
      router: {
        mode: "hash",
        ...appConfig.router
      }
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "js" /* JS */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: `
runApp(${JSON.stringify(appConfig, null, 2)});
`,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.ImportAliasDefine,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileUtilDefine
      ]
    });
    return next;
  };
  return plugin;
};
var entry_default2 = pluginFactory37;

// src/plugins/project/framework/rax/plugins/appConfig.ts
import changeCase10 from "change-case";
var pluginFactory38 = (cfg) => {
  const plugin = async (pre) => {
    var _a, _b, _c, _d, _e, _f;
    const next = {
      ...pre
    };
    const ir = next.ir;
    const routes = ((_b = (_a = ir.globalRouter) == null ? void 0 : _a.routes) == null ? void 0 : _b.map((route) => ({
      path: route.path,
      source: `pages/${ensureValidClassName(changeCase10.pascalCase(route.fileName))}/index`
    }))) || [{ path: "/", source: "pages/Home/index" }];
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "json" /* JSON */,
      name: COMMON_CHUNK_NAME.CustomContent,
      content: `
{
  "routes": ${JSON.stringify(routes, null, 2)},
  "window": {
    "title": ${JSON.stringify(
        (cfg == null ? void 0 : cfg.title) || ((_d = (_c = ir.project) == null ? void 0 : _c.meta) == null ? void 0 : _d.title) || ((_f = (_e = ir.project) == null ? void 0 : _e.meta) == null ? void 0 : _f.name) || ""
      )}
  }
}
      `,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var appConfig_default2 = pluginFactory38;

// src/plugins/project/framework/rax/plugins/buildConfig.ts
var pluginFactory39 = (cfg) => {
  const plugin = async (pre) => {
    var _a, _b, _c, _d, _e;
    const next = {
      ...pre
    };
    const ir = next.ir;
    const miniAppBuildType = ((_a = cfg == null ? void 0 : cfg.buildConfig) == null ? void 0 : _a.miniAppBuildType) || ((_c = (_b = ir.project) == null ? void 0 : _b.config) == null ? void 0 : _c.miniAppBuildType);
    const targets = (cfg == null ? void 0 : cfg.targets) || ["web"];
    const buildCfg = {
      inlineStyle: false,
      plugins: [],
      targets,
      miniapp: miniAppBuildType ? {
        buildType: miniAppBuildType,
        ...(_d = cfg == null ? void 0 : cfg.buildConfig) == null ? void 0 : _d.miniapp
      } : (_e = cfg == null ? void 0 : cfg.buildConfig) == null ? void 0 : _e.miniapp,
      ...cfg == null ? void 0 : cfg.buildConfig
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "json" /* JSON */,
      name: COMMON_CHUNK_NAME.CustomContent,
      content: `${JSON.stringify(buildCfg, null, 2)}
`,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var buildConfig_default2 = pluginFactory39;

// src/plugins/project/framework/rax/plugins/entryDocument.ts
var pluginFactory40 = (cfg) => {
  const plugin = async (pre) => {
    var _a;
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.CustomContent,
      content: `
import { createElement } from 'rax';
import { Root, Style, Script } from 'rax-document';

function Document() {
  return (
    <html>
      <head>
        <meta charset="utf-8" />
        <meta
          name="viewport"
          content="width=device-width,initial-scale=1,maximum-scale=1,minimum-scale=1,user-scalable=no,viewport-fit=cover"
        />
        <title>${(cfg == null ? void 0 : cfg.title) || ((_a = ir == null ? void 0 : ir.meta) == null ? void 0 : _a.name) || "Rax App"}</title>
        <Style />
      </head>
      <body>
        {/* root container */}
        <Root />
        <Script />
      </body>
    </html>
  );
}

export default Document;
`,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var entryDocument_default = pluginFactory40;

// src/plugins/project/framework/rax/plugins/globalStyle.ts
var pluginFactory41 = (config) => {
  const cfg = {
    fileType: "scss" /* SCSS */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.StyleDepsImport,
      content: "",
      linkAfter: []
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.StyleCssContent,
      content: `
body {
  -webkit-font-smoothing: antialiased;
}
`,
      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: COMMON_CHUNK_NAME.StyleCssContent,
      content: ir.css || "",
      linkAfter: [COMMON_CHUNK_NAME.StyleDepsImport]
    });
    return next;
  };
  return plugin;
};
var globalStyle_default3 = pluginFactory41;

// src/utils/version.ts
var version_exports = {};
__export(version_exports, {
  calcCompatibleVersion: () => calcCompatibleVersion
});
import semver from "semver";
function calcCompatibleVersion(v1, v2) {
  if (!v1 && !v2) {
    return "*";
  }
  if (!v1 || v1 === "*") {
    return v2 || "*";
  }
  if (!v2 || v2 === "*") {
    return v1;
  }
  if (v1 === v2) {
    return v1;
  }
  if (!semver.intersects(v1, v2, { loose: true })) {
    throw new Error(`no compatible versions for "${v1}" and "${v2}"`);
  }
  if (semver.subset(v1, v2, { loose: true })) {
    return v1;
  }
  return v2;
}

// src/plugins/project/framework/rax/plugins/packageJSON.ts
var pluginFactory42 = (cfg) => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const npmDeps = getNpmDependencies(ir);
    const packageJson = {
      name: (cfg == null ? void 0 : cfg.packageName) || "rax-demo-app",
      private: true,
      version: (cfg == null ? void 0 : cfg.packageVersion) || "1.0.0",
      scripts: {
        start: "rax-app start",
        build: "rax-app build",
        eslint: "eslint --ext .js,.jsx ./",
        stylelint: 'stylelint "**/*.{css,scss,less}"',
        prettier: "prettier **/* --write",
        lint: "npm run eslint && npm run stylelint"
      },
      dependencies: {
        ...buildDataSourceDependencies(ir, cfg == null ? void 0 : cfg.datasourceConfig),
        "universal-env": "^3.2.0",
        "intl-messageformat": "^9.3.6",
        rax: "^1.1.0",
        "rax-document": "^0.1.6",
        ...npmDeps.reduce(
          (acc, npm) => ({
            ...acc,
            [npm.package]: npm.version || "*"
          }),
          {}
        )
      },
      devDependencies: {
        "@iceworks/spec": "^1.0.0",
        "rax-app": "^3.0.0",
        eslint: "^6.8.0",
        prettier: "^2.1.2",
        stylelint: "^13.7.2"
      }
    };
    next.chunks.push({
      type: "json" /* JSON */,
      fileType: "json" /* JSON */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: packageJson,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var packageJSON_default3 = pluginFactory42;
function getNpmDependencies(project) {
  const npmDeps = [];
  const npmNameToPkgMap = /* @__PURE__ */ new Map();
  const allDeps = project.packages;
  allDeps.forEach((dep) => {
    if (!isNpmInfo(dep)) {
      return;
    }
    const existing = npmNameToPkgMap.get(dep.package);
    if (!existing) {
      npmNameToPkgMap.set(dep.package, dep);
      npmDeps.push(dep);
      return;
    }
    if (existing.version !== dep.version) {
      try {
        npmNameToPkgMap.set(dep.package, {
          ...existing,
          version: calcCompatibleVersion(existing.version, dep.version)
        });
      } catch (e) {
        throw new Error(
          `Cannot find compatible version for ${dep.package}. Detail: ${getErrorMessage(e)}`
        );
      }
    }
  });
  return npmDeps;
}

// src/plugins/project/framework/rax/index.ts
var rax_default = {
  template: template_default3,
  plugins: {
    appConfig: appConfig_default2,
    buildConfig: buildConfig_default2,
    entry: entry_default2,
    entryDocument: entryDocument_default,
    globalStyle: globalStyle_default3,
    packageJSON: packageJSON_default3
  }
};

// src/solutions/rax-app.ts
function createRaxProjectBuilder(options) {
  return createProjectBuilder({
    inStrictMode: options == null ? void 0 : options.inStrictMode,
    extraContextData: { ...options },
    template: rax_default.template,
    plugins: {
      components: [
        commonDeps_default(),
        esmodule_default({ fileType: "jsx", useAliasName: false }),
        containerClass_default2(),
        containerInitState_default2(),
        containerMethods_default(),
        containerInjectContext_default2(),
        containerInjectDataSourceEngine_default2(options),
        containerInjectUtils_default2(),
        containerLifeCycle_default2(),
        jsx_default2(),
        css_default()
      ],
      pages: [
        commonDeps_default(),
        esmodule_default({ fileType: "jsx" }),
        containerClass_default2(),
        containerInitState_default2(),
        containerMethods_default(),
        containerInjectContext_default2(),
        containerInjectDataSourceEngine_default2(options),
        containerInjectUtils_default2(),
        containerLifeCycle_default2(),
        jsx_default2(),
        css_default()
      ],
      appConfig: [rax_default.plugins.appConfig(options)],
      buildConfig: [rax_default.plugins.buildConfig(options)],
      entry: [rax_default.plugins.entry(options)],
      constants: [constants_default()],
      utils: [esmodule_default(), utils_default("rax")],
      i18n: [i18n_default()],
      globalStyle: [
        rax_default.plugins.globalStyle({ fileType: (options == null ? void 0 : options.globalStylesFileType) || "css" })
      ],
      htmlEntry: [rax_default.plugins.entryDocument(options)],
      packageJSON: [rax_default.plugins.packageJSON(options)]
    },
    postProcessors: [prettier_default()],
    customizeBuilderOptions: options == null ? void 0 : options.customizeBuilderOptions
  });
}
var plugins3 = {
  containerClass: containerClass_default2,
  containerLifeCycles: containerLifeCycle_default2,
  containerMethods: containerMethods_default,
  containerInitState: containerInitState_default2,
  containerInjectContext: containerInjectContext_default2,
  containerInjectDataSourceEngine: containerInjectDataSourceEngine_default2,
  containerInjectUtils: containerInjectUtils_default2,
  jsx: jsx_default2,
  commonDeps: commonDeps_default,
  raxApp: rax_default
};

// src/plugins/component/vue/containerVue.ts
var pluginFactory43 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart,
      content: "<template>",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.TemplateEnd,
      content: "</template>",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.TemplateEnd]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart,
      content: '<script setup lang="ts">',
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.OnMountedStart,
      content: "onMounted(async () => {",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.OnMountedStart]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent,
      content: "",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.OnMountedEnd,
      content: "});",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.OnMountedEnd]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.UnMountedStart,
      content: "onUnmounted(() => {",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.UnMountedStart]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.UnMountedEnd,
      content: "});",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.UnMountedEnd]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd,
      content: "<\/script>",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.CssStyleStart,
      content: '<style scoped lang="scss">',
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.CssStyleStart]
      ]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.CssStyleEnd,
      content: "</style>",
      linkAfter: [
        ...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.CssStyleEnd]
      ]
    });
    return next;
  };
  return plugin;
};
var containerVue_default = pluginFactory43;

// src/utils/nodeToTemplate.ts
import _7 from "lodash";
import {
  isNodeSchema as isNodeSchema3
} from "@alilc/lowcode-types";
function mergeNodeGeneratorConfig2(cfg1, cfg2 = {}) {
  const resCfg = {};
  if (cfg1.handlers || cfg2.handlers) {
    resCfg.handlers = {
      ...cfg1.handlers || {},
      ...cfg2.handlers || {}
    };
  }
  if (cfg1.tagMapping || cfg2.tagMapping) {
    resCfg.tagMapping = cfg2.tagMapping || cfg1.tagMapping;
  }
  if (cfg1.attrPlugins || cfg2.attrPlugins) {
    resCfg.attrPlugins = [];
    resCfg.attrPlugins.push(...cfg2.attrPlugins || []);
    resCfg.attrPlugins.push(...cfg1.attrPlugins || []);
  }
  if (cfg1.nodePlugins || cfg2.nodePlugins) {
    resCfg.nodePlugins = [];
    resCfg.nodePlugins.push(...cfg2.nodePlugins || []);
    resCfg.nodePlugins.push(...cfg1.nodePlugins || []);
  }
  return resCfg;
}
function isPureString2(v) {
  return v[0] === "'" && v[v.length - 1] === "'" || v[0] === '"' && v[v.length - 1] === '"';
}
function generateAttrValue2(attrData, scope, config) {
  const valueStr = generateCompositeType(attrData.attrValue, scope, {
    handlers: config == null ? void 0 : config.handlers,
    nodeGenerator: config == null ? void 0 : config.self
  });
  return [
    {
      type: "NodeCodePieceAttr" /* ATTR */,
      name: attrData.attrName,
      value: valueStr
    }
  ];
}
function generateAttr2(attrName, attrValue, scope, config) {
  let pieces = [];
  if (config == null ? void 0 : config.attrPlugins) {
    pieces = executeFunctionStack(
      { attrName, attrValue },
      scope,
      config.attrPlugins,
      generateAttrValue2,
      config
    );
  } else {
    pieces = generateAttrValue2({ attrName, attrValue }, scope, config);
  }
  pieces = pieces.map((p) => {
    if (p.name === "__events") {
      return null;
    }
    let newValue;
    let pName;
    if (p.name === "onClick" || p.name === "onMouseUp") {
      pName = `@${p.name}`;
      newValue = `"${p.value}"`;
    } else if (p.name === "dataList" || p.name === "itemArray") {
      let data;
      try {
        data = JSON.parse(p.value);
      } catch (error) {
        newValue = `"${p.value.replace(/[\n\r]+/g, "").replace(/^state\['(.*?)'\]\?\./, "$1?.")}"`;
        pName = `:${p.name}`;
      }
      if (data) {
        newValue = `"${JSON.stringify(data).replace(/"(\w+)":/g, "$1:").replace(/:"([^"]*)"/g, ":'$1'")}"`;
        pName = `:${p.name}`;
      }
    } else if (p.value && isPureString2(p.value)) {
      const content = getStaticExprValue(p.value);
      newValue = JSON.stringify(encodeJsxStringNode(content));
      pName = `${p.name}`;
    } else {
      newValue = `"${p.value}"`;
      pName = `:${p.name}`;
    }
    return {
      value: `${pName}=${lineToUppercase(newValue)}`,
      type: "NodeCodePieceAttr" /* ATTR */
    };
  }).filter((p) => p !== null);
  return pieces;
}
function generateAttrs2(nodeItem, scope, config) {
  const { props } = nodeItem;
  let pieces = [];
  if (props) {
    if (!Array.isArray(props)) {
      Object.keys(props).forEach((propName) => {
        if (isValidIdentifier(propName) || isValidVueDirective(propName)) {
          pieces = pieces.concat(
            generateAttr2(propName, props[propName], scope, config)
          );
        }
      });
    } else {
      props.forEach((prop) => {
        if (prop.name && isValidIdentifier(prop.name) && !prop.spread) {
          pieces = pieces.concat(generateAttr2(prop.name, prop.value, scope, config));
        }
      });
    }
  }
  return pieces;
}
function generateConditionVueCtrl(nodeItem, scope, config, next) {
  const pieces = next ? next(nodeItem, scope, config) : [];
  if (nodeItem.condition != null && nodeItem.condition !== true) {
    let value = generateCompositeType(nodeItem.condition, scope, {
      handlers: config == null ? void 0 : config.handlers
    });
    value = value.replace(/[{}]/g, "");
    pieces.unshift({
      value: `v-if="${value}"`,
      type: "NodeCodePieceAttr" /* ATTR */
    });
  }
  return pieces;
}
function generateVueLoopCtrl(nodeItem, scope, config, next) {
  var _a, _b;
  if (nodeItem.loop) {
    const loopItemName = ((_a = nodeItem.loopArgs) == null ? void 0 : _a[0]) || "item";
    const loopIndexName = ((_b = nodeItem.loopArgs) == null ? void 0 : _b[1]) || "index";
    let loopDataExpr = generateCompositeType(nodeItem.loop, scope, {
      handlers: config == null ? void 0 : config.handlers
    });
    loopDataExpr = loopDataExpr.replace(/"/g, "'");
    const pieces = next ? next(nodeItem, scope, config) : [];
    pieces.unshift({
      value: `v-for="(${loopItemName}, ${loopIndexName}) in ${loopDataExpr}"`,
      type: "NodeCodePieceAttr" /* ATTR */
    });
    return pieces;
  }
  return next ? next(nodeItem, scope, config) : [];
}
function generateBasicNode2(nodeItem, scope, config) {
  const pieces = [];
  let tagName = ((config == null ? void 0 : config.tagMapping) || _7.identity)(nodeItem.componentName);
  tagName = tagName === "Div" ? "div" : tagName;
  pieces.push({
    value: tagName || "",
    type: "NodeCodePieceTag" /* TAG */
  });
  return pieces;
}
function generateSimpleNode2(nodeItem, scope, config) {
  const basicParts = generateBasicNode2(nodeItem, scope, config) || [];
  const attrParts = generateAttrs2(nodeItem, scope, config) || [];
  const childrenParts = [];
  if (nodeItem.children && (config == null ? void 0 : config.self)) {
    const childrenStr = config.self(nodeItem.children, scope);
    childrenParts.push({
      type: "NodeCodePieceChildren" /* CHILDREN */,
      value: childrenStr
    });
  }
  return [...basicParts, ...attrParts, ...childrenParts];
}
function linkPieces2(pieces) {
  const tagsPieces = pieces.filter((p) => p.type === "NodeCodePieceTag" /* TAG */);
  if (tagsPieces.length !== 1) {
    throw new CodeGeneratorError("Only one tag definition required", tagsPieces);
  }
  const tagName = tagsPieces[0].value;
  const beforeParts = pieces.filter((p) => p.type === "NodeCodePieceBefore" /* BEFORE */).map((p) => p.value).join("");
  const afterParts = pieces.filter((p) => p.type === "NodeCodePieceAfter" /* AFTER */).map((p) => p.value).join("");
  const childrenParts = pieces.filter((p) => p.type === "NodeCodePieceChildren" /* CHILDREN */).map((p) => p.value).join("");
  let attrsParts = pieces.filter((p) => p.type === "NodeCodePieceAttr" /* ATTR */).map((p) => p.value).join(" ");
  attrsParts = attrsParts ? ` ${attrsParts}` : "";
  if (childrenParts) {
    return `${beforeParts}<${tagName}${attrsParts}>${childrenParts}</${tagName}>${afterParts}`;
  }
  return `${beforeParts}<${tagName}${attrsParts} />${afterParts}`;
}
function generateNodeSchema2(nodeItem, scope, config) {
  const pieces = [];
  if (config == null ? void 0 : config.nodePlugins) {
    const res = executeFunctionStack(
      nodeItem,
      scope,
      config.nodePlugins,
      generateSimpleNode2,
      config
    );
    pieces.push(...res);
  } else {
    pieces.push(...generateSimpleNode2(nodeItem, scope, config));
  }
  return linkPieces2(pieces);
}
var handleChildren2 = (v) => v.join("");
function createNodeGenerator2(cfg = {}) {
  const generateNode = (nodeItem, scope) => {
    const ignoreNode = ["Navigation"];
    if (_7.isArray(nodeItem)) {
      const resList = nodeItem.map((n) => generateNode(n, scope));
      return handleChildren2(resList);
    }
    if (isNodeSchema3(nodeItem)) {
      const tagName = ((cfg == null ? void 0 : cfg.tagMapping) || _7.identity)(nodeItem.componentName);
      if (ignoreNode.includes(tagName)) {
        return "";
      }
      return generateNodeSchema2(nodeItem, scope, {
        ...cfg,
        self: generateNode
      });
    }
    const valueStr = generateCompositeType(nodeItem, scope, {
      handlers: cfg.handlers,
      nodeGenerator: generateNode
    });
    if (isPureString2(valueStr)) {
      return `${encodeJsxStringNode(getStaticExprValue(valueStr))}`;
    }
    return `{{${valueStr}}}`;
  };
  return (nodeItem, scope) => generateNode(nodeItem, scope);
}
function createVueNodeGenerator(cfg) {
  const newCfg = mergeNodeGeneratorConfig2(
    {
      nodePlugins: [generateVueLoopCtrl, generateConditionVueCtrl]
    },
    cfg
  );
  return createNodeGenerator2(newCfg);
}
function findNodeSchema(node, name) {
  if (node && node.componentName && node.componentName === name) {
    return node;
  }
  if (node.children) {
    if (Array.isArray(node.children)) {
      for (const child of node.children) {
        const found = findNodeSchema(child, name);
        if (found) {
          return found;
        }
      }
    } else {
      return findNodeSchema(node.children, name);
    }
  }
  return null;
}
function generateByName(cfg = {}, name, nodeItem, scope, props) {
  const targetNode = findNodeSchema(nodeItem, name);
  if (!targetNode) {
    return { code: "", node: {} };
  }
  targetNode.props = { ...targetNode.props, ...props };
  return {
    code: generateNodeSchema2(targetNode, scope, {
      ...cfg
    }),
    node: targetNode
  };
}

// src/core/vue/util/isLiteralAtomicExpr.ts
function isLiteralAtomicExpr2(expr) {
  return expr === "null" || expr === "undefined" || expr === "true" || expr === "false" || /^-?\d+(\.\d+)?$/.test(expr);
}

// src/core/vue/util/isSimpleStraightLiteral.ts
function isSimpleStraightLiteral2(expr) {
  switch (expr.type) {
    case "BigIntLiteral":
    case "BooleanLiteral":
    case "DecimalLiteral":
    case "NullLiteral":
    case "NumericLiteral":
    case "RegExpLiteral":
    case "StringLiteral":
      return true;
    default:
      return false;
  }
}

// src/core/vue/handlers/transformThis2Context.ts
import generate4 from "@babel/generator";
function transformThis2Context2(expr, scope, { ignoreRootScope = false } = {}) {
  var _a;
  if (ignoreRootScope && scope.parent == null) {
    return typeof expr === "string" ? expr : generate4(expr).code;
  }
  return parseExpressionConvertThis2Context(
    expr,
    "__$$context",
    ((_a = scope.bindings) == null ? void 0 : _a.getAllBindings()) || []
  );
}

// src/core/vue/handlers/transformJsExpression.ts
function transformJsExpr2(expr, scope, { dontWrapEval = false, dontTransformThis2ContextAtRootScope = false } = {}) {
  if (!expr) {
    return "undefined";
  }
  if (isLiteralAtomicExpr2(expr)) {
    return expr;
  }
  const exprAst = parseExpression2(expr);
  if (isSimpleStraightLiteral2(exprAst)) {
    return expr;
  }
  const transformedExpr = transformThis2Context2(exprAst, scope, {
    ignoreRootScope: dontTransformThis2ContextAtRootScope
  }).replace(/this\.|state\./g, "");
  if (dontWrapEval) {
    return transformedExpr;
  }
  switch (exprAst.type) {
    case "ArrowFunctionExpression":
    case "FunctionExpression":
      return transformThis2Context2(exprAst, scope, {
        ignoreRootScope: dontTransformThis2ContextAtRootScope
      });
    default:
      break;
  }
  return `${transformedExpr}`;
}

// src/plugins/component/vue/template.ts
var pluginFactory44 = (config) => {
  const cfg = {
    fileType: "vue" /* VUE */,
    nodeTypeMapping: {},
    ...config
  };
  const { nodeTypeMapping } = cfg;
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const { tolerateEvalErrors = true } = next.contextData;
    const customHandlers = {
      expression(input, scope2, config2) {
        var _a;
        return transformJsExpr2(generateExpression(input, scope2), scope2, {
          dontWrapEval: !((_a = config2 == null ? void 0 : config2.tolerateEvalErrors) != null ? _a : tolerateEvalErrors),
          dontTransformThis2ContextAtRootScope: true
        });
      },
      function(input, scope2) {
        return transformThis2Context2(
          generateCompositeType(
            {
              type: "JSFunction",
              value: input.value || "function () {}"
            },
            Scope.createRootScope()
          ),
          scope2,
          { ignoreRootScope: true }
        );
      }
    };
    const generatorPlugins = {
      handlers: customHandlers,
      tagMapping: (v) => nodeTypeMapping[v] || v,
      tolerateEvalErrors
    };
    const generator = createVueNodeGenerator(generatorPlugins);
    const ir = next.ir;
    const scope = Scope.createRootScope();
    const templateContent = generator(ir, scope);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.TemplateDom,
      content: `
          ${templateContent}
      `,
      linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart]
    });
    return next;
  };
  return plugin;
};
var template_default4 = pluginFactory44;

// src/plugins/component/vue/vueCommonDeps.ts
var pluginFactory45 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
      content: `
import { onMounted, onUnmounted, ref, reactive } from 'vue';
import { useRouter } from 'vue-router';`,
      linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart]
    });
    return next;
  };
  return plugin;
};
var vueCommonDeps_default = pluginFactory45;

// src/utils/requestHandle.ts
import _8 from "lodash";
var PREFIX_API_CACHE = "page_cache_";
var PREFIX_PAGE_NUM = "_nowPage";
var PREFIX_IS_LAST_PAGE = "_isLastPage";
var PREFIX_API_PARAM_NAME = "Params";
var SUFFIX_API_SCRIPT = "Request";
var SUFFIX_DATA_SOURCE_MAP = "dataSourceMap";
var SUFFIX_API_METHOD = "Method";
var GLOBE_API_PARAM = "globeParam";
var requestEndUrl = {
  dynamicForm: (url, formName, isJsExp) => {
    if (isJsExp) {
      return `/${formName}/page`;
    } else {
      return `'/${formName}/page'`;
    }
  },
  dataDictionary: (url, formName, isJsExp) => {
    if (isJsExp) {
      return url.replace("/source/api", "");
    } else {
      return `'${url.replace("/source/api", "")}'`;
    }
  },
  dynamicFormCache: (url, formName, isJsExp) => {
    if (isJsExp) {
      return `/${formName}/page`;
    } else {
      return `'/${formName}/page'`;
    }
  },
  dynamicFormDetail: (url, formName, isJsExp) => {
    const urlArray = url.split("/");
    let id = urlArray[urlArray.length - 1];
    if (id.startsWith(`'`)) {
      id = id.replace(`'`, "");
    }
    return `'/${formName}/'` + id;
  },
  dataLoginUserInfo: (url, formName, isJsExp) => {
    return url;
  }
};
var ignoreHeader = [
  {
    key: "authToken",
    ignore: (value) => {
      return true;
    }
  },
  {
    key: "siteCode",
    ignore: (value) => {
      return true;
    }
  },
  {
    key: "dcAuthType",
    ignore: (value) => {
      return true;
    }
  },
  {
    key: "Content-Type",
    ignore: (value) => {
      return ["application/json"].includes(value);
    }
  }
];
function requestHeaderHandler(headers) {
  if (!headers) {
    return "";
  }
  let endHeaders = "";
  for (let i = 0; i < Object.keys(headers).length; i++) {
    const key = Object.keys(headers)[i];
    if (shouldIgnoreKey(key, headers[key])) {
      break;
    }
    if (headers[key]) {
      let tempHeaders = `defaultConfig.header.data['${key}'] = '${headers[key]}'`;
      if (isJsExpression(headers[key])) {
        tempHeaders = `defaultConfig.header.data['${key}'] = ${generateFunction(headers[key], { isToVue: true })}`;
      }
      endHeaders += `${tempHeaders};`;
    }
  }
  if (endHeaders) {
    endHeaders = "// \u8BF7\u6C42\u5934\u5904\u7406\nconst defaultConfig = getDefaultConfig<boolean>()\n" + endHeaders;
  }
  return endHeaders;
}
function requestParamsHandler(params) {
  if (!params || Object.keys(params).length === 0) {
    return "";
  }
  let paramsData = params ? Object.keys(params).map(
    (key) => {
      if (isJsExpression(params[key])) {
        return "";
      }
      return `${key}: ${params[key]}`;
    }
  ).filter((item) => item).join(",") : "";
  return `
    // \u8BF7\u6C42\u53C2\u6570\u5904\u7406
    data = {
   ${paramsData ? paramsData + "," : ""}
   ...data
   }`;
}
function requestAfterDataHandler(dataSourceItems, extra) {
  const strArray = [];
  if (dataSourceItems.dataHandler) {
    const resultDataName = lineToUppercase(dataSourceItems.id + "Data");
    const resultData = `const ${resultDataName} = await ${getApiName(dataSourceItems.id)}.${dataSourceItems.id}(${getApiParamName(dataSourceItems.id)});`;
    const handleData = `const handleData = ${getApiHandleFunctionName(dataSourceItems.id)}({ data: ${resultDataName}})`;
    strArray.push(resultData, handleData);
    let endData;
    if (!dataSourceItems.dataHandler.value.includes("requestAfter")) {
      endData = `${lineToUppercase(getApiId(dataSourceItems.id, extra))}.value = handleData`;
      strArray.push(endData);
    }
  } else {
    const handleData = `const handleData = await ${getApiName(dataSourceItems.id)}.${dataSourceItems.id}(${getApiParamName(dataSourceItems.id)});`;
    const data = `${lineToUppercase(getApiId(dataSourceItems.id, extra))}.value = handleData`;
    strArray.push(handleData, data);
  }
  return strArray;
}
function isJsExpression(value) {
  return _8.isObject(value) && (value == null ? void 0 : value.type) == "JSExpression";
}
function shouldIgnoreKey(key, value) {
  for (let i = 0; i < ignoreHeader.length; i++) {
    const headerItem = ignoreHeader[i];
    if (headerItem.key == key) {
      return headerItem.ignore(value);
    }
  }
  const dynamicKeyPattern = /^authToken-\d+$/;
  if (dynamicKeyPattern.test(key)) {
    return true;
  }
  return false;
}
function handleUrl(dataSourceConfig, extra) {
  var _a, _b, _c, _d, _e;
  let url;
  if (isJsExpression((_a = dataSourceConfig.options) == null ? void 0 : _a.uri)) {
    url = generateFunction((_b = dataSourceConfig.options) == null ? void 0 : _b.uri, { isToVue: true, isDeleteLastSemicolon: true });
  } else {
    url = (_c = dataSourceConfig.options) == null ? void 0 : _c.uri;
  }
  const id = dataSourceConfig.id;
  const config = extra && extra[id];
  if (!config) {
    return `'${(_d = dataSourceConfig.options) == null ? void 0 : _d.uri}'`;
  }
  const type = config.dataSourceType;
  const formName = lineToUppercase(config.code);
  return requestEndUrl[type](url, formName, isJsExpression((_e = dataSourceConfig.options) == null ? void 0 : _e.uri));
}
function handlePageParamToRef(data) {
  if (!data.extra) {
    return [];
  }
  const extra = data.extra;
  const variableArray = [];
  Object.keys(extra).forEach((key) => {
    var _a;
    const extraItem = extra[key];
    if (extraItem.pageHelperInfo) {
      const pageIsLastPage = `const ${lineToUppercase(key + PREFIX_IS_LAST_PAGE)} = ref(false)`;
      const pageNowPage = `const ${lineToUppercase(key + PREFIX_PAGE_NUM)} = ref(${(_a = extraItem.pageHelperInfo.page.value) != null ? _a : 1})`;
      variableArray.push(pageNowPage, pageIsLastPage);
    }
  });
  return variableArray;
}
function handleParamToRef(data) {
  const dataSourceItems = data && data.list || [];
  const paramSet = /* @__PURE__ */ new Set();
  const nameArray = [];
  dataSourceItems.forEach((item) => {
    var _a;
    const params = (_a = item.options) == null ? void 0 : _a.params;
    if (params) {
      Object.values(params).forEach((paramItem) => {
        if (isJsExpression(paramItem)) {
          const nameSet = parseExpressionGetState(paramItem == null ? void 0 : paramItem.value);
          nameSet.forEach((name) => paramSet.add(name));
        }
      });
    }
  });
  const paramArray = [...paramSet];
  const paramStr = paramArray.filter((item) => item).map((item) => `${item}: ''`);
  const param = `const ${GLOBE_API_PARAM} = reactive({${paramStr.join(",")}})`;
  nameArray.push(param);
  return nameArray;
}
function handleApiToRef(data) {
  const dataSourceItems = data && data.list || [];
  const variableArray = [];
  const extra = data.extra;
  dataSourceItems.forEach((item) => {
    let id = getApiId(item.id, extra);
    const data2 = `const ${lineToUppercase(id)} = ref()`;
    variableArray.push(data2);
  });
  return variableArray;
}
function getApiId(id, extra) {
  var _a;
  return extra && ((_a = extra[id]) == null ? void 0 : _a.isOpenCache) ? PREFIX_API_CACHE + id : id;
}
function getApiParamName(id) {
  return lineToUppercase(id) + PREFIX_API_PARAM_NAME;
}
function getApiHandleFunctionName(id) {
  return lineToUppercase("requestAfter" + id);
}
function getApiName(apiId) {
  return apiId + SUFFIX_API_SCRIPT;
}
function getApiRequestMethodName(id) {
  return lineToUppercase(id) + "Method";
}

// src/plugins/component/vue/apiImport.ts
var pluginFactory46 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const dataSourceConfig = isValidContainerType(pre.ir) ? pre.ir.dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    if (dataSourceItems.length > 0) {
      dataSourceItems.forEach((ds) => {
        const dsType = ds.type || "fetch";
        if (dsType !== "custom") {
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport,
            content: `import  ${getApiName(ds.id)} from '@/api/${ds.id}';`,
            linkAfter: [...DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport]]
          });
        }
      });
    }
    return next;
  };
  return plugin;
};
var apiImport_default = pluginFactory46;

// src/plugins/component/vue/esmodule.ts
import { flatMap as flatMap3, camelCase as camelCase2, get as get2 } from "lodash";
var DEP_MAIN_BLOCKLIST2 = ["lib", "lib/index", "es", "es/index", "main"];
var DEFAULT_EXPORT_NAME2 = "__default__";
function groupDepsByPack2(deps) {
  const depMap = {};
  const addDep = (pkg, dep) => {
    if (!depMap[pkg]) {
      depMap[pkg] = [];
    }
    depMap[pkg].push(dep);
  };
  deps.forEach((dep) => {
    if (dep.dependencyType === "Internal" /* Internal */) {
      addDep(`${dep.moduleName}${dep.main ? `/${dep.main}` : ""}`, dep);
    } else {
      let depMain = "";
      if (dep.main && DEP_MAIN_BLOCKLIST2.indexOf(dep.main) < 0) {
        depMain = dep.main;
      }
      if (depMain.substring(0, 1) === "/") {
        depMain = depMain.substring(1);
      }
      addDep(`${dep.package}${depMain ? `/${depMain}` : ""}`, dep);
    }
  });
  return depMap;
}
function getDependencyIdentifier2(info) {
  return info.aliasName || info.exportName;
}
function getExportNameOfDep2(dep) {
  if (dep.destructuring) {
    return dep.exportName || dep.componentName || throwNewError2("destructuring dependency must have exportName or componentName");
  }
  if (!dep.subName) {
    return dep.componentName || dep.exportName || throwNewError2("dependency item must have componentName or exportName");
  }
  return dep.exportName || `__$${camelCase2(
    get2(dep, "moduleName") || get2(dep, "package") || throwNewError2("dep.moduleName or dep.package is undefined")
  )}_default`;
}
function throwNewError2(msg) {
  throw new Error(msg);
}
function buildPackageImport2(pkg, deps, targetFileType, useAliasName) {
  if (!pkg || pkg === "undefined" || pkg === "null") {
    return [];
  }
  const chunks = [];
  const exportItems = {};
  const defaultExportNames = [];
  const depsInfo = deps.map((dep) => {
    const info = {
      exportName: getExportNameOfDep2(dep),
      isDefault: !dep.destructuring,
      subName: dep.subName || void 0,
      nodeIdentifier: dep.componentName || void 0,
      source: dep
    };
    if (info.isDefault) {
      if (defaultExportNames.indexOf(info.exportName) < 0) {
        defaultExportNames.push(info.exportName);
      }
    }
    if (!info.subName) {
      if (info.nodeIdentifier === info.exportName) {
        info.nodeIdentifier = void 0;
      }
      if (info.isDefault) {
        info.aliasName = info.nodeIdentifier || info.exportName;
        info.exportName = DEFAULT_EXPORT_NAME2;
      }
      if (info.nodeIdentifier) {
        info.aliasName = info.nodeIdentifier;
        info.nodeIdentifier = void 0;
      }
    } else {
      if (info.isDefault) {
        info.aliasName = info.exportName;
        info.exportName = DEFAULT_EXPORT_NAME2;
      }
      if (info.nodeIdentifier === `${info.exportName}.${info.subName}`) {
        info.nodeIdentifier = void 0;
      }
    }
    return info;
  });
  depsInfo.forEach((info) => {
    if (!exportItems[info.exportName]) {
      exportItems[info.exportName] = {
        exportName: info.exportName,
        isDefault: info.isDefault,
        aliasNames: [],
        needOriginExport: false
      };
    }
    if (!info.nodeIdentifier && !info.aliasName) {
      exportItems[info.exportName].needOriginExport = true;
    }
  });
  depsInfo.forEach((info) => {
    if (info.aliasName) {
      const { aliasNames } = exportItems[info.exportName];
      if (aliasNames.indexOf(info.aliasName) < 0) {
        aliasNames.push(info.aliasName);
      }
    }
  });
  depsInfo.forEach((info) => {
    if (info.nodeIdentifier) {
      const exportItem = exportItems[info.exportName];
      if (!exportItem.needOriginExport && exportItem.aliasNames.length > 0) {
        info.aliasName = exportItem.aliasNames[0];
      }
    }
  });
  const nodeIdentifiers = depsInfo.map((info) => info.nodeIdentifier).filter(Boolean);
  const conflictInfos = flatMap3(Object.keys(exportItems), (exportName) => {
    const exportItem = exportItems[exportName];
    const usedNames = [
      ...exportItem.aliasNames,
      ...exportItem.needOriginExport || exportItem.aliasNames.length <= 0 ? [exportName] : []
    ];
    const conflictNames = usedNames.filter((n) => nodeIdentifiers.indexOf(n) >= 0);
    if (conflictNames.length > 0) {
      return [
        ...conflictNames.indexOf(exportName) >= 0 ? [[exportName, true, exportItem]] : [],
        ...conflictNames.filter((n) => n !== exportName).map((n) => [n, false, exportItem])
      ];
    }
    return [];
  });
  const conflictExports = conflictInfos.filter((c) => c[1]).map((c) => c[0]);
  const conflictAlias = conflictInfos.filter((c) => !c[1]).map((c) => c[0]);
  const solutions = {};
  depsInfo.forEach((info) => {
    if (info.aliasName && conflictAlias.indexOf(info.aliasName) >= 0) {
      let solution = solutions[info.aliasName];
      if (!solution) {
        solution = `${info.aliasName}Alias`;
        const conflictItem = (conflictInfos.find((c) => c[0] === info.aliasName) || [])[2];
        conflictItem.aliasNames = conflictItem.aliasNames.filter((a) => a !== info.aliasName);
        conflictItem.aliasNames.push(solution);
        solutions[info.aliasName] = solution;
      }
      info.aliasName = solution;
    }
    if (conflictExports.indexOf(info.exportName) >= 0) {
      let solution = solutions[info.exportName];
      if (!solution) {
        solution = `${info.exportName}Export`;
        const conflictItem = (conflictInfos.find((c) => c[0] === info.exportName) || [])[2];
        conflictItem.aliasNames.push(solution);
        conflictItem.needOriginExport = false;
        solutions[info.exportName] = solution;
      }
      info.aliasName = solution;
    }
  });
  depsInfo.forEach((info) => {
    const name = info.aliasName || info.exportName;
    if (!isValidIdentifier(name)) {
      throw new CodeGeneratorError(`Invalid Identifier [${name}]`);
    }
    if (info.nodeIdentifier && !isValidIdentifier(info.nodeIdentifier)) {
      throw new CodeGeneratorError(`Invalid Identifier [${info.nodeIdentifier}]`);
    }
  });
  const aliasDefineStatements = {};
  if (useAliasName) {
    Object.keys(exportItems).forEach((exportName) => {
      var _a;
      const aliasList = ((_a = exportItems[exportName]) == null ? void 0 : _a.aliasNames) || [];
      if (aliasList.length > 0) {
        const srcName = exportItems[exportName].needOriginExport ? exportName : aliasList[0];
        const aliasNameList = exportItems[exportName].needOriginExport ? aliasList : aliasList.slice(1);
        aliasNameList.forEach((a) => {
          if (!aliasDefineStatements[a]) {
            aliasDefineStatements[a] = `const ${a} = ${srcName};`;
          }
        });
      }
    });
  }
  function getDefaultExportName(info) {
    if (info.isDefault) {
      return defaultExportNames[0];
    }
    return info.exportName;
  }
  depsInfo.forEach((info) => {
    if (info.nodeIdentifier) {
      const ownerName = getDependencyIdentifier2(info);
      chunks.push({
        type: "string" /* STRING */,
        fileType: targetFileType,
        name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
        content: useAliasName ? `const ${info.nodeIdentifier} = ${ownerName}.${info.subName};` : "",
        linkAfter: [...DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport]],
        ext: {
          originalName: `${getDefaultExportName(info)}.${info.subName}`,
          aliasName: info.nodeIdentifier,
          dependency: info.source
        }
      });
    } else if (info.aliasName) {
      if (info.isDefault && defaultExportNames.find((n) => n === info.aliasName)) {
        delete aliasDefineStatements[info.aliasName];
        return;
      }
      let contentStatement = "";
      if (aliasDefineStatements[info.aliasName]) {
        contentStatement = aliasDefineStatements[info.aliasName];
        delete aliasDefineStatements[info.aliasName];
      }
      chunks.push({
        type: "string" /* STRING */,
        fileType: targetFileType,
        name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
        content: contentStatement,
        linkAfter: [...DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport]],
        ext: {
          originalName: getDefaultExportName(info),
          aliasName: info.aliasName,
          dependency: info.source
        }
      });
    }
  });
  Object.keys(aliasDefineStatements).forEach((a) => {
    chunks.push({
      type: "string" /* STRING */,
      fileType: targetFileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
      content: aliasDefineStatements[a],
      linkAfter: [...DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport]]
    });
  });
  const exportItemList = Object.keys(exportItems).map((k) => exportItems[k]);
  const defaultExport = exportItemList.filter((item) => item.isDefault);
  const otherExports = exportItemList.filter((item) => !item.isDefault);
  const statementL = ["import"];
  if (defaultExport.length > 0) {
    if (useAliasName) {
      statementL.push(defaultExportNames[0]);
    } else {
      statementL.push(defaultExport[0].aliasNames[0]);
    }
    if (otherExports.length > 0) {
      statementL.push(", ");
    }
  }
  if (otherExports.length > 0) {
    const items = otherExports.map((item) => {
      return !useAliasName || item.needOriginExport || item.aliasNames.length <= 0 ? item.exportName : `${item.exportName} as ${item.aliasNames[0]}`;
    });
    statementL.push(`{ ${items.join(", ")} }`);
  }
  statementL.push("from");
  const getInternalDependencyModuleId = () => `@/${deps[0].type}/${pkg}`;
  if (deps[0].dependencyType === "Internal" /* Internal */) {
    statementL.push(`'${getInternalDependencyModuleId()}';`);
    chunks.push({
      type: "string" /* STRING */,
      fileType: targetFileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport,
      content: statementL.join(" "),
      linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport]
    });
  } else {
    statementL.push(`'${pkg}';`);
    chunks.push({
      type: "string" /* STRING */,
      fileType: targetFileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
      content: statementL.join(" "),
      linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart]
    });
  }
  if (defaultExportNames.length > 1) {
    if (deps[0].dependencyType === "Internal" /* Internal */) {
      defaultExportNames.slice(1).forEach((exportName) => {
        chunks.push({
          type: "string" /* STRING */,
          fileType: targetFileType,
          name: TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport,
          content: `import ${exportName} from '${getInternalDependencyModuleId()}';`,
          linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport]
        });
      });
    } else {
      defaultExportNames.slice(1).forEach((exportName) => {
        chunks.push({
          type: "string" /* STRING */,
          fileType: targetFileType,
          name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
          content: `import ${exportName} from '${pkg}';`,
          linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart]
        });
        chunks.push({
          type: "string" /* STRING */,
          fileType: targetFileType,
          name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
          content: "",
          linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart],
          ext: {
            aliasName: exportName,
            originalName: exportName,
            dependency: {
              package: pkg,
              componentName: exportName
            }
          }
        });
      });
    }
  }
  return chunks;
}
function depConvertToVue(deps) {
  return deps.map((dep) => {
    if (!dep.devMode || dep.devMode !== "lowCode") {
      dep.package = VUE_MODULE_NAME;
      dep.main = "";
    }
    return dep;
  });
}
var pluginFactory47 = (config) => {
  const cfg = {
    fileType: "js" /* JS */,
    useAliasName: true,
    ...config || {}
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    if (ir && ir.deps && ir.deps.length > 0) {
      let deps = cfg.filter ? cfg.filter(ir.deps) : ir.deps;
      deps = depConvertToVue(deps);
      const packs = groupDepsByPack2(deps);
      Object.keys(packs).forEach((pkg) => {
        const chunks = buildPackageImport2(pkg, packs[pkg], cfg.fileType, cfg.useAliasName);
        next.chunks.push(...chunks);
      });
    }
    return next;
  };
  return plugin;
};
var esmodule_default2 = pluginFactory47;

// src/plugins/component/vue/containerInitVariable.ts
var pluginFactory48 = (config) => {
  const cfg = {
    fileType: "vue" /* VUE */,
    implementType: "inConstructor",
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const scope = Scope.createRootScope();
    const state = ir.state || {};
    const fields = Object.keys(state).map((stateName) => {
      const value = generateCompositeType(state[stateName], scope);
      return `const ${stateName} = ref(${value})`;
    });
    const dataSourceConfig = isValidContainerType(pre.ir) ? pre.ir.dataSource : null;
    const apiRefArray = handleApiToRef(dataSourceConfig);
    const pageParams = handlePageParamToRef(dataSourceConfig);
    const data = handleParamToRef(dataSourceConfig);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ConstVar,
      content: `${data.join("\n")}`,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ConstVar]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ConstVar,
      content: `${apiRefArray.join("\n")}`,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ConstVar]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ConstVar,
      content: `${fields.join("\n")}`,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ConstVar]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ConstVar,
      content: `${pageParams.join("\n")}`,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ConstVar]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ConstVar,
      content: `const router = useRouter()`,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ConstVar]]
    });
    return next;
  };
  return plugin;
};
var containerInitVariable_default = pluginFactory48;

// src/plugins/component/vue/containerLifeCycle.ts
import { isJSFunction as isJSFunction8, isJSExpression as isJSExpression9 } from "@alilc/lowcode-types";
var pluginFactory49 = (config) => {
  const cfg = {
    fileType: "vue" /* VUE */,
    exportNameMapping: {},
    normalizeNameMapping: {},
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    if (ir.lifeCycles) {
      const { lifeCycles } = ir;
      const chunks = Object.keys(lifeCycles).map((lifeCycleName) => {
        var _a;
        if (!isJSFunction8(lifeCycles[lifeCycleName]) && !isJSExpressionFn(lifeCycles[lifeCycleName]) && !isJSExpression9(lifeCycles[lifeCycleName])) {
          return null;
        }
        let normalizeName;
        if (lifeCycleName === "constructor") {
          normalizeName = lifeCycleName;
        } else {
          normalizeName = cfg.normalizeNameMapping[lifeCycleName] || lifeCycleName;
        }
        if ((_a = cfg == null ? void 0 : cfg.exclude) == null ? void 0 : _a.includes(normalizeName)) {
          return null;
        }
        const exportName = cfg.exportNameMapping[lifeCycleName] || lifeCycleName;
        if (normalizeName === "constructor") {
        }
        if (normalizeName === "componentDidMount") {
          return {
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent,
            content: generateFunction(lifeCycles[lifeCycleName], {
              isBlock: true,
              isToVue: true
            }),
            linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent]]
          };
        }
        if (normalizeName === "componentWillUnmount") {
          return {
            type: "string" /* STRING */,
            fileType: cfg.fileType,
            name: TEMPLATE_DEFINE_CHUNK_NAME.UnMountedContent,
            content: generateFunction(lifeCycles[lifeCycleName], {
              isBlock: true,
              isToVue: true
            }),
            linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.UnMountedContent]]
          };
        }
        if (normalizeName === "render") {
        }
        return {
          type: "string" /* STRING */,
          fileType: cfg.fileType,
          name: TEMPLATE_DEFINE_CHUNK_NAME.Method,
          content: generateFunction(lifeCycles[lifeCycleName], {
            name: exportName,
            isMember: true,
            isToVue: true
          }),
          linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.Method]]
        };
      }).filter((i) => !!i);
      next.chunks.push(...chunks.filter((x) => x !== null));
    }
    const dataSourceConfig = isValidContainerType(pre.ir) ? pre.ir.dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    dataSourceItems.forEach((item) => {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent,
        content: `  ${SUFFIX_DATA_SOURCE_MAP}.${getApiRequestMethodName(item.id)}();`,
        linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent]]
      });
    });
    return next;
  };
  return plugin;
};
var containerLifeCycle_default3 = pluginFactory49;

// src/plugins/component/vue/containerInjectDataSourceEngine.ts
var pluginFactory50 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const dataSourceConfig = isValidContainerType(pre.ir.containers[0]) ? pre.ir.containers[0].dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    const extra = dataSourceConfig && dataSourceConfig.extra || {};
    if (dataSourceItems.length > 0) {
      dataSourceItems.forEach((ds) => {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const dsType = ds.type || "fetch";
        const method = toFirstUpperCase((_b = (_a = ds.options) == null ? void 0 : _a.method) != null ? _b : "Post");
        const url = handleUrl(ds, extra);
        const formData = dataSourceConfig.extra ? (_d = (_c = dataSourceConfig.extra[ds.id]) == null ? void 0 : _c.columnToAttribute) == null ? void 0 : _d.formData : "";
        if (dsType !== "custom" && !formData) {
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "ts" /* TS */,
            subModule: ds.id,
            name: COMMON_CHUNK_NAME.ExternalDepsImport,
            content: `
              import { ${method}RequestModel, QueryType } from '@dc/vue-h5-base/src/http/request-model'
              import { getDefaultConfig } from '@dc/vue-h5-base/src/http/config/custom-config'
              import { PageModel } from '@dc/vue-h5-base/src/http/result-model'
              import utils from '@/utils/utils'
            `,
            linkAfter: []
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "ts" /* TS */,
            subModule: ds.id,
            name: COMMON_CHUNK_NAME.FileMainContent,
            content: `
export default {
  /**
   * \u5206\u9875\u67E5\u8BE2
   * @param data
   */
  ${ds.id}: (data?: QueryType) => {
  ${requestHeaderHandler((_e = ds.options) == null ? void 0 : _e.headers)}
  ${requestParamsHandler((_f = ds.options) == null ? void 0 : _f.params)}
  return new ${method}RequestModel<PageModel<any>>(${url}, data).request()
   },
}
            `,
            linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
          });
        } else {
          console.log(dataSourceConfig.extra[ds.id]["columnToAttribute"]["formData"]);
          const formId = url == null ? void 0 : url.toString().split("/").pop();
          const formName = lineToUppercase(dataSourceConfig.extra[ds.id]["code"]);
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "ts" /* TS */,
            subModule: ds.id,
            name: COMMON_CHUNK_NAME.ExternalDepsImport,
            content: `
              import { GetRequestModel, PostRequestModel, PutRequestModel, QueryType } from '@dc/vue-h5-base/src/http/request-model'
              import { getDefaultConfig } from '@dc/vue-h5-base/src/http/config/custom-config'
              import { PageModel } from '@dc/vue-h5-base/src/http/result-model'
            `,
            linkAfter: []
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "ts" /* TS */,
            subModule: ds.id,
            name: COMMON_CHUNK_NAME.FileMainContent,
            content: `
export default {
  /**
   * \u83B7\u53D6\u8868\u5355\u8BE6\u60C5
   * @param data
   */
  ${ds.id}: (data?: QueryType) => {
  ${requestHeaderHandler((_g = ds.options) == null ? void 0 : _g.headers)}
  ${requestParamsHandler((_h = ds.options) == null ? void 0 : _h.params)}
  return new ${method}RequestModel<PageModel<any>>(${url}, data).request()
   },
  /**
	 * \u5206\u9875\u67E5\u8BE2\u4FE1\u606F
	 * @param query
	 */
  page: (query?: QueryType) => new PostRequestModel<PageModel<any>>('/${formName}/page', query).request(),
    /**
   * \u65B0\u589E
   * @param data
   */
  add: (data: Partial<Record<string, string | number | Array<{}>>>) => {
    return new PostRequestModel<any>('/${formName}/', data as unknown as QueryType).request()
  },
    /**
   * \u66F4\u65B0
   * @param data
   */
  update: (data: Partial<Record<string, string | number | Array<{}>>>) => {
    return new PutRequestModel<any>('/${formName}/', data as unknown as QueryType).request()
  },
  /**
	 * \u6839\u636Eid\u83B7\u53D6\u8BE6\u7EC6\u4FE1\u606F
	 * @param id
	 */
  getById: (id: string) => {
    return new GetRequestModel<any>(\`/${formName}/\${id}\`, {}).request()
  },
}
            `,
            linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
          });
        }
      });
    }
    return next;
  };
  return plugin;
};
var containerInjectDataSourceEngine_default3 = pluginFactory50;

// src/plugins/component/vue/convert/convert-function.ts
var useApiMethod = `${SUFFIX_DATA_SOURCE_MAP}[dataSourceId + '${SUFFIX_API_METHOD}']`;
var convert_function_default = {
  updateVariable: `
    /**
     * \u6570\u636E\u6E90\u7684\u70B9\u51FB\u4EA4\u4E92\u4E8B\u4EF6\uFF08\u8BF7\u4E0D\u8981\u968F\u610F\u6539\u52A8\u8BE5\u65B9\u6CD5\uFF09
     * @param clickValue \u4E8B\u4EF6\u4F20\u9012\u7684\u539F\u53C2\u6570
     * @param extra \u989D\u5916\u7684\u53C2\u6570\uFF08\u6570\u636E\u6E90\u76F8\u5173\u7684\u53C2\u6570\uFF09
     */
    function updateVariable(clickValue, extra) {
    const { field, dataSourceId } = extra || {}
    // \u5982\u679C\u6CA1\u6709field\uFF0C\u5219\u4E0D\u8FDB\u884C\u64CD\u4F5C
    if (!field) {
        console.log('\u6CA1\u6709field\uFF0C\u4E0D\u8FDB\u884C\u64CD\u4F5C')
        return
    }
    ${GLOBE_API_PARAM}[field] = clickValue
    ${useApiMethod}().then((data) => {
        this[dataSourceId + 'IsLastPage'] = data?.data?.isLastPage;
        this[dataSourceId + 'NowPage'] = data?.data?.pageNum
    })
}`,
  goPage: `
    /**
     * \u9875\u9762\u8DF3\u8F6C\u4E8B\u4EF6\uFF08\u8BF7\u4E0D\u8981\u968F\u610F\u6539\u52A8\u8BE5\u65B9\u6CD5\uFF09
     * @param params \u9ED8\u8BA4\u4F20\u5165\u7684\u53C2\u6570
     * @param extra \u989D\u5916\u7684\u53C2\u6570
     */
    function goPage(params, extra) {
    const pageId = extra?.['pathId'] || params || ''
    if (!pageId) {
        // \u5982\u679C\u6CA1\u6709\u8DEF\u5F84\u7684\u60C5\u51B5\u4E0B\uFF0C\u4E0D\u8FDB\u884C\u8DF3\u8F6C
        return
    }
    // \u8FDB\u884C\u9875\u9762\u8DF3\u8F6C
    router.push(pageId);
}`,
  pageHelperInfo: `
    /**
     * \u5206\u9875\u52A9\u624B\u4FE1\u606F
     * @param params
     * @param extra
     */
    function pageHelperInfo(params, extra) {
    const {
        pageField = 'pageNum',
        pageValue = 1,
        rowsField = 'pageSize',
        rowsValue = 10,
        dataSourceId,
    } = { ...(params || {}), ...(extra || {}) }
    return new Promise((resolve) => {
        ${useApiMethod}({ [pageField]: params?.page || pageValue, [rowsField]: params?.rows || rowsValue })
            .then((data) => {
                this[dataSourceId + 'IsLastPage'] =  data?.data?.isLastPage;
                this[dataSourceId + 'NowPage'] = data?.data?.pageNum;
                resolve({
                    page: data.data[pageField],
                    rows: data.data[rowsField],
                    total: data.data.total,
                    isLastPage: data.data.isLastPage,
                });
            })
    })
}`
};

// src/plugins/component/vue/containerMethod.ts
var pluginFactory51 = (config) => {
  const cfg = {
    fileType: "vue" /* VUE */,
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    if (!ir.methods) {
      return next;
    }
    const { methods } = ir;
    const chunks = Object.keys(methods).map((methodName) => {
      const convertMethod = convert_function_default[methodName];
      if (convertMethod) {
        return {
          type: "string" /* STRING */,
          fileType: cfg.fileType,
          name: TEMPLATE_DEFINE_CHUNK_NAME.Method,
          content: `${convertMethod}`,
          linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.Method]]
        };
      }
      return {
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: TEMPLATE_DEFINE_CHUNK_NAME.Method,
        content: `function ${generateFunction(methods[methodName], { name: methodName, isMember: true, isToVue: true })}`,
        linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.Method]]
      };
    });
    const dataSourceConfig = isValidContainerType(pre.ir) ? pre.ir.dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    dataSourceItems.forEach((item) => {
      if (item.dataHandler && item.dataHandler.type == "JSFunction") {
        const functionName = getApiHandleFunctionName(item.id);
        const handleFunction = generateFunction(item.dataHandler, { name: functionName, isMember: true, isToVue: true });
        next.chunks.push({
          type: "string" /* STRING */,
          fileType: cfg.fileType,
          name: TEMPLATE_DEFINE_CHUNK_NAME.Method,
          content: `function ${handleFunction}`,
          linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.Method]]
        });
      }
    });
    next.chunks.push(...chunks);
    return next;
  };
  return plugin;
};
var containerMethod_default2 = pluginFactory51;

// src/plugins/component/vue/convert/convert-variable.ts
var convert_variable_default = {
  itemList: (value) => {
    if (!value)
      return [];
    const valueJSON = parseCustomObjectArray(value);
    const strArray = [];
    const ascArray = [];
    const descArray = [];
    valueJSON.forEach((item) => {
      if (item.columnValue) {
        const valueName = `${GLOBE_API_PARAM}.${item.columnValue.split(".")[0]}`;
        strArray.push({ key: lineToUppercase(item.columnName), value: valueName });
      } else if (item.orderBy) {
        if (item.orderBy == "desc") {
          descArray.push(lineToUppercase(item.columnName));
        } else if (item.orderBy == "asc") {
          ascArray.push(lineToUppercase(item.columnName));
        }
      }
    });
    descArray.length && strArray.push({
      key: "orderByDesc",
      value: `'${descArray[0]}'`
    });
    ascArray.length && strArray.push({
      key: "orderByAsc",
      value: `'${ascArray[0]}'`
    });
    return strArray;
  }
};
function parseCustomObjectArray(str) {
  if (str == "[]") {
    return [];
  }
  const result = [];
  const objectRegex = /{([^}]+)}/g;
  let match;
  while ((match = objectRegex.exec(str)) !== null) {
    const objString = match[1].trim();
    const obj = {};
    const keyValueRegex = /(\w+)\s*:\s*([^,]+)(,|$)/g;
    let keyValueMatch;
    while ((keyValueMatch = keyValueRegex.exec(objString)) !== null) {
      const key = keyValueMatch[1].trim();
      let value = keyValueMatch[2].trim();
      if (value.startsWith("'") && value.endsWith("'")) {
        value = value.slice(1, -1);
      }
      if (/^\w+\.\w+$/.test(value)) {
        value = value;
      }
      obj[key] = value;
    }
    result.push(obj);
  }
  return result;
}

// src/plugins/component/vue/dataSourceMap.ts
var pluginFactory52 = (config) => {
  const cfg = {
    fileType: "vue" /* VUE */,
    implementType: "inConstructor",
    ...config
  };
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const dataSourceConfig = isValidContainerType(pre.ir) ? pre.ir.dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    dataSourceItems.forEach((item) => {
      let paramsStr = "";
      let paramsObject = `const ${item.id}Params = {};`;
      const paramName = getApiParamName(item.id);
      const strArray = [];
      const dataResults = requestAfterDataHandler(item, dataSourceConfig.extra);
      if (item.options && item.options.params) {
        const params = item.options.params;
        const keys = Object.keys(params);
        for (let i = 0; i < keys.length; i++) {
          const key = keys[i];
          if (isJsExpression(params[key])) {
            let handleValue = generateFunction(params[key], {
              isToVue: true,
              isDeleteLastSemicolon: true
            });
            if (convert_variable_default[key]) {
              strArray.push(...convert_variable_default[key](handleValue));
            } else {
              strArray.push({
                key,
                value: handleValue
              });
            }
          }
        }
        paramsStr = `${strArray.filter((item2) => item2).map((item2) => `${item2.key}: ${item2.value}`).join(",")}`;
        paramsObject = `const ${paramName} = { ${paramsStr ? paramsStr + "," : ""}...params}`;
      } else if (item.options && !item.options.params) {
        paramsObject = `const ${paramName} = {...params}`;
      }
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: cfg.fileType,
        name: TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapContent,
        content: `
  ${getApiRequestMethodName(item.id)}: async (params?: any) =>  {
  ${paramsObject}
  ${dataResults.join("\n")}
  return handleData
},
        `,
        linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapContent]]
      });
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapStart,
      content: `const ${SUFFIX_DATA_SOURCE_MAP} = {`,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapStart]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: cfg.fileType,
      name: TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapEnd,
      content: `}`,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.DataSourceMapEnd]]
    });
    return next;
  };
  return plugin;
};
var dataSourceMap_default = pluginFactory52;

// src/plugins/component/vue/routerSecond.ts
var pluginFactory53 = () => {
  const plugin = async (pre) => {
    var _a, _b;
    const next = {
      ...pre
    };
    const ir = next.ir;
    (_b = (_a = ir.globalRouter) == null ? void 0 : _a.routes) == null ? void 0 : _b.filter((item) => item.firstPage == "false").forEach((route) => {
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: "ts" /* TS */,
        name: COMMON_CHUNK_NAME.ExternalDepsImport,
        subModule: route.fileName,
        content: `export default [`,
        linkAfter: []
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: "ts" /* TS */,
        name: COMMON_CHUNK_NAME.FileMainContent,
        subModule: route.fileName,
        content: `{
                      path: '${route.path}',
                      name: '${route.title}',
                      component: () => import("@/views/${route.componentName}/${route.isFormRouter ? "Manage.vue" : "Index.vue"}"),
                    }`,
        linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
      });
      next.chunks.push({
        type: "string" /* STRING */,
        fileType: "ts" /* TS */,
        name: COMMON_CHUNK_NAME.FileExport,
        subModule: route.fileName,
        content: `]`,
        linkAfter: [COMMON_CHUNK_NAME.FileMainContent]
      });
    });
    return next;
  };
  return plugin;
};
var routerSecond_default = pluginFactory53;

// src/plugins/project/framework/vuejs3/template/files/env.ts
function getFile43() {
  const file2 = createResultFile(
    ".env",
    "",
    `
# .env
VITE_APP_API_LOGIN=/login
VITE_APP_API_LOGIN_OUT=/loginOut
VITE_APP_API_BASE_URL=/api

VITE_APP_API_FILE_REVIEW=http://tz.future.dct99.com:8090/
#VITE_APP_COPYRIGHT=Copyright@2022 \u7248\u6743\u6240\u6709\uFF1Axxxx

# oss
#VITE_APP_OSS_URL=https://tz-community.oss-cn-hangzhou.aliyuncs.com
#VITE_APP_API_OSS=/oss/logFile/upload
#VITE_APP_OSS_SUFFIX=!tz_sy

# message
#VITE_APP_API_MESSAGE=/WxXcx/sendLoginCode
#VITE_APP_API_CODE_LOGIN=/WxXcx/loginOrSignByMobile
#VITE_APP_API_CODE_LOGIN_PARAMS_MOBILE=mobile
#VITE_APP_API_CODE_LOGIN_PARAMS_CODE=smsCode

# mask
VITE_APP_DEFAULT_MASK='false'
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/vuejs3/template/files/eslintignore.ts
function getFile44() {
  const file2 = createResultFile(
    ".eslintignore",
    "",
    `
node_modules
.vscode
.idea
dist
/public
.eslintrc.js
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/vuejs3/template/files/eslintrc.yml.ts
function getFile45() {
  const file2 = createResultFile(
    ".eslintrc",
    "yml",
    `
env:
  browser: true
  es2021: true
  node: true
  'vue/setup-compiler-macros': true
extends:
  - eslint:recommended
  - plugin:vue/essential
  - prettier
  - plugin:prettier/recommended
  - plugin:@typescript-eslint/recommended
parserOptions:
  ecmaVersion: 2020
  parser: '@typescript-eslint/parser'
  sourceType: module
parser: 'vue-eslint-parser'
plugins:
  - vue
  - '@typescript-eslint'
rules:
  # \u7F29\u8FDB tab
  indent:
    - error
    - tab
    - SwitchCase: 1
  # \u5B57\u7B26\u5355\u5F15\u53F7
  quotes:
    - error
    - single
  # \u5C3E\u90E8\u5206\u53F7
  semi:
    - error
    - never
  # \u652F\u6301\u5355\u4E2Atemplate\u4E2D\u591A\u4E2A\u4E00\u7EA7\u6807\u7B7E
  vue/no-multiple-template-root: off
  # \u5904\u7406v-model\u540E\u65B9\u53C2\u6570\u95EE\u9898
  vue/no-v-model-argument: off
  # \u7EC4\u4EF6\u540D\u79F0\u68C0\u67E5
  vue/multi-word-component-names: 0
    `
  );
  return [[], file2];
}

// src/plugins/project/framework/vuejs3/template/files/gitignore.ts
function getFile46() {
  return [
    [],
    {
      name: ".gitignore",
      ext: "",
      content: `
# \u9879\u76EE\u7684\u73AF\u5883\u6587\u4EF6
.DS_Store
node_modules
/dist


# \u672C\u5730\u73AF\u5883\u6587\u4EF6
.env.local
.env.*.local

# \u65E5\u5FD7\u6587\u4EF6
npm-debug.log*
yarn-debug.log*
yarn-error.log*
pnpm-debug.log*
*-debug.log

# \u7F16\u8F91\u76EE\u5F55\u548C\u6587\u4EF6
.idea
.vscode
*.suo
*.ntvs*
*.njsproj
*.sln
*.sw?
local

# \u6B64\u6587\u4EF6\u9700\u8981\u63D0\u4EA4\uFF0C\u8BE5\u6587\u4EF6\u65E8\u5728\u8DDF\u8E2A\u88AB\u5B89\u88C5\u7684\u6BCF\u4E2A\u8F6F\u4EF6\u5305\u7684\u786E\u5207\u7248\u672C\uFF0C\u4EE5\u4FBF\u4EA7\u54C1\u53EF\u4EE5\u4EE5\u76F8\u540C\u7684\u65B9\u5F0F\u88AB 100\uFF05 \u590D\u5236
package-lock.json
yarn.lock
pnpm-lock.yaml

# \u6392\u9664\u672C\u5730\u6587\u4EF6
local/

dist.zip
            `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/npmrc.ts
function getFile47() {
  return [
    [],
    {
      name: ".npmrc",
      ext: "",
      content: `
@dc-basic-component:registry=https://nexus.dct99.com/repository/npm-public/
@dc:registry=https://nexus.dct99.com/repository/npm-public/
shamefully-hoist=true
strict-peer-dependencies=false
            `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/prettierignore.ts
function getFile48() {
  return [
    [],
    {
      name: ".prettierignore",
      ext: "",
      content: `
node_modules
.vscode
.idea
dist
/public
.eslintrc.js
*.yml
*.yaml
*.md
*.min.js
            `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/prettierrc.yml.ts
function getFile49() {
  return [
    [],
    {
      name: ".prettierrc",
      ext: "yml",
      content: `
# \u6BCF\u884C\u4EE3\u7801\u957F\u5EA6\uFF08\u9ED8\u8BA480\uFF09
printWidth: 160
# \u6BCF\u4E2Atab\u76F8\u5F53\u4E8E\u591A\u5C11\u4E2A\u7A7A\u683C\uFF08\u9ED8\u8BA42\uFF09
tabWidth: 4
# \u662F\u5426\u4F7F\u7528tab\u8FDB\u884C\u7F29\u8FDB\uFF08\u9ED8\u8BA4false\uFF09
useTabs: true
# \u4F7F\u7528\u5355\u5F15\u53F7\uFF08\u9ED8\u8BA4false\uFF09
singleQuote: true
# \u58F0\u660E\u7ED3\u5C3E\u4F7F\u7528\u5206\u53F7(\u9ED8\u8BA4true)
semi: false
# \u591A\u884C\u4F7F\u7528\u62D6\u5C3E\u9017\u53F7\uFF08\u9ED8\u8BA4none\uFF09
trailingComma: none
# \u5BF9\u8C61\u5B57\u9762\u91CF\u7684\u5927\u62EC\u53F7\u95F4\u4F7F\u7528\u7A7A\u683C\uFF08\u9ED8\u8BA4true\uFF09
bracketSpacing: true
# \u53EA\u6709\u4E00\u4E2A\u53C2\u6570\u7684\u7BAD\u5934\u51FD\u6570\u7684\u53C2\u6570\u662F\u5426\u5E26\u5706\u62EC\u53F7\uFF08\u9ED8\u8BA4avoid\uFF09
arrowParens: 'avoid'
# \u884C\u7ED3\u675F\u95EE\u9898\u5904\u7406, lf
endOfLine: lf
            `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/index.html.ts
function getFile50() {
  return [
    [],
    {
      name: "index",
      ext: "html",
      content: `
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8"/>
    <link rel="icon" type="image/png" href="/logo.png"/>
    <meta name="viewport"
          content="width=device-width, initial-scale=1.0, user-scalable=1.0, minimum-scale=1.0, maximum-scale=1.0, viewport-fit=cover"/>
    <title>\u7801\u94FA</title>
  <!--\u5FAE\u4FE1web view api-->
  <script type="text/javascript" src="https://res.wx.qq.com/open/js/jweixin-1.3.2.js"><\/script>
</head>
<body>
<div id="app">
    <div class="loading" style="display: flex;justify-content: center;align-items: center;height: 100vh">
        <div class="loading__icon"></div>
        <div class="loading__text">\u8BF7\u7A0D\u7B49\uFF0C\u9875\u9762\u52A0\u8F7D\u4E2D...</div>
    </div>
</div>
<script type="module" src="/src/main.ts"><\/script>
</body>
</html>
            `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/postcss.config.cjs.ts
function getFile51() {
  return [
    [],
    {
      name: "postcss.config",
      ext: "cjs",
      content: "// postcss.config.js\nmodule.exports = {\n  plugins: {\n   'postcss-px-to-viewport': {\n    // \u8BBE\u8BA1\u7A3F\u5BBD\u5EA6\n    viewportWidth: 375,\n    // \u6392\u9664 node_modules\n    // exclude: /(\\/|\\\\)(node_modules)(\\/|\\\\)/,\n    // \u4E0D\u8F6C\u6362\u7684\u7C7B\u540D\n    selectorBlackList: ['.ignore', '.hairlines']\n   }\n  }\n}"
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/tsconfig.json.ts
function getFile52() {
  return [
    [],
    {
      name: "tsconfig",
      ext: "json",
      content: `
{
  "compilerOptions": {
    "target": "ESNext",
    "useDefineForClassFields": true,
    "module": "ESNext",
    "moduleResolution": "Node",
    "strict": true,
    "jsx": "preserve",
    "sourceMap": true,
    "resolveJsonModule": true,
    "isolatedModules": true,
    "esModuleInterop": true,
    "lib": ["ESNext", "DOM"],
    "skipLibCheck": true,
    "baseUrl": ".",
    "paths": {
      "@/*": ["src/*"]
    }
  },
  "include": ["src/**/*.ts", "src/**/*.d.ts", "src/**/*.tsx", "src/**/*.vue"],
  "references": [{ "path": "./tsconfig.node.json" }]
}
            `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/tsconfig.node.json.ts
function getFile53() {
  return [
    [],
    {
      name: "tsconfig.node",
      ext: "json",
      content: `
{
  "compilerOptions": {
    "composite": true,
    "module": "ESNext",
    "moduleResolution": "Node",
    "allowSyntheticDefaultImports": true
  },
  "include": ["vite.config.ts"]
}
            `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/vite.config.ts.ts
function getFile54() {
  return [
    [],
    {
      name: "vite.config",
      ext: "ts",
      content: `
import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import viteCompression from 'vite-plugin-compression'
import * as path from 'path'

// https://vitejs.dev/config/
export default defineConfig({
 base: '/expressH5/',
 plugins: [vue(), viteCompression()],
 resolve: {
  alias: {
   '@': path.resolve(__dirname, './src'),
   '~@': path.resolve(__dirname, './src')
  }
 },
 server: {
  // host: '127.0.0.1',
  host: '0.0.0.0',
  port: 3212,
  cors: true,
  proxy: {
   '/source/api': {
    target: 'http://localhost:9933/',
    changeOrigin: true,
    ws: true,
    rewrite: path => path.replace(/\\/api/g, '/api')
   }
  }
 },
 css: {
  preprocessorOptions: {
   less: {
    javascriptEnabled: true
   }
  }
 },
 // \u914D\u7F6E\u6253\u5305\u5757\u5927\u5C0F
 build: {
  chunkSizeWarningLimit: 1500
 },
 optimizeDeps: {
  exclude: ['@dc/vue-h5-base'],
  include: ['axios']
 }
})
      `
    }
  ];
}

// src/plugins/project/framework/vuejs3/template/files/css/global.scss.ts
function getFile55() {
  const file2 = createResultFile(
    "global",
    "scss",
    `
* {
  margin: 0;
  padding: 0;
  box-sizing: border-box;
}
.page {
  // \u4E0D\u663E\u793A\u6EDA\u52A8\u6761
  scrollbar-width: none; /* Firefox */
  background: #fff;

  &::-webkit-scrollbar {
    display: none; /* Chrome Safari */
  }

  height: 100vh;
  width: 100vw;
  display: flex;
  flex-direction: column;
  overflow: hidden scroll;
  box-sizing: border-box;

  // \u5B50\u5143\u7D20\u9AD8\u5EA6\u95EE\u9898\u5904\u7406
  & > * {
    flex: 0 0 auto;
  }

  & > & {
    flex: 1 1 auto;
  }
}

.van-uploader {
  flex: 1 1 auto;
}

.van-search {
  background: #ffffff;
  padding: 10px 16px;
  border-top: 1px solid #f3f3f3;

  @at-root &__content--round {
    background: #f3f3f3;
    padding: 4px 16px;
  }
}

// \u7BA1\u7406\u9875\u9762
.manage-page {
  overflow: hidden;
  display: flex;
  flex-direction: column;
  flex: 1 1 auto;
  padding-bottom: 16px;

  --van-tab-text-color: var(--van-text-color-3);
  --van-tab-active-text-color: var(--van-primary-color);
  --van-tabs-bottom-bar-color: var(--van-primary-color);

  .van-pull-refresh {
    flex: 1 1 auto;
    overflow-y: scroll;
    padding: 16px;
  }
}

// \u8BE6\u60C5\u9875\u9762
.detail-page {
  flex: 1 1 auto;
  overflow-y: auto;
  font-size: 14px;
  font-weight: 400;
  color: #9b9ba3;
  padding-bottom: 16px;
  position: relative;
  display: flex;
  flex-direction: column;

  .detail {
    display: grid;
    grid-template-columns: max-content 1fr;
    box-shadow: 0 0 0.5rem 0 rgba(35, 24, 21, 0.1);
    grid-row-gap: 16px;
    column-gap: 16px;
    background: white;
    margin: 16px 16px 0 16px;
    padding: 16px;
    border-radius: 10px;

    @at-root &__label {
      color: #51515c;
      display: flex;
      align-items: center;
      grid-column: 1;

      &:before {
        content: '';
        width: 6px;
        height: 6px;
        border-radius: 3px;
        background: #aeaeb4;
        margin-right: 6px;
        display: inline-block;
      }
    }

    @at-root &__value {
      grid-column: 2;
      color: #9b9ba3;
      flex: 1 1 auto;
      text-align: right;
    }

    @at-root &__images {
      grid-column: 1/-1;
      display: grid;
      grid-template-columns: repeat(3, 1fr);

      .van-image {
        width: 100%;
        min-height: 60px;
        aspect-ratio: 1;
      }
    }

    .van-divider {
      grid-column: span 2;
      margin: 0;
    }
  }
}

// \u5F39\u7A97\u9875\u9762
.overlay-page {
  width: 100vw;
  height: 100vh;

  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  background: transparent;
  padding: 16px;


  .van-form {
    flex: 0 0 auto;
    overflow-y: auto;
    display: flex;
    flex-direction: column;
    background: white;
    border-radius: 10px;

    .van-button {
      margin: 15px 16px;
    }
  }

  .van-cell.tip {
    color: #d46b08;
  }
}

.card__actions {
  grid-column: 1 / -1;
  display: flex;
  justify-content: flex-end;
  align-items: center;
  gap: 10px;

  @at-root &__button {
    font-size: 12px;
    font-weight: 500;
    border-radius: 18px;
    padding: 0 8px;
    height: 24px;

  }
}

/*\u5360\u4F4D*/
.spacer {
  flex: 1 1 auto;
}

.spacer-2 {
  flex: 2 1 auto;
}
`
  );
  return [["src", "assets", "scss"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/css/mixin.scss.ts
function getFile56() {
  const file2 = createResultFile(
    "mixin",
    "scss",
    `
//sass\u5E38\u7528\u6DF7\u5408\u5668(\u5E94\u8BE5\u5408\u7406\u4F7F\u7528)
// \u5F39\u6027\u5E03\u5C40\u6DF7\u5408\u5668
@mixin flexMixer($justify: center, $align: center, $flex: row) {
	// \u7533\u660E\u4E3A\u5F39\u6027\u76D2\u5B50
	display: flex;
	// \u6392\u5217\u65B9\u5F0F
	flex-direction: $flex;
	// \u4E3B\uFF08\u526F\uFF09\u8F74\u7684\u5BF9\u9F50\u65B9\u5F0F
	justify-content: $justify;
	// \u4E3B\uFF08\u526F\uFF09\u8F74\u7684\u5BF9\u9F50\u65B9\u5F0F
	align-items: $align;
}
// \u5B9A\u4F4D\u6DF7\u5408\u5668
@mixin positionMixer($position: static, $left: auto, $top: auto, $right: auto, $bottom: auto) {
	position: $position;
	left: $left;
	top: $top;
	right: $right;
	bottom: $bottom;
}
// \u6D6E\u52A8\u6DF7\u5408\u5668
@mixin floatMixer($float: left) {
	float: $float;
}
// \u8BBE\u7F6E\u80CC\u666F\u6DF7\u5408\u5668
@mixin bgMixer($url, $position: center center, $size: 100% 100%, $repeat: no-repeat) {
	background: $url $repeat $position;
	background-size: $size;
}
// \u5BBD\u9AD8\u6DF7\u5408\u5668
@mixin widthMixer($width: 100px, $height: 100px) {
	width: $width;
	height: $height;
}
// \u6587\u5B57\u6DF7\u5408\u5668
@mixin fontMixer($fontSize: 16px, $color: #515a6e, $weight: 500, $font-familyt: Source Han Sans SC) {
	font-family: $font-familyt;
	font-size: $fontSize;
	font-weight: $weight;
	color: $color;
}

// \u591A\u884C\u5B57\u4F53\u7701\u7565\u6DF7\u5408\u5668
@mixin pointMixer($line: 2) {
	display: -webkit-box; //\u5FC5\u987B\u7ED3\u5408\u7684\u5C5E\u6027 \uFF0C\u5C06\u5BF9\u8C61\u4F5C\u4E3A\u5F39\u6027\u4F38\u7F29\u76D2\u5B50\u6A21\u578B\u663E\u793A \u3002
	word-break: break-all;
	-webkit-line-clamp: $line;
	line-clamp: $line;
	overflow: hidden;
	text-overflow: ellipsis; //\u53EF\u4EE5\u7528\u6765\u591A\u884C\u6587\u672C\u7684\u60C5\u51B5\u4E0B\uFF0C\u7528\u7701\u7565\u53F7\u201C\u2026\u201D\u9690\u85CF\u8D85\u51FA\u8303\u56F4\u7684\u6587\u672C \u3002
	white-space: normal;
	/* autoprefixer: off */
	-webkit-box-orient: vertical; //\u5FC5\u987B\u7ED3\u5408\u7684\u5C5E\u6027 \uFF0C\u8BBE\u7F6E\u6216\u68C0\u7D22\u4F38\u7F29\u76D2\u5BF9\u8C61\u7684\u5B50\u5143\u7D20\u7684\u6392\u5217\u65B9\u5F0F \u3002
	/* autoprefixer: on */
}
`
  );
  return [["src", "assets", "scss"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/css/theme.css.ts
function getFile57() {
  const file2 = createResultFile(
    "theme",
    "css",
    `
@import '@dc/vue-h5-base/src/assets/scss/theme.css';

:root {
	--van-primary-color: #008fff;
	/* Color Palette */
	--van-gray-9: #eeeeee;
	--van-gray-10: #bdbdbd;
	--van-gray-11: #cccccc;
	--van-blue-1: #008fff;
	--van-blue-2: #3296fb;
	--van-orange-1: #f27623;

	/* --------------------------------------------- */
	/* tabbar height */
	--van-tabbar-height: 50px;

	/* --------------------------------------------- */
	/* input \u80CC\u666F\u8272*/
	--input-background-color: #f4f4f4;

	/* --------------------------------------------- */
	/* \u6D59\u91CC\u529E\u4E3B\u9898 */

	/* \u5706\u89D2*/
	--zlb-radius-r5: 10px;
	--zlb-radius-r6: 12px;
	--zlb-radius-r7: 14px;
	--zlb-radius-r8: 16px;
	--zlb-radius-r9: 18px;

	/* --------------------------------------------- */
	/* \u5B57\u4F53\u989C\u8272 */
	--van-text-color-4: #7897ba;
	--van-text-color-5: #232d2d;
	/*--van-text-size2: 18px;*/

	/* --------------------------------------------- */
	/* \u5B57\u4F53 */
	/*\u5DF2\u6709\u5B57\u4F53\uFF0C\u53EF\u4EE5\u4E0D\u7528\u8986\u5199*/
	--van-font-size-xs: 10px;
	--van-font-size-sm: 12px;
	--van-font-size-md: 14px;
	--van-font-size-lg: 16px;
	/*\u8FFD\u52A0\u4E00\u4E2A\u8D85\u5927\u53F7\u5B57\u4F53*/
	--van-font-size-ml: 18px;

	/* --------------------------------------------- */
	/*\u8F93\u5165\u6846\u6837\u5F0F*/
	--van-field-label-color: var(--van-text-color);
	--van-field-placeholder-text-color: var(--van-text-color-3);

	/* --------------------------------------------- */
	/*\u8F93\u5165\u6846\u6837\u5F0F*/
	/*--van-uploader-size: 69px;*/
	/*--van-uploader-delete-icon-size: 18px;*/

	--title-bar-height: 50px;
	--title-bar-padding-top: 0;

	--van-cascader-active-color: var(--van-primary-color);
	--van-cascader-tab-color: var(--van-primary-color);
	--van-tabs-bottom-bar-color: var(--van-primary-color);
}
  `
  );
  return [["src", "assets", "scss"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/src/App.vue.ts
function getFile58() {
  const file2 = createResultFile(
    "App",
    "vue",
    `
<template>
	<router-view v-slot="{ Component }">
		<!--		<keep-alive>-->
		<component :is="Component" />
		<!--		</keep-alive>-->
	</router-view>
</template>

<script lang="ts" setup>
import { onMounted } from 'vue'
import { useRequestStore } from '@dc/vue-h5-base/src/store/request'

let store = useRequestStore()

onMounted(() => {
	store.$reset()
})
<\/script>

<style>
.amap-logo {
	display: none;
	opacity: 0 !important;
}

.amap-copyright {
	opacity: 0;
}
</style>
  `
  );
  return [["src"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/src/main.ts
function getFile59() {
  const file2 = createResultFile(
    "main",
    "ts",
    `
import { createApp } from 'vue'
import App from './App.vue'

/**
 * \u72B6\u6001\u7BA1\u7406
 */
import { createPinia } from 'pinia'
import piniaPluginPersist from 'pinia-plugin-persist'
// \u8DEF\u7531
import router from './router'
/**
 * vant \u7EC4\u4EF6\uFF0C\u6309\u9700\u5F15\u5165
 */
import Vant from 'vant'
import 'vant/lib/index.css'

// \u8986\u76D6\u4E3B\u9898\u6837\u5F0F
import '@/assets/scss/theme.css'

/* \u8FD9\u91CC\u662F\u57FA\u7840\u6846\u67B6\u7684\u6837\u5F0F */
import '@/assets/scss/global.scss'
import '@dc/vue-h5-base/src/assets/font/iconfont.css'
import '@dckj-npm/lowcode-vue-materials/style.css'

createApp(App)
	.use(createPinia().use(piniaPluginPersist))
	.use(Vant)
	// \u8DEF\u7531
	.use(router)
	.mount('#app')

  `
  );
  return [["src"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/src/vite-env.ts
function getFile60() {
  const file2 = createResultFile(
    "vite-env.d",
    "ts",
    `
declare module '*.vue' {
  import type { DefineComponent } from 'vue'
  const component: DefineComponent<{}, {}, any>
  export default component
}

interface ImportMetaEnv {
  // \u767B\u5F55\u7684\u63A5\u53E3\u5730\u5740
  readonly VITE_APP_API_LOGIN: string
  // \u767B\u5F55\u7684\u63A5\u53E3\u5730\u5740
  readonly VITE_APP_API_LOGIN_OUT: string
  // \u767B\u5F55\u7684\u63A5\u53E3\u5730\u5740
  readonly VITE_APP_API_BASE_URL: string
  //\u6587\u4EF6\u9884\u89C8\u5730\u5740\u524D\u7F00
  readonly VITE_APP_API_FILE_REVIEW: string

  // copyright
  readonly VITE_APP_COPYRIGHT: string
  // \u9ED8\u8BA4\u7684\u8BF7\u6C42\u906E\u7F69\u5C42\u662F\u5426\u5F00\u542F
  readonly VITE_APP_DEFAULT_MASK: boolean
}

interface ImportMeta {
  readonly env: ImportMetaEnv
}
  `
  );
  return [["src"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/src/views/baseIndexA/welcome.vue.ts
function getFile61() {
  const file2 = createResultFile(
    "Welcome",
    "vue",
    `
<template>
    <div></div>
</template>

<script lang="ts" setup>
<\/script>

<style lang="scss" scoped>
</style>
  `
  );
  return [["src", "views", "baseIndexA"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/src/views/baseIndexA/tabs.ts
function getFile62() {
  const file2 = createResultFile(
    "tabs",
    "ts",
    `
// import home from '@/assets/images/index/home.png'
// import homeActive from '@/assets/images/index/home-active.png'
// import housekeeper from '@/assets/images/index/housekeeper.png'
// import housekeeperActive from '@/assets/images/index/housekeeper-active.png'
// import mine from '@/assets/images/index/mine.png'
// import mineActive from '@/assets/images/index/mine-active.png'
//
// export interface TabItem {
//  /**
//   * \u6807\u9898
//   */
//  label: string
//  /**
//   * \u56FE\u6807
//   */
//  icon: string
//  /**
//   * \u6FC0\u6D3B\u56FE\u6807
//   */
//  activeIcon: string
//  /**
//   * \u8DEF\u7531\u5730\u5740
//   */
//  router: string
// }
//
// export const tabs: Array<TabItem> = [
//  {
//   label: '\u9996\u9875',
//   icon: home,
//   activeIcon: homeActive,
//   router: '/home'
//  },
//  {
//   label: '\u6D88\u606F',
//   icon: housekeeper,
//   activeIcon: housekeeperActive,
//   router: '/message'
//  },
//  {
//   label: '\u6211\u7684',
//   icon: mine,
//   activeIcon: mineActive,
//   router: '/mine'
//  }
// ]
  `
  );
  return [["src", "views", "baseIndexA"], file2];
}

// src/plugins/project/framework/vuejs3/template/files/src/utils/utils.ts
function getFile63() {
  const file2 = createResultFile(
    "utils",
    "ts",
    `
export default {
    /**
     * \u8DF3\u8F6C\u5230\u6307\u5B9A\u7684pathId\uFF0C\u4EC5\u9650\u9884\u89C8\u9875\u9762
     * @param pageId
     * @param isNew
     */
    gotoByPageId: (pageId: string, isNew: boolean) => {
      // \u83B7\u53D6\u5DF2\u6709\u7684path\u53C2\u6570\u4FE1\u606F
      const oldPageId = getValueFromQueryByName('pageId')
      if (!oldPageId) {
        console.error('pageId is not exist')
        return
      }
      // \u6DFB\u52A0\u5730\u5740\u680F\u4E2D\u7684pathId\u53C2\u6570\u4FE1\u606F
      const resultPath = window.location.href.replace(\`pageId=\${oldPageId}\`, \`pageId=\${pageId}\`)
      if (isNew) {
        window.open(resultPath)
      } else {
        window.location.href = resultPath
      }
    },
    /**
     * \u83B7\u53D6\u5730\u5740\u680F\u53C2\u6570\u503C
     * @param queryName \u53C2\u6570\u540D
     * @param defaultValue \u9ED8\u8BA4\u503C
     */
    getValueFromQueryByName: (queryName: string, defaultValue: string = '') => {
      return getValueFromQueryByName(queryName, defaultValue)
    },
    /**
     * \u83B7\u53D6cookie\u4E2D\u7684\u503C
     * @param cookieName
     * @param defaultValue
     */
    getValueFromCookieByName: (cookieName: string, defaultValue: string = '') => {
      const reg = new RegExp('(^| )' + cookieName + '=([^;]*)(;|$)')
      const arr = document.cookie.match(reg)
      if (arr) {
        return unescape(arr[2])
      } else {
        return defaultValue
      }
    },
    /**
     * \u83B7\u53D6localStorage\u4E2D\u7684\u503C
     * @param key
     * @param defaultValue
     */
    getValueFromLocalStorage: (key: string, defaultValue: string = '') => {
      return localStorage.getItem(key) || defaultValue
    },
    /**
     * \u83B7\u53D6sessionStorage\u4E2D\u7684\u503C
     * @param key
     * @param defaultValue
     */
    getValueFromSessionStorage: (key: string, defaultValue: string = '') => {
      return sessionStorage.getItem(key) || defaultValue
    }
}
  `
  );
  return [["src", "utils"], file2];
}

// src/plugins/project/framework/vuejs3/template/static-files.ts
function generateStaticFiles4(root = createResultDir(".")) {
  runFileGenerator(root, getFile60);
  runFileGenerator(root, getFile51);
  runFileGenerator(root, getFile50);
  runFileGenerator(root, getFile49);
  runFileGenerator(root, getFile48);
  runFileGenerator(root, getFile47);
  runFileGenerator(root, getFile46);
  runFileGenerator(root, getFile45);
  runFileGenerator(root, getFile44);
  runFileGenerator(root, getFile43);
  runFileGenerator(root, getFile52);
  runFileGenerator(root, getFile58);
  runFileGenerator(root, getFile59);
  runFileGenerator(root, getFile53);
  runFileGenerator(root, getFile54);
  runFileGenerator(root, getFile55);
  runFileGenerator(root, getFile56);
  runFileGenerator(root, getFile57);
  runFileGenerator(root, getFile61);
  runFileGenerator(root, getFile62);
  runFileGenerator(root, getFile63);
  return root;
}

// src/plugins/project/framework/vuejs3/template/index.ts
var vuejs3Template = {
  slots: {
    components: {
      path: ["src", "components"]
    },
    pages: {
      path: ["src", "views"]
    },
    router: {
      path: ["src", "router"],
      fileName: "index"
    },
    routerModules: {
      path: ["src", "router", "modules"]
    },
    utils: {
      path: ["src", "utils"],
      fileName: "utils"
    },
    i18n: {
      path: ["src"],
      fileName: "i18n"
    },
    packageJSON: {
      path: [],
      fileName: "package"
    },
    api: {
      path: ["src", "api"]
    },
    main: {
      path: ["src", "views", "baseIndexA"],
      fileName: "Index"
    },
    form: {
      path: ["src", "views"]
    },
    hooks: {
      path: ["src", "hooks"]
    }
  },
  generateTemplate() {
    return generateStaticFiles4();
  }
};
var template_default5 = vuejs3Template;

// src/plugins/project/framework/vuejs3/plugins/packageJSON.ts
var pluginFactory54 = (cfg) => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    const packageJson = {
      name: (cfg == null ? void 0 : cfg.packageName) || "vuejs3-demo-app",
      private: true,
      version: (cfg == null ? void 0 : cfg.packageVersion) || "0.0.1",
      type: "module",
      scripts: {
        dev: "vite",
        build: "vite build",
        preview: "vite preview"
      },
      description: "vue3\u57FA\u7840\u9879\u76EE",
      dependencies: {
        axios: "^1.7.7",
        dayjs: "^1.11.9",
        "js-base64": "^3.7.5",
        pinia: "^2.0.20",
        "pinia-plugin-persist": "^1.0.0",
        "postcss-px-to-viewport": "^1.1.1",
        vant: "^3.6.4",
        vue: "^3.3",
        "vue-router": "^4.1.3",
        "@dckj-npm/lowcode-vue-materials": "^1.2.84",
        "ant-design-vue": "^4.2.5",
        jsencrypt: "^3.3.2"
      },
      devDependencies: {
        "@dc/vue-h5-base": "^1.0.53-beta.10",
        "@types/node": "^17.0.45",
        "@typescript-eslint/eslint-plugin": "^5.56.0",
        "@typescript-eslint/parser": "^5.56.0",
        "@vitejs/plugin-vue": "^3.2.0",
        "@vue/compiler-sfc": "3.2.33",
        "@vue/eslint-config-prettier": "^7.1.0",
        eslint: "^8.36.0",
        "eslint-plugin-prettier": "^4.2.1",
        "eslint-plugin-vue": "^8.7.1",
        prettier: "^2.8.6",
        sass: "^1.60.0",
        typescript: "^4.9.5",
        vite: "^3.2.5",
        "vite-plugin-compression": "^0.5.1",
        "vite-plugin-eslint": "^1.8.1",
        "vite-plugin-style-import": "^2.0.0",
        "vue-eslint-parser": "^8.3.0",
        "vue-tsc": "^0.40.13"
      }
    };
    next.chunks.push({
      type: "json" /* JSON */,
      fileType: "json" /* JSON */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: packageJson,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var packageJSON_default4 = pluginFactory54;

// src/utils/routerHandle.ts
function getRouters(routes) {
  return routes.filter((item) => item.firstPage != "false").map((route) => {
    return `
                    {
                      path: '${route.path}',
                      name: '${route.title}',
                      component: () => import("@/views/${route.componentName}/${route.isFormRouter ? "Manage.vue" : "Index.vue"}"),
                    }`;
  });
}

// src/plugins/project/framework/vuejs3/plugins/router.ts
var pluginFactory55 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: `
        import {
          	createRouter,
          	createWebHashHistory,
          	createWebHistory,
          	NavigationGuardNext,
          	RouteLocationNormalized,
          	RouteLocationNormalizedLoaded,
          	RouteRecordRaw
        } from "vue-router"
        import { useSystemStore } from "@dc/vue-h5-base/src/store/system"
        import { setRouter, defaultBeforeEach } from "@dc/vue-h5-base/src/router"
        import { useUserStore } from '@dc/vue-h5-base/src/store/user'
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.FileVarDefine,
      content: `
// \u52A8\u6001\u5BFC\u5165\u6240\u6709modules\u4E0B\u7684\u8DEF\u7531\u6587\u4EF6\u4FE1\u606F
const modelsFile = import.meta.globEager<Record<"default", Array<RouteRecordRaw>>>("./modules/**/*.ts")

// \u8DEF\u7531\u53BB\u4E2D\u5FC3\u5316
const children =
  Object.keys(modelsFile)
    .map((key: string) => modelsFile[key].default)
    .flat(1) || []

/**
 * \u7CFB\u7EDF\u8DEF\u7531\u4FE1\u606F
 */
const routes: RouteRecordRaw[] = [
    {
        path: "/",
        redirect: "${ir.routes[0].path}",
        name: "index",
        meta: {
            keepAlive: true
        },
        component: () => import("@/views/baseIndexA/Index.vue"),
        children: [
            ${getRouters(ir.routes).join(",")}
        ]
    },
    {
        path: "/business",
        name: "business",
        component: () => import("@dc/vue-h5-base/src/views/Main.vue"),
        children: children,
        // \u8FD9\u91CC\u7528\u6765\u663E\u793A\u6807\u9898
        props: (route: RouteLocationNormalizedLoaded) => ({
            title: route.query.title || route.query.title || route.name
        })
    },
    {
        path: "/login",
        name: "\u767B\u5F55",
        component: () => import("@dc/vue-h5-base/src/views/login/Login.vue")
    }
]
const router = createRouter({
    history: createWebHashHistory(import.meta.env.BASE_URL),
    routes,
})

// \u8BBE\u7F6E\u57FA\u7840\u6846\u67B6\u4E2D\u7684\u8DEF\u7531\u4FE1\u606F
setRouter(router)

/**
 * \u5F00\u542F\u8DEF\u7531\u524D\u7F6E\u5B88\u536B
 */
router.beforeEach(defaultBeforeEach)
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.FileExport,
      content: `
        export default router;
      `,
      linkAfter: [
        COMMON_CHUNK_NAME.ExternalDepsImport,
        COMMON_CHUNK_NAME.InternalDepsImport,
        COMMON_CHUNK_NAME.FileVarDefine,
        COMMON_CHUNK_NAME.FileMainContent
      ]
    });
    return next;
  };
  return plugin;
};
var router_default2 = pluginFactory55;

// src/plugins/project/framework/vuejs3/plugins/main.ts
var pluginFactory56 = (config) => {
  const cfg = {
    fileType: "vue" /* VUE */,
    nodeTypeMapping: {},
    ...config
  };
  const { nodeTypeMapping } = cfg;
  const plugin = async (pre) => {
    var _a, _b;
    const next = {
      ...pre
    };
    const { tolerateEvalErrors = true } = next.contextData;
    const customHandlers = {
      expression(input, scope2, config2) {
        var _a2;
        return transformJsExpr2(generateExpression(input, scope2), scope2, {
          dontWrapEval: !((_a2 = config2 == null ? void 0 : config2.tolerateEvalErrors) != null ? _a2 : tolerateEvalErrors),
          dontTransformThis2ContextAtRootScope: true
        });
      },
      function(input, scope2) {
        return transformThis2Context2(
          generateCompositeType(
            {
              type: "JSFunction",
              value: input.value || "function () {}"
            },
            Scope.createRootScope()
          ),
          scope2,
          { ignoreRootScope: true }
        );
      }
    };
    const generatorPlugins = {
      handlers: customHandlers,
      tagMapping: (v) => nodeTypeMapping[v] || v,
      tolerateEvalErrors
    };
    const ir = next.ir.containers[0];
    const scope = Scope.createRootScope();
    const { code, node } = generateByName(generatorPlugins, "Navigation", ir, scope, {
      "v-model": "active"
    });
    next.chunks.push({
      zIndex: code ? 1 : 0,
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: COMMON_CHUNK_NAME.FileMainContent,
      content: `
<template>
	<div class="page">
		<!--\u9996\u9875-->
		<router-view v-slot="{ Component, route }">
			<keep-alive>
				<component :is="Component" :key="route.fullPath" />
			</keep-alive>
		</router-view>

		<!--\u5E95\u90E8\u5BFC\u822A\u680F-->
        ${code}
	</div>
</template>

<script lang="ts" setup>
import { onMounted, ref, watchEffect } from "vue"
import { useRoute, useRouter } from 'vue-router'
import { Navigation } from '@dckj-npm/lowcode-vue-materials';

let router = useRouter()

/**
 * \u5F53\u524D\u6FC0\u6D3B\u7684tab
 */
const active = ref(0)
const tabInfo = [
    ${(_b = (_a = node.props) == null ? void 0 : _a.itemArray) == null ? void 0 : _b.map(
        (item) => {
          var _a2, _b2, _c, _d;
          return `{text: '${(_a2 = item.text) != null ? _a2 : ""}', icon: '${(_b2 = item.icon) != null ? _b2 : ""}', pageId: '${(_c = item.pageId) != null ? _c : ""}', selectedIcon: '${(_d = item.selectedIcon) != null ? _d : ""}'}`;
        }
      ).join(",\n")}]

/**
* \u8DF3\u8F6C\u9875\u9762
* @param params
* @param extParams
*/
function goPage(params, ...extParams) {
  const { pathId } = extParams.find(obj => obj.hasOwnProperty('pathId')) || {};
  const pageId = params ? params : pathId;
  router.replace(pageId);
}

/**
 * \u4ECE\u754C\u9762\u8FDB\u5165\uFF0C\u9009\u4E2Dtab
 */
let route = useRoute()
watchEffect(() => {
	let number = tabInfo.findIndex((tab) => tab.pageId == route?.path)
	if (number != -1) {
		active.value = number
	}
})
<\/script>

<style lang="scss" scoped>
</style>`,
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var main_default = pluginFactory56;

// src/utils/apiHandler.ts
var suffix = "Request";
function getApiName2(apiId) {
  return apiId + suffix;
}

// src/types/column-type.ts
var DYNAMIC_COLUMN_DATA_TYPE_TEXT = {
  code: 1,
  name: "\u5355\u884C\u6587\u672C",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_TEXTAREA = {
  code: 2,
  name: "\u591A\u884C\u6587\u672C",
  dbTypeName: "text"
};
var DYNAMIC_COLUMN_DATA_TYPE_INT = {
  code: 3,
  name: "\u6574\u6570",
  dbTypeName: "int"
};
var DYNAMIC_COLUMN_DATA_TYPE_MONEY = {
  code: 15,
  name: "\u91D1\u989D",
  dbTypeName: "numeric"
};
var DYNAMIC_COLUMN_DATA_TYPE_NUMBER = {
  code: 35,
  name: "\u6570\u503C",
  dbTypeName: "numeric"
};
var DYNAMIC_COLUMN_DATA_TYPE_ID_CARD = {
  code: 11,
  name: "\u8EAB\u4EFD\u8BC1",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_MOBILE = {
  code: 12,
  name: "\u624B\u673A",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_EMAIL = {
  code: 36,
  name: "\u90AE\u7BB1",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_DATE = {
  code: 6,
  name: "\u65E5\u671F",
  dbTypeName: "date"
};
var DYNAMIC_COLUMN_DATA_TYPE_DATETIME = {
  code: 7,
  name: "\u65E5\u671F\u65F6\u95F4",
  dbTypeName: "datetime"
};
var DYNAMIC_COLUMN_DATA_TYPE_LABEL = {
  code: 10,
  name: "\u6587\u672C\u8BF4\u660E",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_SWITCH = {
  code: 29,
  name: "\u5F00\u5173",
  dbTypeName: "tinyint"
};
var DYNAMIC_COLUMN_DATA_TYPE_RADIO = {
  code: 4,
  name: "\u5355\u9009\u6846",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_CHECKBOX = {
  code: 5,
  name: "\u590D\u9009\u6846",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_USER = {
  code: 18,
  name: "\u8054\u7CFB\u4EBA",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_DEPT = {
  code: 17,
  name: "\u7EC4\u7EC7\u67B6\u6784\u90E8\u95E8",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_ORGAN = {
  code: 25,
  name: "\u7EC4\u7EC7\u67B6\u6784\u5355\u4F4D",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_SELECT = {
  code: 19,
  name: "\u4E0B\u62C9\u6846",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_CASCADE = {
  code: 13,
  name: "\u7EA7\u8054/\u5206\u7C7B",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_PICTURE = {
  code: 14,
  name: "\u56FE\u7247",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_VIDEO = {
  code: 30,
  name: "\u89C6\u9891",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_AUDIO = {
  code: 37,
  name: "\u97F3\u9891",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_DOC = {
  code: 34,
  name: "\u6587\u6863",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_ATTACHMENTS = {
  code: 16,
  name: "\u9644\u4EF6",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_AUTO = {
  code: 26,
  name: "\u81EA\u52A8\u751F\u6210",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_EDITOR = {
  code: 31,
  name: "\u5BCC\u6587\u672C",
  dbTypeName: "longtext"
};
var DYNAMIC_COLUMN_DATA_TYPE_POSITIONING = {
  code: 39,
  name: "\u5B9A\u4F4D",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_GRADE = {
  code: 41,
  name: "\u7B49\u7EA7",
  dbTypeName: "numeric"
};
var DYNAMIC_COLUMN_DATA_TYPE_BUTTON = {
  code: 46,
  name: "\u6309\u94AE",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_CHILDREN_TABLE = {
  code: 47,
  name: "\u5B50\u8868\u5355",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_QUOTE = {
  code: 48,
  name: "\u5F15\u7528\u5B57\u6BB5",
  dbTypeName: "varchar"
};
var DYNAMIC_COLUMN_DATA_TYPE_LINKAGE = {
  code: 49,
  name: "\u8054\u52A8\u5B57\u6BB5",
  dbTypeName: "varchar"
};

// src/utils/columnType.ts
var getFieldType = (columnKeyType) => {
  switch (columnKeyType) {
    case DYNAMIC_COLUMN_DATA_TYPE_TEXT.code:
    case DYNAMIC_COLUMN_DATA_TYPE_INT.code:
    case DYNAMIC_COLUMN_DATA_TYPE_MONEY.code:
    case DYNAMIC_COLUMN_DATA_TYPE_NUMBER.code:
    case DYNAMIC_COLUMN_DATA_TYPE_ID_CARD.code:
    case DYNAMIC_COLUMN_DATA_TYPE_MOBILE.code:
    case DYNAMIC_COLUMN_DATA_TYPE_EMAIL.code:
      return "field";
    case DYNAMIC_COLUMN_DATA_TYPE_TEXTAREA.code:
      return "textarea";
    case DYNAMIC_COLUMN_DATA_TYPE_DATE.code:
      return "date-picker";
    case DYNAMIC_COLUMN_DATA_TYPE_DATETIME.code:
      return "time-picker";
    case DYNAMIC_COLUMN_DATA_TYPE_LABEL.code:
      return "text";
    case DYNAMIC_COLUMN_DATA_TYPE_SWITCH.code:
      return "switch";
    case DYNAMIC_COLUMN_DATA_TYPE_RADIO.code:
      return "radio";
    case DYNAMIC_COLUMN_DATA_TYPE_CHECKBOX.code:
      return "checkbox";
    case DYNAMIC_COLUMN_DATA_TYPE_USER.code:
    case DYNAMIC_COLUMN_DATA_TYPE_DEPT.code:
    case DYNAMIC_COLUMN_DATA_TYPE_ORGAN.code:
    case DYNAMIC_COLUMN_DATA_TYPE_SELECT.code:
      return "picker";
    case DYNAMIC_COLUMN_DATA_TYPE_CASCADE.code:
      return "cascader";
    case DYNAMIC_COLUMN_DATA_TYPE_PICTURE.code:
    case DYNAMIC_COLUMN_DATA_TYPE_VIDEO.code:
    case DYNAMIC_COLUMN_DATA_TYPE_AUDIO.code:
    case DYNAMIC_COLUMN_DATA_TYPE_DOC.code:
    case DYNAMIC_COLUMN_DATA_TYPE_ATTACHMENTS.code:
      return "uploader";
    case DYNAMIC_COLUMN_DATA_TYPE_AUTO.code:
      return "auto-complete";
    case DYNAMIC_COLUMN_DATA_TYPE_EDITOR.code:
      return "rich-text";
    case DYNAMIC_COLUMN_DATA_TYPE_POSITIONING.code:
      return "amap";
    case DYNAMIC_COLUMN_DATA_TYPE_GRADE.code:
      return "rate";
    case DYNAMIC_COLUMN_DATA_TYPE_CHILDREN_TABLE.code:
    case DYNAMIC_COLUMN_DATA_TYPE_QUOTE.code:
    case DYNAMIC_COLUMN_DATA_TYPE_LINKAGE.code:
      return "picker";
    default:
      return "field";
  }
};

// src/plugins/project/framework/vuejs3/plugins/form.ts
var pluginFactory57 = () => {
  const plugin = async (pre) => {
    var _a, _b, _c, _d, _e, _f;
    const next = {
      ...pre
    };
    const ir = next.ir;
    const columnList = ((_c = (_b = (_a = ir.dataSource) == null ? void 0 : _a.extra[ir.dataSource.list[0].id].columnToAttribute) == null ? void 0 : _b.formData) == null ? void 0 : _c.filter(
      (item) => item.columnKeyType !== DYNAMIC_COLUMN_DATA_TYPE_BUTTON.code && item.columnKeyType !== DYNAMIC_COLUMN_DATA_TYPE_AUTO.code
    )) || [];
    console.log(columnList);
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      subModule: "add-field",
      content: `
        import { FieldProps } from '@dc/vue-h5-base/src/components/form-item/field-props'
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.FileVarDefine,
      subModule: "add-field",
      content: `
      export const fields = (id?: string | undefined) => {
        return [
          ${columnList.map((field) => {
        return `
              {
                name: '${field.columnName}',
                label: '${field.columnComment}',
                type: '${getFieldType(field.columnKeyType)}',
                placeholder: '${field.guideWords}',
                show: ${field.showAddType == 0 ? false : true},
                required: ${field.isRequired == 0 ? false : true},
                rules: [
                  {
                    required: ${field.isRequired == 0 ? false : true},
                    message: '${field.guideWords}',
                  },
                  ${field.fieldValidation ? `
                    {
                      pattern: '${field.fieldValidation}',
                      message: '${field.columnComment}\u683C\u5F0F\u4E0D\u6B63\u786E'
                    }
                    ` : ""}
                ],
                typeValue: { 
                  ${field.selectActionLabel ? `
                    fieldNames: {
                      label: '${field.selectActionLabel}',
                      value: '${field.selectActionValue}'
                    },
                    ` : ""}
                  ${field.fieldSuffix ? `addonAfter: ${field.fieldSuffix}` : ""}
                  ${field.columnOptionList ? `
                      options: [${field.columnOptionList.map((item) => {
          console.log(JSON.stringify(item));
          return JSON.stringify(item);
        })}]
                      ` : ""}
                }
              }
              `;
      })}
        ]
      }
      `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.TemplateDom,
      subModule: "Add",
      content: `
        <template>
          <van-form ref="form">
            <template v-for="(item, index) of addFields">
              <base-form-item
                v-if="item.show"
                :key="index"
                v-model:value="formState[item.name]"
                :label="item.label"
                :name="item.name"
                :placeholder="item.placeholder"
                :required="true"
                :rules="item.rules"
                :type="item.type"
                :typeValue="item.typeValue"
                @update:extraValue="extraValueChange"
              />
            </template>
          </van-form>
          <van-button round type="primary" color="#FB663E" @click="onSubmit">\u63D0\u4EA4</van-button>
        </template>
      `,
      linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
      subModule: "Add",
      content: `
      <script setup lang="ts">
      import router from '@/router'
      import { fields } from './add-field'
      import { computed, onMounted, reactive, ref, defineProps, onBeforeMount } from 'vue'
      import BaseFormItem from '@dc/vue-h5-base/src/components/form-item/BaseFormItem.vue'
      import { messageMethod } from '@dc/vue-h5-base/src/utils/message-util'
      import { GetRequestModel, PostRequestModel } from '@dc/vue-h5-base/src/http/request-model'
      import { OptionProps, SelectProps, FieldProps, ExtraProps } from '@dc/vue-h5-base/src/components/form-item/field-props'
      import {
        ColumnField,
        handleFileList,
        handleLinkageFields,
        handleRemoteSearch,
        LinkageField,
        getDefaultValues,
        handleColumnOptions,
        FilterField,
        handleFilterField
      } from '@/sources/hooks/index'
      `,
      linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart]
    });
    const dataSourceConfig = isValidContainerType(pre.ir) ? pre.ir.dataSource : null;
    const dataSourceItems = dataSourceConfig && dataSourceConfig.list || [];
    const selectActionTypeFieldList = ((_f = (_e = (_d = ir.dataSource) == null ? void 0 : _d.extra[ir.dataSource.list[0].id].columnToAttribute) == null ? void 0 : _e.formData) == null ? void 0 : _f.filter(
      (field) => field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_USER.code || field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_DEPT.code || field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_ORGAN.code || field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_CHILDREN_TABLE.code || field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_QUOTE.code || field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_LINKAGE.code
    )) || [];
    const quoteFieldList = selectActionTypeFieldList.filter(
      (field) => field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_QUOTE.code
    );
    if (dataSourceItems.length > 0) {
      dataSourceItems.forEach((ds) => {
        const dsType = ds.type || "fetch";
        if (dsType !== "custom") {
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            subModule: "Add",
            name: TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport,
            content: `import  ${getApiName2(ds.id)} from '@/api/${ds.id}';`,
            linkAfter: [...DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport]]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.ConstVar,
            subModule: "Add",
            content: `
const form = ref(null)

const props = defineProps<{
  id?: string
}>()

const addFields = ref(fields(''))
const formState = reactive({
  id: props.id
})
            `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent,
            subModule: "Add",
            content: `
            ${selectActionTypeFieldList.map((field) => {
              return `
// \u8BF7\u6C42\u5B57\u6BB5\u8FDC\u7A0B\u6570\u636E
onBeforeMount(async () => {
  const fieldsItem = addFields.find(item => item.name === '${field.columnComment}')
  if (fieldsItem) {
    const typeValue = reactive<SelectProps>(fieldsItem.typeValue as SelectProps)
    const { data } = await new ${field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_CHILDREN_TABLE.code || field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_QUOTE.code || field.columnKeyType == DYNAMIC_COLUMN_DATA_TYPE_LINKAGE.code ? "Post" : "Get"}RequestModel<Array<OptionProps>>('${field.selectAction}', {}).request()
    typeValue.isFetching = data.length >= 100
    typeValue.options = data ?? []
    // \u76F4\u63A5\u66F4\u65B0\u539F\u59CB item \u7684 typeValue
    fieldsItem.typeValue = typeValue
  }
})
                  `;
            })}
onMounted(async () => {
  ${selectActionTypeFieldList.map((field) => {
              return `
    await get${camelize(field.columnName)}()
    `;
            }).join("")}
  
  //\u67E5\u8BE6\u60C5\u5E76\u663E\u793A
  if (props.id) {
    const { data } = await ${getApiName2(ds.id)}.getById(props.id)
    Object.assign(formState, data)
  } 
})
            `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.OnMountedStart]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.Method,
            subModule: "Add",
            content: `
${selectActionTypeFieldList.map((field) => {
              return `
      const get${camelize(field.columnName)} = async () => {
        const typeValue = reactive<SelectProps>(fieldsItem.typeValue as SelectProps)
        const { data } = await new ${field.selectActionType == 14 || field.selectActionType == 15 ? "Post" : "Get"}RequestModel<Array<OptionProps>>('${field.selectAction}', {}).request()

        typeValue.isFetching = data.length >= 100
        
        typeValue.options = data ?? []
        
        // \u76F4\u63A5\u66F4\u65B0\u539F\u59CB item \u7684 typeValue
        fieldsItem.typeValue = typeValue
      }
    `;
            })}
/**
 * \u8868\u5355\u5B57\u6BB5\u503C\u6539\u53D8\u89E6\u53D1
 **/
function extraValueChange(name: string, option: ExtraProps) {
  ${quoteFieldList ? `
      //\u5F15\u7528\u5B57\u6BB5
      const referenceFields: ColumnField[] = [
      ${quoteFieldList.map((field) => {
              return `
              {
                fieldName: '${camelize(field.columnName)}',
                joinTableInfoId: '${field.joinTableInfo.id}',
              }
            `;
            })}
  ]
                ` : ""}
              ${quoteFieldList ? `
  //\u6709\u7B5B\u9009\u5173\u7CFB\u5B57\u6BB5
  const filterFields: FilterField[] = [
  ${quoteFieldList.map((field) => {
              console.log(field.joinTableInfo.joinColumnList);
              return `
          {
            fieldName: '${camelize(field.columnName)}',
            columnName: '${field.columnName}',
            columnKeyType: ${field.columnKeyType},
            selectAction: '${field.selectAction}',
            selectActionLabelArr: [],
            joinColumnList: [${field.joinTableInfo.joinColumnList.map((item) => JSON.stringify(item)).join(", \n")}]
          }
        `;
            })}
    
  ]
// \u5904\u7406\u7B5B\u9009\u5B57\u6BB5
if(filterFields.length > 0) handleFilterField<IDynamicTbSpxx>(name, option, formState, addFields, filterFields)
                ` : ""}

    }
    /**
     * \u63D0\u4EA4\u6570\u636E
     **/
    async function onSubmit () {
      if (props.id) {
      const { message } = await ${getApiName2(ds.id)}.update(formState)
        messageMethod.success(message)
      } else {
        const { message } = await ${getApiName2(ds.id)}.add(formState)
        messageMethod.success(message)
      }
    }
            `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.UnMountedEnd]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd,
            subModule: "Add",
            content: `
            <\/script>
            `,
            linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd]]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.TemplateDom,
            subModule: "Manage",
            content: `
        <template>
            <div class="page">
              <div class="action">
                  <SearchBar
                    placeholder="\u8BF7\u8F93\u5165\u5173\u952E\u8BCD"
                    :searchText="true"
                    v-model:search-value="searchValue"
                    @confirm="handleSearch"
                    @clear="handleSearch"
                    :autofocus="true"
                  >
                  </SearchBar>
                  <Icon type="add" />
              </div>
              <van-pull-refresh :disabled="true" v-model="refreshing" @refresh="onRefresh" v-if="list.length > 0">
                <van-list v-model:loading="loading" :finished="finished" finished-text="\u6CA1\u6709\u66F4\u591A\u4E86" @load="onLoad">
                  <div class="list">
                    <div class="list-item" v-for="item in list" :key="item.id">
                    ${columnList.length > 3 ? columnList.slice(0, 3).map((item) => {
              return `
                            <div class="list-item-column" >${item.columnComment}: {{item['${item.columnName}']}}</div>
                          `;
            }) : columnList.map((item) => {
              return `
                            <div class="list-item-column" >${item.columnComment}: {{item['${item.columnName}']}}</div>
                          `;
            })}
                    </div>
                  </div>
                </van-list>
              </van-pull-refresh>
            </div>
        </template>
      `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.TemplateStart]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.ExternalDepsImport,
            subModule: "Manage",
            content: `
      <script setup lang="ts">
            import { SearchBar, Icon } from '@dckj-npm/lowcode-vue-materials'
            import { ref, onMounted } from 'vue'
      `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.ScriptStart]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            subModule: "Manage",
            name: TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport,
            content: `import  ${getApiName2(ds.id)} from '@/api/${ds.id}';`,
            linkAfter: [...DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport]]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.ConstVar,
            subModule: "Manage",
            content: `
            const pageNum = ref(1)
            let loading = ref(false)
            const finished = ref(false)
            const refreshing = ref(false)
            const isLastPage = ref(false)
            let list = ref<any[]>([])
            `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.InternalDepsImport]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.OnMountedContent,
            subModule: "Manage",
            content: `
          onMounted(() => {
            onRefresh()
          })
          `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.OnMountedStart]
          });
          next.chunks.push({
            type: "string" /* STRING */,
            fileType: "vue" /* VUE */,
            name: TEMPLATE_DEFINE_CHUNK_NAME.Method,
            subModule: "Manage",
            content: `
            const onRefresh = async () => {
              // \u6E05\u7A7A\u5217\u8868\u6570\u636E
              finished.value = false
      
              // \u91CD\u65B0\u52A0\u8F7D\u6570\u636E
              // \u5C06 loading \u8BBE\u7F6E\u4E3A true\uFF0C\u8868\u793A\u5904\u4E8E\u52A0\u8F7D\u72B6\u6001
              loading.value = true
              pageNum.value = 1
              await onLoad()
            }
              const onLoad = async () => {
                if (refreshing.value) {
                  list.value = []
                  refreshing.value = false
                }
                // \u907F\u514D\u91CD\u590D\u52A0\u8F7D
                // if (loading.value || finished.value) return
      
                let { data } = await ${getApiName2(
              ds.id
            )}.page({ pageNum: pageNum.value, pageSize: 10 })
                console.log('data', data.list)
                
                isLastPage.value = data.isLastPage
                if (data.pageNum === 1) {
                  list.value = data.list
                } else {
                  list.value?.push(...data.list)
                }
                loading.value = false
                pageNum.value = pageNum.value + 1
                if (isLastPage.value || list.value.length >= data.total) {
                  finished.value = true
                  console.log(finished.value)
                }
              }
            `,
            linkAfter: [TEMPLATE_DEFINE_CHUNK_NAME.UnMountedEnd]
          });
        }
      });
    }
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd,
      subModule: "Manage",
      content: `
      <\/script>
      `,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd]]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "vue" /* VUE */,
      name: TEMPLATE_DEFINE_CHUNK_NAME.CssStyleImport,
      subModule: "Manage",
      content: `
      <style lang="scss">
        .page {
          width: 100%;
          display: flex;
          flex-direction: column;
          .action {
            width: 100%;
            display: flex;
            align-items: center;
          }
          .list {
            width: 100%;
            display: flex;
            flex-direction: column;
            .list-item {
              width: 100%;
              display: flex;
              flex-direction: column;
              .list-item-column {
                display: flex;
                align-items: center;
              }
            }
          }
        }
      </style>
      `,
      linkAfter: [...VUE_DEFAULT_LINK_AFTER[TEMPLATE_DEFINE_CHUNK_NAME.ScriptEnd]]
    });
    return next;
  };
  return plugin;
};
var form_default = pluginFactory57;

// src/plugins/project/framework/vuejs3/plugins/hooks.ts
var pluginFactory58 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    const ir = next.ir;
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: `
        import { BasePo, BusinessPO } from '@dc/vue-h5-base/src/entity/common/base'
        import { ExtraProps, FieldProps, SelectProps } from '@dc/vue-h5-base/src/components/form-item/field-props'
        import { PostRequestModel, QueryType } from '@dc/vue-h5-base/src/http/request-model'
        import { OptionProps } from 'ant-design-vue/es/vc-select/Option'
		import { UnwrapNestedRefs } from 'vue'
		import { BaseUtil } from '@dc/vue-h5-base/src/utils/base-util'
		import { CascaderProps, UploadFile, UploadProps } from 'ant-design-vue'
        `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport]
    });
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "ts" /* TS */,
      name: COMMON_CHUNK_NAME.FileVarDefine,
      content: `
export interface IColumnOption {
	/**
	 * \u662F\u5426\u662F\u9ED8\u8BA4\u503C
	 */
	isDefault: number
	/**
	 * \u9009\u9879\u540D\u79F0
	 */
	optionName: string
	/**
	 * \u9009\u9879\u503C
	 */
	optionValue: string | number

	[key: string]: string | number | string[]
}
export interface FilterField {
	fieldName: string
	columnName: string
	columnKeyType: number
	selectAction: string
	selectActionLabelArr: string[]
	joinColumnList: {
		conditionKey: string
		conditionValue: string
	}[]
}
export interface LinkageField {
	selectAction: string
	selectActionValue: string
	selectActionLabel: string
}

export function handleFilterField<T extends BusinessPO | BasePo>(
	name: string,
	option: ExtraProps,
	formState: Record<string, unknown>,
	fieldList: Array<FieldProps<T>>,
	filterFields: FilterField[]
) {
	const relationColumns = filterFields.filter(column => column.joinColumnList.find(joinColumn => joinColumn.conditionKey === name))
	if (relationColumns.length > 0) {
		let itemList: Record<string, QueryType>[] = []
		itemList = relationColumns.map(relationColumn => {
			return {
				columnName: relationColumn.columnName,
				columnValue: option.values ? (formState[relationColumn.fieldName] as QueryType) : ''
			}
		})
		const field = filterFields.find(field => field.fieldName === name)
		itemList.push({
			columnName: field?.columnName,
			columnValue: formState[field?.fieldName as string] as string
		})
		relationColumns.forEach(column => {
			const { columnKeyType, selectAction, selectActionLabelArr } = column
			if (columnKeyType !== 47) {
				new PostRequestModel<Array<IColumnOption>>(selectAction, itemList ? { itemList } : {}).request().then(({ data }) => {
					const fieldTypeValue = fieldList.find(field => field.name === column.fieldName)?.typeValue as SelectProps
					if (fieldTypeValue) fieldTypeValue.options = data ?? []
					const isMultipleField = selectActionLabelArr && selectActionLabelArr.length > 1
					if (isMultipleField) {
						data?.forEach(item => {
							const label: string[] = []
							selectActionLabelArr.forEach(labelName => label.push(<string>item[labelName]))
							item.label = label.join(',')
						})
					}
				})
			}
		})
	}
}

export const handleColumnOptions = <T>(data: Array<T>, selectActionType: number, selectActionLabel: string, selectActionValue: string) => {
	let columnOptionList = []
	switch (selectActionType) {
		case 6:
			// \u90E8\u95E8\u7528\u6237\u5217\u8868
			columnOptionList = JSON.parse(
				JSON.stringify(data)
					.replace(/"deptName"/g, \`"\${selectActionLabel}"\`)
					.replace(/"deptId"/g, \`"\${selectActionValue}"\`)
					.replace(/"userList"/g, '"options"')
			)
			break
		case 7:
			// \u90E8\u95E8\u7528\u6237\u6811
			columnOptionList = JSON.parse(
				JSON.stringify(flattenDeptUserTree(data as Array<any>))
					.replace(/"deptName"/g, \`"\${selectActionLabel}"\`)
					.replace(/"deptId"/g, \`"\${selectActionValue}"\`)
			)
			break
		case 8:
			// \u5355\u4F4D\u90E8\u95E8\u7528\u6237\u5217\u8868
			columnOptionList = JSON.parse(
				JSON.stringify(flatten(data as Array<any>))
					.replace(/"orgName"/g, \`"\${selectActionLabel}"\`)
					.replace(/"orgId"/g, \`"\${selectActionValue}"\`)
					.replace(/"deptName"/g, \`"\${selectActionLabel}"\`)
					.replace(/"deptId"/g, \`"\${selectActionValue}"\`)
					.replace(/"deptUserList"/g, '"children"')
					.replace(/"userList"/g, '"children"')
			)
			break
		default:
			columnOptionList = data
	}
	return columnOptionList
}
	
/**
 * \u8F6C\u5316\u6587\u4EF6\u7C7B\u578B
 * @param fileTypeString
 */
export const convertFileTypeString = (fileTypeString: string): string => {
	const parts = fileTypeString.split('/')
	if (parts.length > 0) {
		return parts.flatMap(part => part.split(',').map(type => \`.\${type}\`)).join(',')
	} else {
		return fileTypeString
			.split(',')
			.map(item => \`.\${item}\`)
			.join(',')
	}
}
	/**
 * \u5904\u7406\u8FDC\u7A0B\u641C\u7D22\u94A9\u5B50\u51FD\u6570
 * @param fieldList \u8868\u5355\u5B57\u6BB5\u5217\u8868
 * @param linkageFields \u6709\u5173\u8054\u5173\u7CFB\u7684\u5B57\u6BB5
 * @param name \u5B57\u6BB5\u540D
 * @param value \u503C
 */
export const handleRemoteSearch = async <T extends BusinessPO | BasePo>(
	fieldList: Array<FieldProps<T>>,
	linkageFields: Record<string, LinkageField>,
	name: string,
	value: string
) => {
	if (fieldList.length === 0) return
	const typeValue = fieldList.find(item => item.name === name)?.typeValue as SelectProps
	const itemField = Object.keys(linkageFields).find(item => item === name)
	if (itemField && typeValue && typeValue?.isFetching) {
		const { data } = await new PostRequestModel<Array<IColumnOption>>(linkageFields[itemField as string].selectAction, {
			itemList: [{ columnName: linkageFields[itemField].selectActionLabel, columnValue: value }]
		}).request()
		typeValue.options = data
	}
}
export interface ColumnField {
	fieldName: string
	joinTableInfoId?: string
	linkageTable?: string
	linkageTableColumn?: string
}
	/**
 * \u5904\u7406\u5173\u8054\u5B57\u6BB5\u94A9\u5B50\u51FD\u6570
 * @param referenceFields \u5F15\u7528\u5B57\u6BB5
 * @param linkageFields \u5173\u8054\u5B57\u6BB5
 * @param name \u5B57\u6BB5\u540D
 * @param options \u9009\u62E9\u9879
 * @param formState \u8868\u5355\u5B57\u6BB5
 */
export const handleLinkageFields = <T>(
	referenceFields: Array<ColumnField>,
	linkageFields: Array<ColumnField>,
	name: string,
	options: Array<OptionProps>,
	formState: UnwrapNestedRefs<Partial<T>>
) => {
	const localReference = referenceFields.filter(field => field?.fieldName === name)

	if (localReference.length > 0) {
		const localLinkage = linkageFields.filter(field => field.linkageTable === localReference[0].joinTableInfoId)
		if (localLinkage.length > 0) {
			localLinkage.flatMap(item => {
				formState[item.fieldName as keyof UnwrapNestedRefs<Partial<T>>] = options[0][item.linkageTableColumn as string]
			})
		}
	}
}
/**
 * \u5904\u7406\u9644\u4EF6\u5217\u8868\u94A9\u5B50
 * @param formState \u8868\u5355\u6570\u636E
 * @param fieldList \u5B57\u6BB5\u5217\u8868\u6570\u636E
 */
export const handleFileList = <T extends BusinessPO | BasePo>(formState: UnwrapNestedRefs<Partial<T>>, fieldList: Array<FieldProps<T>>) => {
	const uploadComponents = fieldList.filter(item => item.type === 'upload')
	if (uploadComponents.length > 0) {
		fieldList
			.filter(item => item.type === 'upload')
			.forEach(item => {
				const typeValue = item.typeValue as UploadProps
				const fieldValue = formState[\`\${item.name as string}FileList\` as keyof UnwrapNestedRefs<Partial<T>>] as LogFile[]
				if (typeValue && fieldValue && fieldValue.length > 0) {
					typeValue.fileList = []
					typeValue.fileList =
						(fieldValue
							?.filter(item => item)
							.map(item => ({
								uid: item.id,
								url: BaseUtil.getUploadPath(item.uploadPath)
							})) as UploadFile<LogFile>[]) ?? []
				}
			})
	}
}
/**
 * \u83B7\u53D6\u9ED8\u8BA4\u503C\u94A9\u5B50\u51FD\u6570
 * @param formState \u8868\u5355\u6570\u636E
 * @param tableId
 * @param id \u4E3B\u952Eid
 */
export const getDefaultValues = <T extends BusinessPO | BasePo>(formState: Record<string, any>, tableId: string, id?: string | undefined) => {
	dynamicRequest
		.getDefaultValue({
			tableId,
			id,
			recordMap: formState
		})
		.then(({ data }) => {
			data.forEach(item => {
				formState[item.columnName as string] = item.columnValue
			})
		})
}
export type PickType = 'date' | 'week' | 'month' | 'quarter' | 'year'
/**
 * \u8BBE\u7F6E\u65E5\u671F\u9009\u62E9\u5668\u7C7B\u578B\u548C\u65E5\u671F\u683C\u5F0F\u94A9\u5B50\u51FD\u6570
 * @param dateFormat \u65E5\u671F\u683C\u5F0F
 */
export const setDatePickProps = (dateFormat?: string, showTime?: boolean) => {
	let type: PickType = 'date'
	let dateFormatUpper = dateFormat?.replace(/yyyy/g, 'YYYY').replace(/dd/g, 'DD') || 'YYYY-MM-DD'
	if (showTime) dateFormatUpper = dateFormat?.replace(/yyyy/g, 'YYYY').replace(/dd/g, 'DD') || 'YYYY-MM-DD HH:mm'
	if (dateFormat) {
		const formatLowerCase = dateFormat.toLowerCase()
		if (formatLowerCase.includes('w') || formatLowerCase.includes('ww')) {
			type = 'week'
		} else if (formatLowerCase.includes('q')) {
			type = 'quarter'
		} else if (!formatLowerCase.includes('dd')) {
			type = 'month'
			if (!formatLowerCase.includes('mm')) {
				type = 'year'
			}
		}
	}
	return {
		pickType: type,
		format: dateFormatUpper,
		valueFormat: dateFormatUpper
	}
}

        `,
      linkAfter: [COMMON_CHUNK_NAME.ExternalDepsImport, COMMON_CHUNK_NAME.InternalDepsImport]
    });
    return next;
  };
  return plugin;
};
var hooks_default = pluginFactory58;

// src/plugins/project/framework/vuejs3/index.ts
var vuejs3_default = {
  template: template_default5,
  plugins: {
    packageJSON: packageJSON_default4,
    router: router_default2,
    main: main_default,
    form: form_default,
    hooks: hooks_default
  }
};

// src/solutions/vuejs3.ts
function createDcSolutionProjectBuilder() {
  return createProjectBuilder({
    template: vuejs3_default.template,
    plugins: {
      components: [],
      pages: [
        template_default4({
          nodeTypeMapping: {
            Div: "div",
            Component: "div",
            Page: "div",
            Block: "div"
          }
        }),
        vueCommonDeps_default(),
        esmodule_default2({ fileType: "vue" }),
        containerVue_default(),
        apiImport_default(),
        containerInitVariable_default(),
        dataSourceMap_default(),
        containerLifeCycle_default3(),
        containerMethod_default2()
      ],
      router: [
        vuejs3_default.plugins.router()
      ],
      utils: [],
      i18n: [],
      packageJSON: [vuejs3_default.plugins.packageJSON()],
      api: [containerInjectDataSourceEngine_default3()],
      main: [vuejs3_default.plugins.main()],
      form: [vuejs3_default.plugins.form()],
      hooks: [vuejs3_default.plugins.hooks()],
      routerModules: [routerSecond_default()]
    },
    postProcessors: [prettier_default()]
  });
}
var plugins4 = {
  template: template_default4,
  vueCommonDeps: vueCommonDeps_default,
  esmodule: esmodule_default2,
  containerVue: containerVue_default,
  apiImport: apiImport_default,
  containerInitVariable: containerInitVariable_default,
  dataSourceMap: dataSourceMap_default,
  containerLifeCycle: containerLifeCycle_default3,
  containerMethod: containerMethod_default2,
  vuejs3: vuejs3_default
};

// src/plugins/common/requireUtils.ts
var pluginFactory59 = () => {
  const plugin = async (pre) => {
    const next = {
      ...pre
    };
    next.chunks.push({
      type: "string" /* STRING */,
      fileType: "jsx" /* JSX */,
      name: COMMON_CHUNK_NAME.InternalDepsImport,
      content: "import * from 'react';",
      linkAfter: []
    });
    return next;
  };
  return plugin;
};
var requireUtils_default = pluginFactory59;

// src/utils/index.ts
var utils_exports = {};
__export(utils_exports, {
  common: () => common_exports,
  compositeType: () => compositeType_exports,
  dataSource: () => dataSource_exports,
  expressionParser: () => expressionParser_exports,
  jsExpression: () => jsExpression_exports,
  jsSlot: () => jsSlot_exports,
  nodeToJSX: () => nodeToJSX_exports,
  pathHelper: () => pathHelper_exports,
  resultHelper: () => resultHelper_exports,
  schema: () => schema_exports,
  scope: () => Scope_exports,
  templateHelper: () => templateHelper_exports,
  validate: () => validate_exports,
  version: () => version_exports
});

// src/index.ts
var src_default = {
  createProjectBuilder,
  createModuleBuilder,
  solutions: {
    icejs: createIceJsProjectBuilder,
    icejs3: createIceJsProjectBuilder2,
    rax: createRaxProjectBuilder,
    vuejs3: createDcSolutionProjectBuilder
  },
  solutionParts: {
    icejs: icejs_default,
    icejs3: icejs3_default,
    rax: rax_default,
    vuejs3: vuejs3_default
  },
  publishers: {
    disk: createDiskPublisher,
    zip: createZipPublisher
  },
  plugins: {
    common: {
      esmodule: esmodule_default,
      esModule: esmodule_default,
      requireUtils: requireUtils_default,
      styleImport: styleImport_default
    },
    style: {
      css: css_default
    },
    project: {
      constants: constants_default,
      i18n: i18n_default,
      utils: utils_default
    },
    icejs: {
      ...plugins
    },
    icejs3: {
      ...plugins2
    },
    rax: {
      ...plugins3
    },
    vuejs3: {
      ...plugins4
    },
    react: {
      ...plugins
    }
  },
  postprocessor: {
    prettier: prettier_default
  },
  utils: utils_exports,
  chunkNames: {
    COMMON_CHUNK_NAME,
    CLASS_DEFINE_CHUNK_NAME,
    REACT_CHUNK_NAME,
    TEMPLATE_DEFINE_CHUNK_NAME
  },
  defaultLinkAfter: {
    COMMON_DEFAULT_LINK_AFTER: DEFAULT_LINK_AFTER,
    VUE_DEFAULT_LINK_AFTER
  },
  constants: const_exports
};
export {
  BUILTIN_SLOT_NAMES,
  CLASS_DEFINE_CHUNK_NAME,
  COMMON_CHUNK_NAME,
  COMMON_SUB_MODULE_NAME,
  CONTAINER_TYPE,
  ChunkBuilder,
  ChunkType,
  CodeBuilder,
  CodeGeneratorError,
  CompatibilityError,
  ComponentValidationError,
  DEFAULT_LINK_AFTER,
  DependencyType,
  FILE_TYPE_FAMILY,
  FileType,
  InternalDependencyType,
  NATIVE_ELE_PKG,
  PIECE_TYPE,
  PluginType,
  ProjectBuilder,
  PublisherError,
  SUPPORT_SCHEMA_VERSION_LIST,
  SchemaParser,
  TEMPLATE_DEFINE_CHUNK_NAME,
  VUE_DEFAULT_LINK_AFTER,
  VUE_MODULE_NAME,
  componentAnalyzer,
  createModuleBuilder,
  createProjectBuilder,
  src_default as default,
  groupChunks,
  handleRouter,
  isBuiltinSlotName
};
//# sourceMappingURL=index.js.map
